subroutine dist_eul_lag( eul_indics, dis, xh_lag, yh_lag, zh_lag, grid_parameter)

use ibm_membrane

!interpolated indices in eulerian
integer :: grid_parameter(11)
integer :: tam, i
real :: dx, dy
real :: xh_lag(grid_parameter(7)), yh_lag(grid_parameter(7)), zh_lag(grid_parameter(7))
real :: distancex,distancey,distancez!(grid_parameter(7),3)
real :: dis(grid_parameter(7),3)
real :: e_x, e_y, e_z
real :: eul_x(grid_parameter(4)),eul_y(grid_parameter(5)),eul_z(grid_parameter(6))
integer :: eul_indics(grid_parameter(7),3)
  lx_cub=grid_parameter(1)
  ly_cub=grid_parameter(2)
  lz_cub=grid_parameter(3)
  nx=grid_parameter(4)        !eulerian grids
  ny=grid_parameter(5)        !eulerian grids
  nz=grid_parameter(6)        !eulerian grids
  nx_h=grid_parameter(8)        !lagrangian grids
  ny_h=grid_parameter(9)        !lagrangian grids
  nz_h=grid_parameter(10)        !lagrangian grids
  tam=grid_parameter(7)

    dx=lx_cub/(nx-1)
    dy=ly_cub/(ny-1)


    eul_x(1)=0.0d0
    eul_y(1)=0.0d0
  do i=2,nx
   eul_x(i)=eul_x(i-1)+dx
  enddo
  do j=2,ny
   eul_y(j)=eul_y(j-1)+dy
  enddo

  do k = 1, nz
   eul_z(k)=dcos(((k-1)*pi)/(nz-1))
  enddo
!   write(*,*) 'eul_indic=12000', eul_indics(120000,1)
   write(*,*) 'yh_lag', yh_lag(5)
         do i=1,tam
                 e_x=eul_x(eul_indics(i,1))
                 e_y=eul_y(eul_indics(i,2))
                 e_z=eul_z(eul_indics(i,3))
                 distancex=abs( e_x - (xh_lag(i) + lx_cub*0.5) )
                 distancey=abs( e_y - (xh_lag(i) + lx_cub*0.5) )
                 distancez=abs( e_z - (xh_lag(i) + lx_cub*0.5) )
             dis(i,1)= distancex
             dis(i,2)= distancey
             dis(i,3)= distancez
          enddo


return
end subroutine dist_eul_lag
