program helyx
implicit none
integer :: k, i, j, nx_h, ny_h, nz_h
double precision:: T, U
integer :: k_ibm, j_ibm, i_ibm
integer ::  nx,ny,nz
double precision:: xh, yh, zh, n_turns
double precision:: xmin,xmax,ymin,ymax,zmin,zmax
double precision :: deltax,deltay,deltaz
double precision :: lx_cub, ly_cub, lz_cub 
double precision :: theta_t, theta_u, p_new
double precision :: c_eli, a_eli , b_eli
double precision, allocatable, dimension(:,:,:) :: alfa_ibm
double precision, parameter :: pi=3.14159265358979


  n_turns=1.0d0        !One side of the elipsoid if 1
  theta_t=1.0d0*n_turns*pi      
  a_eli= 0.1           !thickness
  b_eli= 0.3           !radius
  c_eli= 0.0
  !hight=c_eli*theta_u=0.56
  lx_cub= 4.0d0             !Cube lengh x in units nn2-nn1
  ly_cub= 4.0d0             !Cube lengh y in units nn2-nn1
  lz_cub= 2.0d0             !Cube lengh z in units

  nx = 50                      !number of elements of box
  ny = 50                      !number of elements of box
  nz = 50                      !number of elements of box


  nx_h = 400                      !number of elements to create helix
  ny_h = 400                      !number of elements to create helix
  nz_h = 36                      !number of elements to create helix

  !Smoothing with sigmoid function

 allocate (alfa_ibm(nx, ny, nz))

  alfa_ibm=0
  !print*, alfa_ibm(1:nx,1:ny,1:nz)



      do k=1,(nz_h)
         T=(real(k)-1.0)*theta_t/nz_h
  
         do j=1,(ny_h)
           U=(real(j)-1.0)*a_eli/ny_h
                  
                    xh = b_eli*sin(T) !- a_eli*sin(T)*cos(U) !- a_eli*a_eli*cos(T)*sin(U)
                    yh = b_eli*cos(T) !- a_eli*cos(T)*cos(U) !+ a_eli*a_eli*sin(T)*sin(U)
                    zh = c_eli!+U
                   !print*, xh ,yh, zh

                     i_ibm= int((nx/lx_cub)*(xh+ lx_cub*0.5) +1)
                     j_ibm= int((ny/ly_cub)*(yh+ ly_cub*0.5) +1 )
                    
                     
                      p_new=(zh - lz_cub*0.1)*2.0d0/lz_cub
                      k_ibm=int((abs(acos(p_new))*((nz-1)/pi))+1)
                   write(*,*) i_ibm, j_ibm, k_ibm   
                   !write(*,*) mod(59,20) 
                        alfa_ibm(i_ibm,j_ibm,k_ibm)= 1!/(1+exp(-sigma_slope))
                     
     end do
   end do


   ! Write VTK File
  xmin = 0
  xmax = lx_cub
  ymin = 0
  ymax = ly_cub
  zmin=0
  zmax = lz_cub
  deltax = (xmax-xmin)/nx
  deltay = (ymax-ymin)/ny
  deltaz = (zmax-zmin)/nz

!   ! vtr file writing
  open(1,file='c_form.vtr',form = "formatted")

   write(1,'(A)') '<VTKFile type="RectilinearGrid" version="0.1" byte_order="LittleEndian">'
   write(1,*) '<RectilinearGrid WholeExtent="',1,nx,1,ny,1,nz,'">'
   write(1,*) '<Piece Extent="',1,nx,1,ny,1,nz,'">'
   write(1,'(A)') '<PointData>'
   write(1,'(A)') '<DataArray type="Float32" Name="tau_IBM" NumberOfComponents="1" format="ascii">'
   write(1,*)     alfa_ibm(1:nx,1:ny,1:nz)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '</PointData>'
   write(1,'(A)') '<CellData>'
   write(1,'(A)') '</CellData>'
   write(1,'(A)') '<Coordinates>'
   write(1,'(A)') '<DataArray type="Float32" Name="X_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (xmin+(i-0.5)*deltax,i=1,nx)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '<DataArray type="Float32" Name="Y_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (ymin+(i-0.5)*deltay,i=1,ny)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '<DataArray type="Float32" Name="Z_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (cos(((i-1)*3.14159265358979)/(nz-1)),i=1,nz)!(zmin+(i-0.5)*deltaz,i=1,nz)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '</Coordinates>'
   write(1,'(A)') '</Piece>'
   write(1,'(A)') '</RectilinearGrid>'
   write(1,'(A)') '</VTKFile> '
  close(1)

 deallocate (alfa_ibm)


end program helyx
