program helyx
implicit none
integer :: k, i, j, nx_h, ny_h, nz_h
double precision :: a, R , h
double precision:: T, U
integer :: k_ibm, j_ibm, i_ibm
integer ::  nx,ny,nz
double precision:: xh, yh, zh, n_turns
double precision:: xmin,xmax,ymin,ymax,zmin,zmax
double precision :: deltax,deltay,deltaz
double precision :: lx_cub, ly_cub, lz_cub 
double precision :: smoothslope, smooth_portion
double precision :: theta_t, theta_u, thick_a, p_new
double precision :: ntot
double precision, allocatable, dimension(:,:,:) :: alfa_ibm
double precision, parameter :: pi=3.14159265358979


  n_turns=2
  R=2.0d0                   !Helix main radious
  theta_t=n_turns*pi      !Helix Azimuth
  h=0.5/theta_t                !Helix pitch
  theta_u=3.5*pi      !number of local rounds over theta_t (2*3.1416 = 1 revolution)
  thick_a= 0.003          !helix thickness


  lx_cub= 4.0d0             !Cube lengh x in units nn2-nn1
  ly_cub= 4.0d0             !Cube lengh y in units nn2-nn1
  lz_cub= 2.0d0      !Cube lengh z in units

  nx = 100!int(lx_cub/stpx)     !number of elements of box
  ny = 100!int(ly_cub/stpy)     !number of elements of box
  nz = 200!int(theta_t/stpz)     !number of elements of box


  nx_h = 200!int(lx_cub/stpx)     !number of elements to create helix
  ny_h = 200!int(ly_cub/stpy)     !number of elements to create helix
  nz_h = 600!int(theta_t/stpz)     !number of elements to create helix

  !Smoothing with sigmoid function
  smooth_portion= 0.5           ! 20/100 portion to be smoothed
  smoothslope=4.5                 !how fast the curve decrease see sigmoid_func.m
  ntot= 100.00
 allocate (alfa_ibm(nx, ny, nz))

  alfa_ibm=0
  !print*, alfa_ibm(1:nx,1:ny,1:nz)



      do k=1,(nz_h)
         T=(real(k)-1.0)*theta_t/nz_h
  !print*, T
         do j=1,(ny_h)
           U=(real(j)-1)*theta_u/ny_h

             !do i=1,(nx_h+1)
               a=thick_a!(real(i)-1.0)*thick_a/nx_h
  !print*, a

                    !xh= R*sin(T) - a*sin(T)*cos(U) - a*h*cos(T)*sin(U)
                    !yh= R*cos(T) - a*cos(T)*cos(U) + a*h*sin(T)*sin(U)
                    !zh = h*T+a*R*sin(U)/(sqrt((R*R)+(h*h)))
                     xh= 0.1*exp(a*U)*cos(U) + 0.5*exp(a*U)*cos(T)*cos(U)   ! the second term controls the diameter
                     yh= 0.5*exp(a*U)*sin(U) + 0.1*exp(a*U)*cos(T)*sin(U)   ! the second term controls the diameter
                     zh = 0.025*exp(0.3*U)*sin(T)


                    !print*, xh ,yh, zh

                     i_ibm= int((nx/lx_cub)*(xh+ lx_cub*0.5) +1)
                     j_ibm= int((ny/ly_cub)*(yh+ ly_cub*0.5)+1 )
                    
                     
                      p_new=(zh - lz_cub*0.1)*2.0d0/lz_cub
                      k_ibm=int((abs(acos(p_new))*((nz-1)/pi))+1)
                   write(*,*) i_ibm, j_ibm, k_ibm   
                        alfa_ibm(i_ibm,j_ibm,k_ibm)= 1!/(1+exp(-sigma_slope))
                     
     end do
   end do


   ! Write VTK File
  xmin = 0
  xmax = lx_cub
  ymin = 0
  ymax = ly_cub
  zmin=0
  zmax = lz_cub
  deltax = (xmax-xmin)/nx
  deltay = (ymax-ymin)/ny
  deltaz = (zmax-zmin)/nz

!   ! vtr file writing
  open(1,file='cornucopia.vtr',form = "formatted")

   write(1,'(A)') '<VTKFile type="RectilinearGrid" version="0.1" byte_order="LittleEndian">'
   write(1,*) '<RectilinearGrid WholeExtent="',1,nx,1,ny,1,nz,'">'
   write(1,*) '<Piece Extent="',1,nx,1,ny,1,nz,'">'
   write(1,'(A)') '<PointData>'
   write(1,'(A)') '<DataArray type="Float32" Name="tau_IBM" NumberOfComponents="1" format="ascii">'
   write(1,*)     alfa_ibm(1:nx,1:ny,1:nz)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '</PointData>'
   write(1,'(A)') '<CellData>'
   write(1,'(A)') '</CellData>'
   write(1,'(A)') '<Coordinates>'
   write(1,'(A)') '<DataArray type="Float32" Name="X_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (xmin+(i-0.5)*deltax,i=1,nx)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '<DataArray type="Float32" Name="Y_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (ymin+(i-0.5)*deltay,i=1,ny)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '<DataArray type="Float32" Name="Z_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (cos(((i-1)*3.14159265358979)/(nz-1)),i=1,nz)!(zmin+(i-0.5)*deltaz,i=1,nz)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '</Coordinates>'
   write(1,'(A)') '</Piece>'
   write(1,'(A)') '</RectilinearGrid>'
   write(1,'(A)') '</VTKFile> '
  close(1)

 deallocate (alfa_ibm)


end program helyx
