program helyx
implicit none
integer :: k, i, j, nx_h, ny_h, nz_h
real :: a, R , h
real :: T, U
integer :: k_ibm, j_ibm, i_ibm
integer ::  nx,ny,nz,n_turns
real:: xh, yh, zh
real(kind=8) :: TT1_0, UU_0, a_h_0, xh_0, yh_0, zh_0
real(kind=8) :: xh_01, yh_01, zh_01,i_ibm_01,j_ibm_01,k_ibm_01 
real(kind=8) :: rest_length_1, rest_length_2
real :: xmin,xmax,ymin,ymax,zmin,zmax
real :: deltax,deltay,deltaz
real :: lx_cub, ly_cub, lz_cub, smoothslope, smooth_portion, sigma_slope, sigma_slope_n
real(kind=8) :: i_ibm_0,j_ibm_0,k_ibm_0, spring_k
real :: theta_t, theta_u, thick_a, p_new
real :: ni, ntot, p_new_0,p_new_01
integer :: counter, ich
real, allocatable, dimension(:,:,:) :: alfa_ibm
real, allocatable, dimension(:,:) :: spring_master, spring_s1,spring_s2,spring_car
real, allocatable, dimension(:,:,:) :: fx,fy,fz
real, allocatable, dimension(:) :: xh_lag, yh_lag, zh_lag
integer, allocatable, dimension (:,:) :: int_eul_indics                 
real(kind=8) :: f_m2s2_x,f_m2s2_y,f_m2s2_z,f_m2s1_x,f_m2s1_y,f_m2s1_z 
real, allocatable, dimension(:,:)  :: dist_ela
double precision, parameter :: pi=3.14159265358979
!Grids
integer :: grid_param(11)

  n_turns=4
  R=0.2                   !Helix main radious
  theta_t=n_turns*2*3.1416      !Helix Azimuth
  h=0.5/theta_t                !Helix pitch
  theta_u=2*3.1416      !number of local rounds over theta_t (2*3.1416 = 1 revolution)
  thick_a= 0.04          !helix thickness


  lx_cub= 2             !Cube lengh x in units nn2-nn1
  ly_cub= 4             !Cube lengh y in units nn2-nn1
  lz_cub= 2      !Cube lengh z in units

  nx = 100!int(lx_cub/stpx)     !number of elements of box
  ny = 100!int(ly_cub/stpy)     !number of elements of box
  nz = 200!int(theta_t/stpz)     !number of elements of box


  nx_h = 200!int(lx_cub/stpx)     !number of elements to create helix
  ny_h = 200!int(ly_cub/stpy)     !number of elements to create helix
  nz_h = 600!int(theta_t/stpz)     !number of elements to create helix
  
  grid_param(1)=lx_cub
  grid_param(2)=ly_cub
  grid_param(3)=lz_cub
  grid_param(4)=nx        !eulerian grids
  grid_param(5)=ny        !eulerian grids
  grid_param(6)=nz        !eulerian grids
  grid_param(8)=nx_h        !lagrangian grids
  grid_param(9)=ny_h        !lagrangian grids
  grid_param(10)=nz_h        !lagrangian grids
  grid_param(7)=grid_param(9)*grid_param(10)
  
  
  !Smoothing with sigmoid function
  smooth_portion= 0.5           ! 20/100 portion to be smoothed
  smoothslope=4.5                 !how fast the curve decrease see sigmoid_func.m
  ntot= 100.00
   
 allocate (alfa_ibm(nx, ny, nz))
 allocate(spring_master(nx*ny*nz,3))
 allocate(spring_s1(nx*ny*nz,3))
 allocate(spring_s2(nx*ny*nz,3))
 allocate(spring_car(nx*ny*nz,3)) 
 allocate(fx(nx,ny,nz))
 allocate(fy(nx,ny,nz))
 allocate(fz(nx,ny,nz))
 allocate (xh_lag(grid_param(7)))
 allocate (yh_lag(grid_param(7)))
 allocate (zh_lag(grid_param(7)))
 allocate(int_eul_indics(grid_param(7),3))
 allocate(dist_ela(grid_param(7),3))           
  alfa_ibm=0
  ich=0
  spring_k=2.5e4
  counter=0
  

      do k=1,(nz_h+1)
         T=(real(k)-1.0)*theta_t/nz_h
         TT1_0=(real(k)-2.0)*theta_t/(nz_h)
  
         do j=1,(ny_h+1)
           U=(real(j)-1)*theta_u/ny_h
           UU_0=(real(j)-2.0)*theta_u/(ny_h)
           
             !do i=1,(nx_h+1)
               a=thick_a!(real(i)-1.0)*thick_a/nx_h
               !a_h_0=(real(i)-1.0)*thick_a/(nx_h)
                ich=ich+1
                    xh= R*sin(T) - a*sin(T)*cos(U) - a*h*cos(T)*sin(U)
                    xh_lag(ich)= xh
                
                    yh= R*cos(T) - a*cos(T)*cos(U) + a*h*sin(T)*sin(U)
                    yh_lag(ich)= yh
                    zh = h*T+a*R*sin(U)/(sqrt((R*R)+(h*h)))
                    zh_lag(ich)= zh

                     i_ibm= int((nx/lx_cub)*(xh+ lx_cub*0.5) +1)
                     j_ibm= int((ny/ly_cub)*(yh+ ly_cub*0.5)+1 )
                    
                      p_new=(zh - lz_cub*0.2)*2.0d0/lz_cub
                      k_ibm=int((abs(acos(p_new))*((nz-1)/pi))+1)
                     !p_new=nz*(zh- lz_cub*0.2)/lz_cub
                     !k_ibm=int(p_new)  
                    ! if (a.LE.(2.0*thick_a)) then  
                    !    ni=ntot*a/(2.0*thick_a)  !with this we declare a smoothing thickness and also we improve the smoothing
                    !    sigma_slope = (smoothslope - ni*2.0*smoothslope/ntot)                               !(a-(1.0-smooth_portion)+smoothslope)-(2*smoothslope*(thick_a)/(nx*smooth_portion))
                    !    alfa_ibm(i_ibm,j_ibm,k_ibm)= 1/(1+exp(-sigma_slope))
                    !end if
                          alfa_ibm(i_ibm,j_ibm,k_ibm)= 1
                     
                  if ((k.ge.2).and.(j.ge.2)) then
                     
                     ! Geting the points 'slave 1' in azimuth T
                     xh_0 = R*sin(TT1_0) - a*sin(TT1_0)*cos(U) - a*h*cos(TT1_0)*sin(U)
                     yh_0 = R*cos(TT1_0) - a*cos(TT1_0)*cos(U) + a*h*sin(TT1_0)*sin(U)
                     zh_0 = h*(TT1_0)+a*R*sin(U)/(sqrt((R*R)+(h*h)))
                     i_ibm_0= int((nx/lx_cub)*(xh_0+ lx_cub*0.5) +1)
                     j_ibm_0= int((ny/ly_cub)*(yh_0+ ly_cub*0.5)+1 )
                    
                     p_new_0=nz*(zh_0+ lz_cub*0.2)/lz_cub
                     k_ibm_0=int(p_new_0)  
                      


                     ! Geting the points 'slave 2' in radia U
                     xh_01 = R*sin(T) - a*sin(T)*cos(UU_0) - a*h*cos(T)*sin(UU_0)
                     yh_01 = R*cos(T) - a*cos(T)*cos(UU_0) + a*h*sin(T)*sin(UU_0)
                     zh_01 = h*(T)+a*R*sin(UU_0)/(sqrt((R*R)+(h*h)))
                     i_ibm_01= int((nx/lx_cub)*(xh_01+ lx_cub*0.5) +1)
                     j_ibm_01= int((ny/ly_cub)*(yh_01+ ly_cub*0.5)+1 )
                    
                     p_new_01=nz*(zh_01+ lz_cub*0.2)/lz_cub
                     k_ibm_01=int(p_new_01)  
                     rest_length_1=0!sqrt((xh-xh_0)**2 + (yh-yh_0)**2 + (zh-zh_0)**2)
                     rest_length_2=0!sqrt((xh-xh_01)**2 + (yh-yh_01)**2 + (zh-zh_01)**2)
                    counter=counter+1
                    
                    !spring_master(counter, :)= [i_ibm, j_ibm, k_ibm]
                    !spring_s1(counter, :) = [i_ibm_0,j_ibm_0,k_ibm_0]
                    !spring_s2(counter, :) = [i_ibm_01,j_ibm_01,k_ibm_01]
                    !spring_car(counter, :) = [spring_k,rest_length_1,rest_length_2 ]
                    !!----------From baptista 2007-----------------------------------------------------------------
                   
                   !Compiling the forces M to S1
                     
                    f_m2s1_x=spring_k*(1- (rest_length_1/sqrt((xh-xh_0)**2 + (yh-yh_0)**2 + (zh-zh_0)**2)))*(-xh+xh_0)
                    f_m2s1_y=spring_k*(1- (rest_length_1/sqrt((xh-xh_0)**2 + (yh-yh_0)**2 + (zh-zh_0)**2)))*(-yh+yh_0)
                    f_m2s1_z=spring_k*(1- (rest_length_1/sqrt((xh-xh_0)**2 + (yh-yh_0)**2 + (zh-zh_0)**2)))*(-zh+zh_0)
                  
                    fx(i_ibm, j_ibm, k_ibm)=fx(i_ibm, j_ibm, k_ibm) + f_m2s1_x
                    fy(i_ibm, j_ibm, k_ibm)=fy(i_ibm, j_ibm, k_ibm) + f_m2s1_y
                    fz(i_ibm, j_ibm, k_ibm)=fz(i_ibm, j_ibm, k_ibm) + f_m2s1_z
                    
                    fx(i_ibm_0,j_ibm_0,k_ibm_0)=fx(i_ibm_0,j_ibm_0,k_ibm_0) - f_m2s1_x
                    fy(i_ibm_0,j_ibm_0,k_ibm_0)=fy(i_ibm_0,j_ibm_0,k_ibm_0) - f_m2s1_y
                    fz(i_ibm_0,j_ibm_0,k_ibm_0)=fz(i_ibm_0,j_ibm_0,k_ibm_0) - f_m2s1_z
                                      
                    
                   !Compiling the forces M to S2
                    
                    f_m2s2_x=spring_k*(1- (rest_length_2/sqrt((xh-xh_01)**2 + (yh-yh_01)**2 + (zh-zh_01)**2)))*(-xh+xh_01)
                    f_m2s2_y=spring_k*(1- (rest_length_2/sqrt((xh-xh_01)**2 + (yh-yh_01)**2 + (zh-zh_01)**2)))*(-yh+yh_01)
                    f_m2s2_z=spring_k*(1- (rest_length_2/sqrt((xh-xh_01)**2 + (yh-yh_01)**2 + (zh-zh_01)**2)))*(-zh+zh_01)
                    
                    !Ftot_mts2(counter, :)= [f_m2s2_x,f_m2s2_y,f_m2s2_z]
                  
                    fx(i_ibm, j_ibm, k_ibm)=fx(i_ibm, j_ibm, k_ibm) + f_m2s2_x
                    fy(i_ibm, j_ibm, k_ibm)=fy(i_ibm, j_ibm, k_ibm) + f_m2s2_y
                    fz(i_ibm, j_ibm, k_ibm)=fz(i_ibm, j_ibm, k_ibm) + f_m2s2_z
                    
                    fx(i_ibm_01,j_ibm_01,k_ibm_01)=fx(i_ibm_01,j_ibm_01,k_ibm_01) - f_m2s1_x
                    fy(i_ibm_01,j_ibm_01,k_ibm_01)=fy(i_ibm_01,j_ibm_01,k_ibm_01) - f_m2s1_y
                    fz(i_ibm_01,j_ibm_01,k_ibm_01)=fz(i_ibm_01,j_ibm_01,k_ibm_01) - f_m2s1_z
                                      
                  
                  
                  endif

        !end do
     end do
   end do

  call delta_indices(xh_lag, yh_lag, zh_lag, grid_param,int_eul_indics)
  !write(*,*) 'helix', int_eul_indics(120000,1)
  call dist_eul_lag(int_eul_indics, dist_ela, xh_lag, yh_lag, zh_lag, grid_param ) 
  write(*,*) 'distancia', dist_ela(120000,1)
  
                       !open(996,file='./spring.txt')
                       !  write(996,*) spring_master, spring_s1, spring_s2, spring_car
                       !close(996)
deallocate (spring_master)
deallocate (spring_s1)
deallocate (spring_s2)
deallocate (spring_car)


   ! Write VTK File
  xmin = 0
  xmax = lx_cub
  ymin = 0
  ymax = ly_cub
  zmin=0
  zmax = lz_cub
  deltax = (xmax-xmin)/nx
  deltay = (ymax-ymin)/ny
  deltaz = (zmax-zmin)/nz

!   ! vtr file writing
  open(1,file='lagrangian_point.vtr',form = "formatted")

   write(1,'(A)') '<VTKFile type="RectilinearGrid" version="0.1" byte_order="LittleEndian">'
   write(1,*) '<RectilinearGrid WholeExtent="',1,nx,1,ny,1,nz,'">'
   write(1,*) '<Piece Extent="',1,nx,1,ny,1,nz,'">'
   write(1,'(A)') '<PointData>'
   write(1,'(A)') '<DataArray type="Float32" Name="tau_IBM" NumberOfComponents="1" format="ascii">'
   write(1,*)     alfa_ibm(1:nx,1:ny,1:nz)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '</PointData>'
   write(1,'(A)') '<CellData>'
   write(1,'(A)') '</CellData>'
   write(1,'(A)') '<Coordinates>'
   write(1,'(A)') '<DataArray type="Float32" Name="X_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (xmin+(i-0.5)*deltax,i=1,nx)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '<DataArray type="Float32" Name="Y_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (ymin+(i-0.5)*deltay,i=1,ny)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '<DataArray type="Float32" Name="Z_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(1,*)     (cos(((i-1)*3.14159265358979)/(nz-1)),i=1,nz)!(zmin+(i-0.5)*deltaz,i=1,nz)
   write(1,'(A)') '</DataArray>'
   write(1,'(A)') '</Coordinates>'
   write(1,'(A)') '</Piece>'
   write(1,'(A)') '</RectilinearGrid>'
   write(1,'(A)') '</VTKFile> '

  close(1)

 deallocate (alfa_ibm)
deallocate (fx)
deallocate (fy)
deallocate (fz)
 deallocate (xh_lag)
 deallocate (yh_lag)
 deallocate (zh_lag)
 deallocate(int_eul_indics)
 deallocate(dist_ela)      


end program helyx
