subroutine find_lag_forces_in_eul(xL_P, yL_P, zL_P,eul_indics, &
frz_ib,frz_mass, rest_length, ang_bend, lenteja, rest_inv_beam, dtempo, f_hyd)
use commondata
use par_size !paralelisation chunks
use grid
use sim_par  !pi, simulation parameters
use ibm_membrane
#define masspoint_flag masspointflag
#define beam_flag beamflag
#define spring_flag springflag
#define non_invariant_flag noninvariantflag
integer          :: i,j,k,l
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
integer :: eul_indics(nz_h,3)
double precision :: xL_P(nz_h), yL_P(nz_h), zL_P(nz_h)
double precision :: fx(nx,nz,ny), fy(nx,nz,ny), fz(nx,nz,ny)
double precision :: f_m2s1_x, f_m2s1_y, f_m2s1_z, f_m2s2_x, f_m2s2_y, f_m2s2_z
double precision :: spring_k, ds
double precision :: diste_l(nz_h,3,2*n_supp+1)
double precision :: delta_k(nz_h,3,2*n_supp+1),rez_esf(2*n_supp+1)
double precision :: frz_ib(nx,nz,ny,3)
double precision :: dys2s1, dxs2s1, dzs2s1

double precision :: crossxs2s1, crossys2s1, crosszs2s1
double precision :: lenteja(nz_h)
double precision :: f_m2s1_x_cross, f_m2s1_y_cross, f_m2s1_z_cross
!dumped springs

double precision :: dV_xs2s1, dV_ys2s1, dV_zs2s1, b_d_spring, k_d_spring,dtempo
double precision :: frz_mass(nx,nz,ny,3)
double precision :: del_kern_force(nx,nz,ny,2*n_supp+1)
double precision :: rest_length(nz_h)
!beam method
double precision :: c_res_x,c_res_y,c_res_z,k_bend
double precision :: x_lef,x_med,x_rig, y_lef, y_med, &
y_rig, z_lef, z_med, z_rig
double precision :: cross_p_z, cross_p_y, cross_p_x
double precision :: f_left_x, f_left_y, f_left_z
double precision :: f_right_x, f_right_y, f_right_z
double precision :: f_med_x, f_med_y, f_med_z
double precision :: ang_bend(nz_h,3)
double precision :: rest_inv_beam(nz_h,3)
double precision :: f_hyd(3)
!-------------------------From baptista 2007---------------------------------------
frz_ib=0.0d0
spring_k=2.5e+5 !Dimensionless k-=k/(rho*U_tau^2*h)
ds=lz_cub/64!nz_h
!rest_length=0.0d0!ds
call delta_indices(xL_P, yL_P, zL_P, eul_indics, diste_l)
!call delta_kernel(diste_l, eul_indics,delta_k, rez_esf)

fx=0.0d0
fy=0.0d0
fz=0.0d0
!ang_bend=0.0d0
do i=1,nz_h

#if spring_flag == 1
  !------------------- y distances periodicity-------------------------------------------------------
  !Distance M to S1
  dys2s1=0.0d0
  !%%%%%%%%%%%%%%%%%%
  if(i.ge.2)then
  !%%%%%%%%%%%%%%%%%%
  if(((yL_P(i)+ly_cub*0.5).gt.0).and.((yL_P(i)+ly_cub*0.5).lt.ly_cub*0.5)&
  .and.((yL_P(i-1)+ly_cub*0.5).gt.0).and.((yL_P(i-1)+ly_cub*0.5).lt.ly_cub*0.5))then
    dys2s1=yL_P(i-1)-yL_P(i)
  elseif(((yL_P(i)+ly_cub*0.5).gt.ly_cub*0.5).and.((yL_P(i)+ly_cub*0.5).le.ly_cub)&
  .and.((yL_P(i-1)+ly_cub*0.5).gt.ly_cub*0.5).and.((yL_P(i-1)+ly_cub*0.5).le.ly_cub))then
    dys2s1=yL_P(i-1)-yL_P(i)
  elseif(((yL_P(i)+ly_cub*0.5).ge.ly_cub/4).and.((yL_P(i)+ly_cub*0.5).le.3*ly_cub/4)&
  .and.((yL_P(i-1)+ly_cub*0.5).ge.ly_cub/4).and.((yL_P(i-1)+ly_cub*0.5).le.3*ly_cub/4))then
    dys2s1=yL_P(i-1)-yL_P(i)
  elseif(((yL_P(i)+ly_cub*0.5).gt.0).and.((yL_P(i)+ly_cub*0.5).lt.ly_cub/4)&
  .and.((yL_P(i-1)+ly_cub*0.5).gt.3*ly_cub/4).and.((yL_P(i-1)+ly_cub*0.5).le.ly_cub))then
    dys2s1=yL_P(i-1)-(yL_P(i)+ly_cub)
  elseif(((yL_P(i-1)+ly_cub*0.5).gt.0).and.((yL_P(i-1)+ly_cub*0.5).lt.ly_cub/4)&
  .and.((yL_P(i)+ly_cub*0.5).gt.3*ly_cub/4).and.((yL_P(i)+ly_cub*0.5).le.ly_cub))then
    dys2s1=yL_P(i-1)-(yL_P(i)-ly_cub)
  endif

  !------------------- x distances  periodicity-------------------------------------------------------
  !Distance M to S1
  dxs2s1=0.0d0
  if(((xL_P(i)+lx_cub*0.5).gt.0).and.((xL_P(i)+lx_cub*0.5).lt.lx_cub*0.5)&
  .and.((xL_P(i-1)+lx_cub*0.5).gt.0).and.((xL_P(i-1)+lx_cub*0.5).lt.lx_cub*0.5))then
    dxs2s1=xL_P(i-1)-xL_P(i)
  elseif(((xL_P(i)+lx_cub*0.5).gt.lx_cub*0.5).and.((xL_P(i)+lx_cub*0.5).le.lx_cub)&
  .and.((xL_P(i-1)+lx_cub*0.5).gt.lx_cub*0.5).and.((xL_P(i-1)+lx_cub*0.5).le.lx_cub))then
    dxs2s1=xL_P(i-1)-xL_P(i)
  elseif(((xL_P(i)+lx_cub*0.5).ge.lx_cub/4).and.((xL_P(i)+lx_cub*0.5).le.3*lx_cub/4)&
  .and.((xL_P(i-1)+lx_cub*0.5).ge.lx_cub/4).and.((xL_P(i-1)+lx_cub*0.5).le.3*lx_cub/4))then
    dxs2s1=xL_P(i-1)-xL_P(i)
  elseif(((xL_P(i)+lx_cub*0.5).gt.0).and.((xL_P(i)+lx_cub*0.5).lt.lx_cub/4)&
  .and.((xL_P(i-1)+lx_cub*0.5).gt.3*lx_cub/4).and.((xL_P(i-1)+lx_cub*0.5).le.lx_cub))then
    dxs2s1=xL_P(i-1)-(xL_P(i)+lx_cub)
  elseif(((xL_P(i-1)+lx_cub*0.5).gt.0).and.((xL_P(i-1)+lx_cub*0.5).lt.lx_cub/4)&
  .and.((xL_P(i)+lx_cub*0.5).gt.3*lx_cub/4).and.((xL_P(i)+lx_cub*0.5).le.lx_cub))then
    dxs2s1=xL_P(i-1)-(xL_P(i)-lx_cub)
  endif

  !%%%%%%%%%%%%%%%%%%%%
  dzs2s1=zL_P(i-1)-zL_P(i)
  elseif(i.eq.1)then
  dxs2s1=xL_P(nz_h)-xL_P(i)
  dys2s1=yL_P(nz_h)-yL_P(i)
  dzs2s1=zL_P(nz_h)-zL_P(i)
  endif
  !%%%%%%%%%%%%%%%%%%%%
  !---------------------------------------------------------------------------------------
   !Compiling the forces M to S1
   if ((((dxs2s1)**2 + (dys2s1)**2 &
   + (dzs2s1)**2)).eq.0) then

   f_m2s1_x=0.0d0
   f_m2s1_y=0.0d0
   f_m2s1_z=0.0d0
   else

     f_m2s1_x=spring_k*(1- (rest_length(i)/sqrt((dxs2s1)**2 + &
     (dys2s1)**2 + (dzs2s1)**2)))*(-dxs2s1)

     f_m2s1_y=spring_k*(1- (rest_length(i)/sqrt((dxs2s1)**2 + &
     (dys2s1)**2 + (dzs2s1)**2)))*(-dys2s1)

     f_m2s1_z=spring_k*(1- (rest_length(i)/sqrt((dxs2s1)**2 + &
     (dys2s1)**2 + (dzs2s1)**2)))*(-dzs2s1)
    endif
    if (i.ge.2)then
            fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
            fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_x

            fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
            fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_y

            fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
            fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_z


            fx(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2))= &
            fx(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2)) + f_m2s1_x

            fy(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2))= &
            fy(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2)) + f_m2s1_y

            fz(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2))= &
            fz(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2)) + f_m2s1_z
elseif(i.eq.1) then
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_x

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_y

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_z


  fx(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2))= &
  fx(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2)) + f_m2s1_x

  fy(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2))= &
  fy(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2)) + f_m2s1_y

  fz(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2))= &
  fz(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2)) + f_m2s1_z

endif
#endif

!Front neightbour comunication
#if spring_flag == 1
if ((i+nz_h/2).gt.nz_h) then


crossxs2s1=(xL_P(i)-xL_P(i+nz_h/2-nz_h))
crossys2s1=(yL_P(i)-yL_P(i+nz_h/2-nz_h))
crosszs2s1=(zL_P(i)-zL_P(i+nz_h/2-nz_h))

else

crossxs2s1=(xL_P(i)-xL_P(i+nz_h/2))
crossys2s1=(yL_P(i)-yL_P(i+nz_h/2))
crosszs2s1=(zL_P(i)-zL_P(i+nz_h/2))

endif
!write(*,*) 'crossxs2s1,crossys2s1,crosszs2s1',&
!sqrt(lenteja(i,2)**2+lenteja(i,3)**2),lenteja(i,2),lenteja(i,3)


f_m2s1_x_cross=spring_k*(1- (lenteja(i)/sqrt((crossxs2s1)**2 + &
(crossys2s1)**2 + (crosszs2s1)**2)))*(-crossxs2s1)

f_m2s1_y_cross=spring_k*(1- (lenteja(i)/sqrt((crossxs2s1)**2 + &
(crossys2s1)**2 + (crosszs2s1)**2)))*(-crossys2s1)

f_m2s1_z_cross=spring_k*(1- (lenteja(i)/sqrt((crossxs2s1)**2 + &
(crossys2s1)**2 + (crosszs2s1)**2)))*(-crosszs2s1)

if ((i+nz_h/2).gt.nz_h) then
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_x_cross

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_y_cross

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_z_cross


  fx(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2))= &
  fx(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2)) - f_m2s1_x_cross

  fy(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2))= &
  fy(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2)) - f_m2s1_y_cross

  fz(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2))= &
  fz(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2)) - f_m2s1_z_cross




else

  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_x_cross

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_y_cross

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_z_cross


  fx(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2))= &
  fx(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2)) - f_m2s1_x_cross

  fy(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2))= &
  fy(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2)) - f_m2s1_y_cross

  fz(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2))= &
  fz(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2)) - f_m2s1_z_cross


endif

#endif

!#############################Testing dumped springs#################################



#if spring_flag == 3
k_d_spring=2.5e+5
b_d_spring=0.50d0 !vary form 0.5 to 50.0d0
if(i.ge.2)then
!%%%%%%%%%%%%%%%%%%
!------------------- y distances periodicity-------------------------------------------------------
  !Distance M to S1
  dys2s1=0.0d0
  dys2s1=yL_P(i-1)-yL_P(i)
!velocity*dt=distance :)
 dV_ys2s1=yL_P(i-1)-yL_P(i)

!------------------- x distances  periodicity-------------------------------------------------------
!Distance M to S1
  dxs2s1=0.0d0
  dxs2s1=xL_P(i-1)-xL_P(i)
!velocity*dt=distance :)
 dV_xs2s1=xL_P(i-1)-xL_P(i)

!Distance in z
  dzs2s1=0.0d0
  dzs2s1=zL_P(i-1)-zL_P(i)
!velocity*dt=distance :)
 dV_zs2s1=zL_P(i-1)-zL_P(i)

!checking peridoicity

  if(abs(dys2s1).gt.(ly_cub/2))then
   dys2s1=sign(1.0d0,dys2s1)*(ly_cub-sign(1.0d0,dys2s1)*dys2s1)
  endif
  if(abs(dxs2s1).gt.(lx_cub/2))then
   dxs2s1=sign(1.0d0,dxs2s1)*(lx_cub-sign(1.0d0,dxs2s1)*dxs2s1)
  endif


  if(abs(dV_ys2s1).gt.(ly_cub/2))then
   dV_ys2s1=sign(1.0d0,dV_ys2s1)*(ly_cub-sign(1.0d0,dV_ys2s1)*dV_ys2s1)
  endif
  if(abs(dV_xs2s1).gt.(lx_cub/2))then
   dV_xs2s1=sign(1.0d0,dV_xs2s1)*(lx_cub-sign(1.0d0,dV_xs2s1)*dV_xs2s1)
  endif

elseif(i.eq.1)then
  dxs2s1=xL_P(nz_h)-xL_P(i)
  dys2s1=yL_P(nz_h)-yL_P(i)
  dzs2s1=zL_P(nz_h)-zL_P(i)
!velocity*dt=distance :)
  dV_ys2s1=yL_P(nz_h)-yL_P(i)
  dV_xs2s1=xL_P(nz_h)-xL_P(i)
  dV_zs2s1=zL_P(nz_h)-zL_P(i)

  !checking peridoicity

    if(abs(dys2s1).gt.(ly_cub/2))then
     dys2s1=sign(1.0d0,dys2s1)*(ly_cub-sign(1.0d0,dys2s1)*dys2s1)
    endif
    if(abs(dxs2s1).gt.(lx_cub/2))then
     dxs2s1=sign(1.0d0,dxs2s1)*(lx_cub-sign(1.0d0,dxs2s1)*dxs2s1)
    endif

    if(abs(dV_ys2s1).gt.(ly_cub/2))then
     dV_ys2s1=sign(1.0d0,dV_ys2s1)*(ly_cub-sign(1.0d0,dV_ys2s1)*dV_ys2s1)
    endif
    if(abs(dV_xs2s1).gt.(lx_cub/2))then
     dV_xs2s1=sign(1.0d0,dV_xs2s1)*(lx_cub-sign(1.0d0,dV_xs2s1)*dV_xs2s1)
    endif

endif
  !%%%%%%%%%%%%%%%%%%%%
dV_ys2s1=dV_ys2s1/dtempo
dV_xs2s1=dV_xs2s1/dtempo
dV_zs2s1=dV_zs2s1/dtempo
  !---------------------------------------------------------------------------------------
   !Compiling the forces M to S1
if ((((dxs2s1)**2 + (dys2s1)**2 &
   + (dzs2s1)**2)).eq.0) then

   f_m2s1_x=0.0d0
   f_m2s1_y=0.0d0
   f_m2s1_z=0.0d0
else

     f_m2s1_x=k_d_spring*((sqrt((dxs2s1)**2 +(dys2s1)**2 + (dzs2s1)**2)) - (rest_length(i))) &
     *(-dxs2s1/sqrt((dxs2s1)**2 +(dys2s1)**2 + (dzs2s1)**2)) - b_d_spring*dV_xs2s1

     f_m2s1_y=k_d_spring*((sqrt((dxs2s1)**2 +(dys2s1)**2 + (dzs2s1)**2)) - (rest_length(i))) &
     *(-dys2s1/sqrt((dxs2s1)**2 +(dys2s1)**2 + (dzs2s1)**2)) - b_d_spring*dV_ys2s1

     f_m2s1_z=k_d_spring*((sqrt((dxs2s1)**2 +(dys2s1)**2 + (dzs2s1)**2)) - (rest_length(i))) &
     *(-dzs2s1/sqrt((dxs2s1)**2 +(dys2s1)**2 + (dzs2s1)**2)) - b_d_spring*dV_zs2s1
endif

if (i.ge.2)then
            fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
            fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_x

            fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
            fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_y

            fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
            fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_z


            fx(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2))= &
            fx(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2)) + f_m2s1_x

            fy(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2))= &
            fy(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2)) + f_m2s1_y

            fz(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2))= &
            fz(eul_indics(i-1,1), eul_indics(i-1,3), eul_indics(i-1,2)) + f_m2s1_z
elseif(i.eq.1) then
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_x

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_y

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) - f_m2s1_z


  fx(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2))= &
  fx(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2)) + f_m2s1_x

  fy(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2))= &
  fy(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2)) + f_m2s1_y

  fz(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2))= &
  fz(eul_indics(nz_h,1), eul_indics(nz_h,3), eul_indics(nz_h,2)) + f_m2s1_z

endif
#endif



!Front neightbour comunication dumped springs
#if spring_flag == 3
if ((i+nz_h/2).gt.nz_h) then


crossxs2s1=(xL_P(i)-xL_P(i+nz_h/2-nz_h))
crossys2s1=(yL_P(i)-yL_P(i+nz_h/2-nz_h))
crosszs2s1=(zL_P(i)-zL_P(i+nz_h/2-nz_h))

dV_ys2s1=(xL_P(i)-xL_P(i+nz_h/2-nz_h))
dV_xs2s1=(yL_P(i)-yL_P(i+nz_h/2-nz_h))
dV_zs2s1=(zL_P(i)-zL_P(i+nz_h/2-nz_h))


!checking peridoicity

  if(abs(crossys2s1).gt.(ly_cub/2))then
   crossys2s1=sign(1.0d0,crossys2s1)*(ly_cub-sign(1.0d0,crossys2s1)*crossys2s1)
  endif
  if(abs(crossxs2s1).gt.(lx_cub/2))then
   crossxs2s1=sign(1.0d0,crossxs2s1)*(lx_cub-sign(1.0d0,crossxs2s1)*crossxs2s1)
  endif


  if(abs(dV_ys2s1).gt.(ly_cub/2))then
   dV_ys2s1=sign(1.0d0,dV_ys2s1)*(ly_cub-sign(1.0d0,dV_ys2s1)*dV_ys2s1)
  endif
  if(abs(dV_xs2s1).gt.(lx_cub/2))then
   dV_xs2s1=sign(1.0d0,dV_xs2s1)*(lx_cub-sign(1.0d0,dV_xs2s1)*dV_xs2s1)
  endif

else

crossxs2s1=(xL_P(i)-xL_P(i+nz_h/2))
crossys2s1=(yL_P(i)-yL_P(i+nz_h/2))
crosszs2s1=(zL_P(i)-zL_P(i+nz_h/2))

dV_ys2s1=(xL_P(i)-xL_P(i+nz_h/2))
dV_xs2s1=(yL_P(i)-yL_P(i+nz_h/2))
dV_zs2s1=(zL_P(i)-zL_P(i+nz_h/2))

!checking peridoicity
 if(abs(crossys2s1).gt.(ly_cub/2))then
   crossys2s1=sign(1.0d0,crossys2s1)*(ly_cub-sign(1.0d0,crossys2s1)*crossys2s1)
 endif
 if(abs(crossxs2s1).gt.(lx_cub/2))then
   crossxs2s1=sign(1.0d0,crossxs2s1)*(lx_cub-sign(1.0d0,crossxs2s1)*crossxs2s1)
 endif


 if(abs(dV_ys2s1).gt.(ly_cub/2))then
   dV_ys2s1=sign(1.0d0,dV_ys2s1)*(ly_cub-sign(1.0d0,dV_ys2s1)*dV_ys2s1)
 endif
 if(abs(dV_xs2s1).gt.(lx_cub/2))then
   dV_xs2s1=sign(1.0d0,dV_xs2s1)*(lx_cub-sign(1.0d0,dV_xs2s1)*dV_xs2s1)
 endif


endif




f_m2s1_x_cross=k_d_spring*((sqrt((crossxs2s1)**2 +(crossys2s1)**2 + (crosszs2s1)**2)) - (lenteja(i))) &
*(-crossxs2s1/sqrt((crossxs2s1)**2 +(crossys2s1)**2 + (crosszs2s1)**2)) - b_d_spring*dV_xs2s1


f_m2s1_y_cross=k_d_spring*((sqrt((crossxs2s1)**2 +(crossys2s1)**2 + (crosszs2s1)**2)) - (lenteja(i))) &
*(-crossys2s1/sqrt((crossxs2s1)**2 +(crossys2s1)**2 + (crosszs2s1)**2)) - b_d_spring*dV_ys2s1


f_m2s1_z_cross=k_d_spring*((sqrt((crossxs2s1)**2 +(crossys2s1)**2 + (crosszs2s1)**2)) - (lenteja(i))) &
*(-crosszs2s1/sqrt((crossxs2s1)**2 +(crossys2s1)**2 + (crosszs2s1)**2)) - b_d_spring*dV_zs2s1



if ((i+nz_h/2).gt.nz_h) then
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_x_cross

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_y_cross

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_z_cross


  fx(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2))= &
  fx(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2)) - f_m2s1_x_cross

  fy(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2))= &
  fy(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2)) - f_m2s1_y_cross

  fz(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2))= &
  fz(eul_indics(i+nz_h/2-nz_h,1), eul_indics(i+nz_h/2-nz_h,3), eul_indics(i+nz_h/2-nz_h,2)) - f_m2s1_z_cross




else

  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_x_cross

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_y_cross

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_m2s1_z_cross


  fx(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2))= &
  fx(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2)) - f_m2s1_x_cross

  fy(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2))= &
  fy(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2)) - f_m2s1_y_cross

  fz(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2))= &
  fz(eul_indics(i+nz_h/2,1), eul_indics(i+nz_h/2,3), eul_indics(i+nz_h/2,2)) - f_m2s1_z_cross


endif

#endif




!################################################ààààààà######ààààà##################

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%  beam method  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#if beam_flag == 1
k_bend=2.5e+10
f_left_y=0.0d0
f_left_x=0.0d0
f_left_z=0.0d0
f_med_x=0.0d0
f_med_y=0.0d0
f_med_z=0.0d0
f_right_x=0.0d0
f_right_y=0.0d0
f_right_z=0.0d0

if((i.ge.2).and.(i.le.(nz_h-1)))then
x_lef=xL_P(i-1)
x_med=xL_P(i)
x_rig=xL_P(i+1)

y_lef=yL_P(i-1)
y_med=yL_P(i)
y_rig=yL_P(i+1)

z_lef=zL_P(i-1)
z_med=zL_P(i)
z_rig=zL_P(i+1)

!%%%%%%%%%%%%%%%%%%%
c_res_x=sqrt((y_med-y_lef)**2+ (z_med-z_lef)**2)*sqrt((y_rig-y_med)**2+ (z_rig-z_med)**2)*sin(ang_bend(i,1))

c_res_y=sqrt((x_med-x_lef)**2+ (z_med-z_lef)**2)*sqrt((x_rig-x_med)**2+ (z_rig-z_med)**2)*sin(ang_bend(i,2))

c_res_z=sqrt((x_med-x_lef)**2+ (y_med-y_lef)**2)*sqrt((x_rig-x_med)**2+ (y_rig-y_med)**2)*sin(ang_bend(i,3))

!checking boundies in x and y
call check_boundary_periodicity(ds, lx_cub, x_lef, x_med, x_rig)
call check_boundary_periodicity(ds, ly_cub, y_lef, y_med, y_rig)
!plan X-Y
cross_p_z=(x_rig-x_med)*(y_med-y_lef)-(y_rig-y_med)*(x_med-x_lef)
!left node
f_left_x=f_left_x - k_bend*(cross_p_z-c_res_z)*(y_rig-y_med)
f_left_y=f_left_y + k_bend*(cross_p_z-c_res_z)*(x_rig-x_med)
!rigth node
f_right_x=f_right_x - k_bend*(cross_p_z-c_res_z)*(y_med-y_lef)
f_right_y=f_right_y + k_bend*(cross_p_z-c_res_z)*(x_med-x_lef)
!medium node
f_med_x=f_med_x + k_bend*(cross_p_z-c_res_z)*((y_med-y_lef) + (y_rig-y_med))
f_med_y=f_med_y - k_bend*(cross_p_z-c_res_z)*((x_med-x_lef) + (x_rig-x_med))


!plan X-Z
cross_p_y=(x_med-x_lef)*(z_rig-z_med)-(x_rig-x_med)*(z_med-z_lef)
!left node
f_left_z= f_left_z - k_bend*(cross_p_y-c_res_y)*(x_rig-x_med)
f_left_x= f_left_x + k_bend*(cross_p_y-c_res_y)*(z_rig-z_med)
!right node
f_right_z=f_right_z -k_bend*(cross_p_y-c_res_y)*(x_med-x_lef)
f_right_x= f_right_x + k_bend*(cross_p_y-c_res_y)*(z_med-z_lef)
!medium node
f_med_z= f_med_z + k_bend*(cross_p_y-c_res_y)*((x_med-x_lef) + (x_rig-x_med))
f_med_x= f_med_x - k_bend*(cross_p_y-c_res_y)*((z_med-z_lef) + (z_rig-z_med))

!plan Y-Z
cross_p_x=(z_med-z_lef)*(y_rig-y_med)-(z_rig-z_med)*(y_med-y_lef)
!left node
f_left_y= f_left_y - k_bend*(cross_p_x-c_res_x)*(z_rig-z_med)
f_left_z= f_left_z + k_bend*(cross_p_x-c_res_x)*(y_rig-y_med)
!right node
f_right_y= f_right_y - k_bend*(cross_p_x-c_res_x)*(z_med-z_lef)
f_right_z= f_right_z + k_bend*(cross_p_x-c_res_x)*(y_med-y_lef)
!medium node
f_med_y=f_med_y + k_bend*(cross_p_x-c_res_x)*((z_med-z_lef) + (z_rig-z_med))
f_med_z=f_med_z - k_bend*(cross_p_x-c_res_x)*((y_med-y_lef) + (y_rig-y_med))

!write(*,*) f_left_x,f_left_y, f_right_x,f_right_y,f_med_x ,f_med_y

!SUM ALL FORCES LEFT NODE
fx(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
fx(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - f_right_x

fy(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
fy(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - f_right_y

fz(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
fz(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - f_right_z


!SUM ALL FORCES right NODE
fx(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
fx(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - f_left_x

fy(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
fy(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - f_left_y

fz(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
fz(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - f_left_z


!SUM ALL FORCES MASTER NODE
fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_x

fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_y

fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_z

!%%%%%%%%%%%%%%%%%%%

elseif(i.eq.1)then
  x_lef=xL_P(nz_h)
  x_med=xL_P(i)
  x_rig=xL_P(i+1)

  y_lef=yL_P(nz_h)
  y_med=yL_P(i)
  y_rig=yL_P(i+1)

  z_lef=zL_P(nz_h)
  z_med=zL_P(i)
  z_rig=zL_P(i+1)
  !%%%%%%%%%%%%%%%%%%%

  c_res_x=sqrt((y_med-y_lef)**2+ (z_med-z_lef)**2)*sqrt((y_rig-y_med)**2+ (z_rig-z_med)**2)*sin(ang_bend(i,1))

  c_res_y=sqrt((x_med-x_lef)**2+ (z_med-z_lef)**2)*sqrt((x_rig-x_med)**2+ (z_rig-z_med)**2)*sin(ang_bend(i,2))

  c_res_z=sqrt((x_med-x_lef)**2+ (y_med-y_lef)**2)*sqrt((x_rig-x_med)**2+ (y_rig-y_med)**2)*sin(ang_bend(i,3))

  !checking boundies in x and y
  call check_boundary_periodicity(ds, lx_cub, x_lef, x_med, x_rig)
  call check_boundary_periodicity(ds, ly_cub, y_lef, y_med, y_rig)
  !plan X-Y
  cross_p_z=(x_rig-x_med)*(y_med-y_lef)-(y_rig-y_med)*(x_med-x_lef)
  !left node
  f_left_x=f_left_x - k_bend*(cross_p_z-c_res_z)*(y_rig-y_med)
  f_left_y=f_left_y + k_bend*(cross_p_z-c_res_z)*(x_rig-x_med)
  !rigth node
  f_right_x=f_right_x - k_bend*(cross_p_z-c_res_z)*(y_med-y_lef)
  f_right_y=f_right_y + k_bend*(cross_p_z-c_res_z)*(x_med-x_lef)
  !medium node
  f_med_x=f_med_x + k_bend*(cross_p_z-c_res_z)*((y_med-y_lef) + (y_rig-y_med))
  f_med_y=f_med_y - k_bend*(cross_p_z-c_res_z)*((x_med-x_lef) + (x_rig-x_med))


  !plan X-Z
  cross_p_y=(x_med-x_lef)*(z_rig-z_med)-(x_rig-x_med)*(z_med-z_lef)
  !left node
  f_left_z= f_left_z - k_bend*(cross_p_y-c_res_y)*(x_rig-x_med)
  f_left_x= f_left_x + k_bend*(cross_p_y-c_res_y)*(z_rig-z_med)
  !right node
  f_right_z=f_right_z -k_bend*(cross_p_y-c_res_y)*(x_med-x_lef)
  f_right_x= f_right_x + k_bend*(cross_p_y-c_res_y)*(z_med-z_lef)
  !medium node
  f_med_z= f_med_z + k_bend*(cross_p_y-c_res_y)*((x_med-x_lef) + (x_rig-x_med))
  f_med_x= f_med_x - k_bend*(cross_p_y-c_res_y)*((z_med-z_lef) + (z_rig-z_med))

  !plan Y-Z
  cross_p_x=(z_med-z_lef)*(y_rig-y_med)-(z_rig-z_med)*(y_med-y_lef)
  !left node
  f_left_y= f_left_y - k_bend*(cross_p_x-c_res_x)*(z_rig-z_med)
  f_left_z= f_left_z + k_bend*(cross_p_x-c_res_x)*(y_rig-y_med)
  !right node
  f_right_y= f_right_y - k_bend*(cross_p_x-c_res_x)*(z_med-z_lef)
  f_right_z= f_right_z + k_bend*(cross_p_x-c_res_x)*(y_med-y_lef)
  !medium node
  f_med_y=f_med_y + k_bend*(cross_p_x-c_res_x)*((z_med-z_lef) + (z_rig-z_med))
  f_med_z=f_med_z - k_bend*(cross_p_x-c_res_x)*((y_med-y_lef) + (y_rig-y_med))
  !write(*,*) f_left_x,f_left_y, f_right_x,f_right_y,f_med_x ,f_med_y

  !SUM ALL FORCES LEFT NODE
  fx(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2))= &
  fx(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2)) - f_right_x

  fy(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2))= &
  fy(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2)) - f_right_y

  fz(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2))= &
  fz(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2)) - f_right_z


  !SUM ALL FORCES right NODE
  fx(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
  fx(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - f_left_x

  fy(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
  fy(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - f_left_y

  fz(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
  fz(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - f_left_z


  !SUM ALL FORCES MASTER NODE
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_x

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_y

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_z
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


elseif(i.eq.nz_h)then
  x_lef=xL_P(i-1)
  x_med=xL_P(i)
  x_rig=xL_P(1)

  y_lef=yL_P(i-1)
  y_med=yL_P(i)
  y_rig=yL_P(1)

  z_lef=zL_P(i-1)
  z_med=zL_P(i)
  z_rig=zL_P(1)
!%%%%%%%%%%%%%%%%%%%

c_res_x=sqrt((y_med-y_lef)**2+ (z_med-z_lef)**2)*sqrt((y_rig-y_med)**2+ (z_rig-z_med)**2)*sin(ang_bend(i,1))

c_res_y=sqrt((x_med-x_lef)**2+ (z_med-z_lef)**2)*sqrt((x_rig-x_med)**2+ (z_rig-z_med)**2)*sin(ang_bend(i,2))

c_res_z=sqrt((x_med-x_lef)**2+ (y_med-y_lef)**2)*sqrt((x_rig-x_med)**2+ (y_rig-y_med)**2)*sin(ang_bend(i,3))
  !checking boundies in x and y
  call check_boundary_periodicity(ds, lx_cub, x_lef, x_med, x_rig)
  call check_boundary_periodicity(ds, ly_cub, y_lef, y_med, y_rig)
  !plan X-Y
  cross_p_z=(x_rig-x_med)*(y_med-y_lef)-(y_rig-y_med)*(x_med-x_lef)
  !left node
  f_left_x=f_left_x - k_bend*(cross_p_z-c_res_z)*(y_rig-y_med)
  f_left_y=f_left_y + k_bend*(cross_p_z-c_res_z)*(x_rig-x_med)
  !rigth node
  f_right_x=f_right_x - k_bend*(cross_p_z-c_res_z)*(y_med-y_lef)
  f_right_y=f_right_y + k_bend*(cross_p_z-c_res_z)*(x_med-x_lef)
  !medium node
  f_med_x=f_med_x + k_bend*(cross_p_z-c_res_z)*((y_med-y_lef) + (y_rig-y_med))
  f_med_y=f_med_y - k_bend*(cross_p_z-c_res_z)*((x_med-x_lef) + (x_rig-x_med))


  !plan X-Z
  cross_p_y=(x_med-x_lef)*(z_rig-z_med)-(x_rig-x_med)*(z_med-z_lef)
  !left node
  f_left_z= f_left_z - k_bend*(cross_p_y-c_res_y)*(x_rig-x_med)
  f_left_x= f_left_x + k_bend*(cross_p_y-c_res_y)*(z_rig-z_med)
  !right node
  f_right_z=f_right_z -k_bend*(cross_p_y-c_res_y)*(x_med-x_lef)
  f_right_x= f_right_x + k_bend*(cross_p_y-c_res_y)*(z_med-z_lef)
  !medium node
  f_med_z= f_med_z + k_bend*(cross_p_y-c_res_y)*((x_med-x_lef) + (x_rig-x_med))
  f_med_x= f_med_x - k_bend*(cross_p_y-c_res_y)*((z_med-z_lef) + (z_rig-z_med))

  !plan Y-Z
  cross_p_x=(z_med-z_lef)*(y_rig-y_med)-(z_rig-z_med)*(y_med-y_lef)
  !left node
  f_left_y= f_left_y - k_bend*(cross_p_x-c_res_x)*(z_rig-z_med)
  f_left_z= f_left_z + k_bend*(cross_p_x-c_res_x)*(y_rig-y_med)
  !right node
  f_right_y= f_right_y - k_bend*(cross_p_x-c_res_x)*(z_med-z_lef)
  f_right_z= f_right_z + k_bend*(cross_p_x-c_res_x)*(y_med-y_lef)
  !medium node
  f_med_y=f_med_y + k_bend*(cross_p_x-c_res_x)*((z_med-z_lef) + (z_rig-z_med))
  f_med_z=f_med_z - k_bend*(cross_p_x-c_res_x)*((y_med-y_lef) + (y_rig-y_med))
  !write(*,*) f_left_x,f_left_y, f_right_x,f_right_y,f_med_x ,f_med_y

  !SUM ALL FORCES LEFT NODE
  fx(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
  fx(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - f_right_x

  fy(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
  fy(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - f_right_y

  fz(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
  fz(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - f_right_z


  !SUM ALL FORCES right NODE
  fx(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2))= &
  fx(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2)) - f_left_x

  fy(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2))= &
  fy(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2)) - f_left_y

  fz(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2))= &
  fz(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2)) - f_left_z


  !SUM ALL FORCES MASTER NODE
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_x

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_y

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + f_med_z

!%%%%%%%%%%%%%%%%%%%
endif



#endif
enddo

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%  non-invariant beam method  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#if non_invariant_flag == 1

do i=1,nz_h
k_bend=2.5e+5!0

if((i.ge.2).and.(i.le.(nz_h-1)))then
  x_lef=xL_P(i-1)
  x_med=xL_P(i)
  x_rig=xL_P(i+1)

  y_lef=yL_P(i-1)
  y_med=yL_P(i)
  y_rig=yL_P(i+1)

  z_lef=zL_P(i-1)
  z_med=zL_P(i)
  z_rig=zL_P(i+1)

  c_res_x=rest_inv_beam(i,1)
  c_res_y=rest_inv_beam(i,2)
  c_res_z=rest_inv_beam(i,3)

!write(*,*) c_res_x, c_res_y, c_res_z
  call check_boundary_periodicity(ds, lx_cub, x_lef, x_med, x_rig)
  call check_boundary_periodicity(ds, ly_cub, y_lef, y_med, y_rig)

fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(x_rig - 2*x_med + x_lef - c_res_x)

fx(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
fx(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - k_bend*(x_rig - 2*x_med + x_lef - c_res_x)

fx(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
fx(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - k_bend*(x_rig - 2*x_med + x_lef - c_res_x)


fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(y_rig - 2*y_med + y_lef - c_res_y)

fy(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
fy(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - k_bend*(y_rig - 2*y_med + y_lef - c_res_y)

fy(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
fy(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - k_bend*(y_rig - 2*y_med + y_lef - c_res_y)


fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

fz(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
fz(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

fz(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
fz(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

elseif(i.eq.1)then

  x_lef=xL_P(nz_h)
  x_med=xL_P(i)
  x_rig=xL_P(i+1)

  y_lef=yL_P(nz_h)
  y_med=yL_P(i)
  y_rig=yL_P(i+1)

  z_lef=zL_P(nz_h)
  z_med=zL_P(i)
  z_rig=zL_P(i+1)


c_res_x=rest_inv_beam(i,1)
c_res_y=rest_inv_beam(i,2)
c_res_z=rest_inv_beam(i,3)

  call check_boundary_periodicity(ds, lx_cub, x_lef, x_med, x_rig)
  call check_boundary_periodicity(ds, ly_cub, y_lef, y_med, y_rig)


  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(x_rig - 2*x_med + x_lef - c_res_x)

  fx(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2))= &
  fx(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2)) - k_bend*(x_rig - 2*x_med + x_lef - c_res_x)

  fx(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
  fx(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - k_bend*(x_rig - 2*x_med + x_lef - c_res_x)


  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(y_rig - 2*y_med + y_lef - c_res_y)

  fy(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2))= &
  fy(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2)) - k_bend*(y_rig - 2*y_med + y_lef - c_res_y)

  fy(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
  fy(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - k_bend*(y_rig - 2*y_med + y_lef - c_res_y)


  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

  fz(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2))= &
  fz(eul_indics(nz_h,1), eul_indics(nz_h,3) ,eul_indics(nz_h,2)) - k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

  fz(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2))= &
  fz(eul_indics(i+1,1), eul_indics(i+1,3) ,eul_indics(i+1,2)) - k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

elseif(i.eq.nz_h)then

  x_lef=xL_P(i-1)
  x_med=xL_P(i)
  x_rig=xL_P(1)

  y_lef=yL_P(i-1)
  y_med=yL_P(i)
  y_rig=yL_P(1)

  z_lef=zL_P(i-1)
  z_med=zL_P(i)
  z_rig=zL_P(1)

c_res_x=rest_inv_beam(i,1)
c_res_y=rest_inv_beam(i,2)
c_res_z=rest_inv_beam(i,3)

  call check_boundary_periodicity(ds, lx_cub, x_lef, x_med, x_rig)
  call check_boundary_periodicity(ds, ly_cub, y_lef, y_med, y_rig)


  fx(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
  fx(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - k_bend*(x_rig - 2*x_med + x_lef - c_res_x)

  fx(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2))= &
  fx(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2)) - k_bend*(x_rig - 2*x_med + x_lef - c_res_x)

  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(x_rig - 2*x_med + x_lef - c_res_x)


  fy(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
  fy(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - k_bend*(y_rig - 2*y_med + y_lef - c_res_y)

  fy(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2))= &
  fy(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2)) - k_bend*(y_rig - 2*y_med + y_lef - c_res_y)

  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(y_rig - 2*y_med + y_lef - c_res_y)


  fz(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2))= &
  fz(eul_indics(i-1,1), eul_indics(i-1,3) ,eul_indics(i-1,2)) - k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

  fz(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2))= &
  fz(eul_indics(1,1), eul_indics(1,3) ,eul_indics(1,2)) - k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))= &
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2)) + 2*k_bend*(z_rig - 2*z_med + z_lef - c_res_z)

endif

enddo
#endif
!#############################################################################
   frz_ib(:,:,:,1)=0.0!fx
   frz_ib(:,:,:,2)=0.0!fy
   frz_ib(:,:,:,3)=0.0!fz


!################# Support#######################################
do i=1, nz_h

if(tresd_sim.eq.0) then

do j=1,nx!2*tresd_supp+1
do k=1,2*n_supp+1
do l=1,2*n_supp+1


indx_supp(j)=j!eul_indics(i,1)+j-tresd_supp-1
call period_supp(indx_supp(j), nx)
indy_supp(k)=eul_indics(i,2)+k-n_supp-1
call period_supp(indy_supp(k), ny)
indz_supp(l)=eul_indics(i,3)+l-n_supp-1

if(sqrt(real(j-n_supp-1)**2+real(k-n_supp-1)**2+real(l-n_supp-1)**2).le.&
sqrt((int(rad_esf*nx/lx_cub))**2 + (int(rad_esf*ny/ly_cub))**2 + rez_esf(l)**2))then
frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),1)=&
frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),1)+&
fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))*ds!*&
!delta_k(i,1,j)*delta_k(i,2,k)*delta_k(i,3,l)*ds

frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),2)=&
frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),2)+&
fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))*ds!*&
!delta_k(i,1,j)*delta_k(i,2,k)*delta_k(i,3,l)*ds

frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),3)=&
frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),3)+&
fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))*ds!*&
!delta_k(i,1,j)*delta_k(i,2,k)*delta_k(i,3,l)*ds
endif
enddo
enddo
enddo

elseif(tresd_sim.eq.1) then

  do j=1,2*n_supp+1
  do k=1,2*n_supp+1
  do l=1,2*n_supp+1


  indx_supp(j)=eul_indics(i,1)+j-n_supp-1
  call period_supp(indx_supp(j), nx)
  indy_supp(k)=eul_indics(i,2)+k-n_supp-1
  call period_supp(indy_supp(k), ny)
  indz_supp(l)=eul_indics(i,3)+l-n_supp-1

  if(sqrt(real(j-n_supp-1)**2+real(k-n_supp-1)**2+real(l-n_supp-1)**2).le.&
  sqrt((int(rad_esf*nx/lx_cub))**2 + (int(rad_esf*ny/ly_cub))**2 + rez_esf(l)**2))then
  frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),1)=&
  frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),1)+&
  fx(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))*ds!*&
  !delta_k(i,1,j)*delta_k(i,2,k)*delta_k(i,3,l)*ds

  frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),2)=&
  frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),2)+&
  fy(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))*ds!*&
  !delta_k(i,1,j)*delta_k(i,2,k)*delta_k(i,3,l)*ds

  frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),3)=&
  frz_ib(indx_supp(j), indz_supp(l),indy_supp(k),3)+&
  fz(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))*ds!*&
  !delta_k(i,1,j)*delta_k(i,2,k)*delta_k(i,3,l)*ds
  endif
  enddo
  enddo
  enddo


endif

!-------------------------------------------------------------------

enddo

!#################################################################

!Adding mass point force
#if masspoint_flag == 1
  frz_ib(:,:,:,1)=frz_mass(:,:,:,1)!frz_ib(:,:,:,1)+
  frz_ib(:,:,:,2)=frz_mass(:,:,:,2)!frz_ib(:,:,:,2)+
  frz_ib(:,:,:,3)=frz_mass(:,:,:,3)!frz_ib(:,:,:,3)+
!write(*,*) "sum fr mass", sum(frz_mass(:,:,:,3))
#endif

f_hyd=0.d0


f_hyd(1)=0.0!sum(frz_ib(eul_indics(:,1), eul_indics(:,3) ,eul_indics(:,2),1))&
!*(4.0/3.0)*rho_fld*pi*(rad_esf*h_dim)**3!(ly_cub/ny)*(rad_esf/sum(rez_esf(:)/(2*n_supp+1)))!*lx_cub/nx ! 2D
f_hyd(2)=0.0!sum(frz_ib(eul_indics(:,1), eul_indics(:,3) ,eul_indics(:,2),2))&
!*(4.0/3.0)*rho_fld*pi*(rad_esf*h_dim)**3!(ly_cub/ny)*(rad_esf/sum(rez_esf(:)/(2*n_supp+1)))!*lx_cub/nx ! 2D
f_hyd(3)=0.0!sum(frz_ib(eul_indics(:,1), eul_indics(:,3) ,eul_indics(:,2),3))&
!*(4.0/3.0)*rho_fld*pi*(rad_esf*h_dim)**3!(ly_cub/ny)*(rad_esf/sum(rez_esf(:)/(2*n_supp+1)))!*lx_cub/nx ! 2D

!write(*,*) f_hyd(1),f_hyd(2),f_hyd(3)
return
end subroutine find_lag_forces_in_eul



subroutine check_boundary_periodicity(ds, lx, x_lef, x_med, x_rig)
use commondata
use par_size !paralelisation chunks
use grid
use sim_par  !pi, simulation parameters
use ibm_membrane
double precision :: dx_lm,dx_rm,x_lef, x_med, x_rig
double precision :: ds, lx

dx_lm=x_med-x_lef
dx_rm=x_rig-x_med

if(abs(dx_lm).gt.(5*ds)) then
if(dx_lm.lt.0)then
!it has moved left
x_lef=-lx+x_lef
elseif(dx_lm.gt.0)then !it has moved right
x_lef= lx+x_lef
endif
endif

if(abs(dx_rm).gt.(5*ds)) then
if(dx_rm.lt.0)then
!it has moved left
x_rig= lx+x_rig
elseif(dx_rm.gt.0)then !it has moved right
x_rig=-lx+x_rig
endif
endif

return
end subroutine check_boundary_periodicity
