subroutine ini_bended(xh_l,yh_l, zh_l,rest_length,ang_bend, lenteja,&
 rest_inv_beam,i_budo)

use commondata
use grid
use sim_par
use ibm_membrane
double precision :: xh_l(nz_h), yh_l(nz_h), zh_l(nz_h)
double precision :: a_bended,  b_bended,  c_bended
integer :: eul_indx(nz_h,3)
integer :: ich, j, k,i_budo
integer :: i_ibm_01,j_ibm_01,k_ibm_01
integer :: i_ibm_0,j_ibm_0,k_ibm_0
integer :: stept
!preferred curvature
double precision :: x_lef,x_med,x_rig, y_lef, y_med, &
y_rig, z_lef, z_med, z_rig
double precision :: dot_pxy, dot_pxz, dot_pyz
double precision :: theta_xy, theta_xz, theta_yz
double precision :: ang_bend_xy, ang_bend_xz, ang_bend_yz
double precision :: ang_bend(nz_h,3), rest_inv_beam(nz_h,3)
!preferred length
double precision :: rest_length(nz_h), lenteja(nz_h)
double precision :: crossxs2s1, crossys2s1, crosszs2s1
!preferred inv-beamflag
double precision :: inv_beanx,inv_beany,inv_beanz

character(len=40):: namefile

!timestep 0
stept=0
  theta_t=2.0d0*pi      !Helix Azimuth
  a_bended=0.1
  b_bended=0.1
  c_bended=0.0d0
!write(*,*) i_budo

 ich=0
do k=1,(nz_h)
 ! T_h=(real(k)-1.0)*theta_t/(nz_h)
 !   T_h0= (real(k)-2.0)*theta_t/(nz_h)
        ich=ich+1

               xh = 0.0d0!c_bended!a_bended*sin(T_h)
               xh_l(ich)= xh

               yh = 0.0d0 !+0.35 !+ ly_cub*0.25!b_bended*cos(T_h)
               yh_l(ich)= yh

               zh = 0.0d0 + 0.465d0 + 0.25*(i_budo-1)!0.0d0 + 0.53 - 0.25*(i_budo-1) !0.465d0
               zh_l(ich)= zh

            i_ibm=minloc(abs(x-(xh + lx_cub*lx_pos))) !int((nx)*(xh + lx_cub*0.5)/lx_cub +1)
            j_ibm=minloc(abs(y-(yh + ly_cub*ly_pos))) !int((ny)*(yh + ly_cub*0.5)/ly_cub +1)
                     !p_new=(zh - lz_cub*0.0d0)*2.0d0/lz_cub
            k_ibm=minloc(abs(z-(zh - lz_cub*lz_pos)))!int((abs(acos(p_new))*((nz-1)/pi))+1)
              eul_indx(ich,1)=i_ibm(1)
              eul_indx(ich,2)=j_ibm(1)
              eul_indx(ich,3)=k_ibm(1)

enddo



!call ibm_write(eul_indx, stept)
call ibm_lag_to_vtk(xh_l,yh_l, zh_l, stept)
call ibm_object_gen(xh_l,yh_l, zh_l,eul_indx, stept)
!call ibm_particulas(xh_l,yh_l, zh_l, stept)

return
end subroutine ini_bended

subroutine ini_helix(xh_l,yh_l, zh_l)

use commondata
use grid
use sim_par
use ibm_membrane
double precision :: xh_l(ny_h*nz_h,3), yh_l(ny_h*nz_h,3), zh_l(ny_h*nz_h,3)
integer :: eul_indx(ny_h*nz_h,3,3)
integer :: ich, j, k
integer :: i_ibm_01,j_ibm_01,k_ibm_01
integer :: i_ibm_0,j_ibm_0,k_ibm_0
integer :: stept

!timestep 0
stept=0
  theta_t=n_turns*2*pi      !Helix Azimuth
  h_h=axi_lngth/theta_t     !Helix pitch
  theta_u=2*pi              !number of local rounds
!allocate (ibm_eu(nx,ny,nz))


 ich=0
      do k=1,(nz_h)
         T_h=(real(k)-1.0)*theta_t/nz_h
         T_h0= (real(k)-2.0)*theta_t/nz_h
         do j=1,(ny_h)
           U_h=(real(j)-1)*theta_u/ny_h
            U_h0=(real(j)-2)*theta_u/ny_h
               ich=ich+1
               a_h=thick_a

                    xh = R_h*sin(T_h) - a_h*sin(T_h)*cos(U_h) - a_h*h_h*cos(T_h)*sin(U_h)
                    xh_l(ich,1)= xh
                    yh = R_h*cos(T_h) - a_h*cos(T_h)*cos(U_h) + a_h*h_h*sin(T_h)*sin(U_h)
                    yh_l(ich,1)= yh
                    zh = h_h*T_h+a_h*R_h*sin(U_h)/(sqrt((R_h*R_h)+(h_h*h_h)))
                    zh_l(ich,1)= zh

                     i_ibm= int((nx)*(xh + lx_cub*0.5)/lx_cub +1)
                     j_ibm= int((ny)*(yh + ly_cub*0.5)/ly_cub +1)
                     p_new=(zh - lz_cub*0.0)*2.0d0/lz_cub
                     k_ibm=int((abs(acos(p_new))*((nz-1)/pi))+1)
                     eul_indx(ich,1,1)=i_ibm(1)
                     eul_indx(ich,2,1)=j_ibm(1)
                     eul_indx(ich,3,1)=k_ibm(1)


  !                       ni=ntot*a_h/(2.0*thick_a)
 !                       sigma_slope = (smoothslope - ni*2.0*smoothslope/ntot)
!                        ibm_eu(i_ibm,j_ibm, k_ibm)= 1.0d0/(1.0d0+exp(-sigma_slope))
!--------------------------------------------------------------------------------------------------
                   if ((k.ge.2).and.(j.ge.2)) then

                     ! Geting the points 'slave 1' in azimuth T
                     xh_0 = R_h*sin(T_h0) - a_h*sin(T_h0)*cos(U_h) - a_h*h_h*cos(T_h0)*sin(U_h)
                      xh_l(ich,2)= xh_0
                     yh_0 = R_h*cos(T_h0) - a_h*cos(T_h0)*cos(U_h) + a_h*h_h*sin(T_h0)*sin(U_h)
                      yh_l(ich,2)= yh_0
                     zh_0 = h_h*T_h0+a_h*R_h*sin(U_h)/(sqrt((R_h*R_h)+(h_h*h_h)))
                      zh_l(ich,2)= zh_0


                     ! Geting the points 'slave 2' in radia U
                    xh_01 = R_h*sin(T_h) - a_h*sin(T_h)*cos(U_h0) - a_h*h_h*cos(T_h)*sin(U_h0)
                     xh_l(ich,3)= xh_01
                    yh_01 = R_h*cos(T_h) - a_h*cos(T_h)*cos(U_h0) + a_h*h_h*sin(T_h)*sin(U_h0)
                     yh_l(ich,3)= yh_01
                    zh_01 = h_h*T_h+a_h*R_h*sin(U_h0)/(sqrt((R_h*R_h)+(h_h*h_h)))
                     zh_l(ich,3)= zh_01

                    else
                    xh_0 = R_h*sin(T_h) - a_h*sin(T_h)*cos(U_h) - a_h*h_h*cos(T_h)*sin(U_h)
                    xh_l(ich,2)= xh_0
                    yh_0 = R_h*cos(T_h) - a_h*cos(T_h)*cos(U_h) + a_h*h_h*sin(T_h)*sin(U_h)
                    yh_l(ich,2)= yh_0
                    zh_0 = h_h*T_h+a_h*R_h*sin(U_h)/(sqrt((R_h*R_h)+(h_h*h_h)))
                    zh_l(ich,2)= zh_0

                    xh_01 = R_h*sin(T_h) - a_h*sin(T_h)*cos(U_h) - a_h*h_h*cos(T_h)*sin(U_h)
                    xh_l(ich,3)= xh_01
                    yh_01 = R_h*cos(T_h) - a_h*cos(T_h)*cos(U_h) + a_h*h_h*sin(T_h)*sin(U_h)
                    yh_l(ich,3)= yh_01
                    zh_01 = h_h*T_h+a_h*R_h*sin(U_h)/(sqrt((R_h*R_h)+(h_h*h_h)))
                    zh_l(ich,3)= zh_01
                  endif
       enddo
   enddo

call ibm_write(eul_indx, stept)


return
end subroutine ini_helix

subroutine ini_astroidal(xh_l,yh_l, zh_l)
use commondata
use grid
use sim_par
use ibm_membrane
double precision :: xh_l(ny_h*nz_h,3), yh_l(ny_h*nz_h,3), zh_l(ny_h*nz_h,3)
integer :: eul_indx(ny_h*nz_h,3,3)
integer :: ich, j, k
integer :: i_ibm_01,j_ibm_01,k_ibm_01
integer :: i_ibm_0,j_ibm_0,k_ibm_0
integer :: stept
!call ibm_read_input

!timestep 0
stept=0

  n_turns=1        !One side of the astroidal
  theta_t=n_turns*pi
  theta_u=pi          !4 wall-membranes
  heigth_a=0.2

 ich=0
      do k=1,(nz_h)
         T_h=(real(k)-1.0)*theta_t/nz_h
         T_h0= (real(k)-2.0)*theta_t/nz_h
         do j=1,(ny_h)
           U_h=(real(j)-1)*theta_u/ny_h
            U_h0=(real(j)-2)*theta_u/ny_h
               ich=ich+1

               a_h=heigth_a

                     xh= a_h*(cos(U_h)**3)*(cos(T_h)**3)   ! the second term controls the diameter
                     xh_l(ich,1)= xh

                     yh= a_h*(sin(U_h)**3)*(cos(T_h)**3)   ! the second term controls the diameter
                     yh_l(ich,1)= yh

                     zh= -a_h*(sin(T_h)**3)
                     zh_l(ich,1)= zh


                     i_ibm= int((nx)*(xh + lx_cub*0.5)/lx_cub +1)
                     j_ibm= int((ny)*(yh + ly_cub*0.5)/ly_cub +1)
                     p_new=(zh - lz_cub*0.2)*2.0d0/lz_cub
                     k_ibm=int((abs(acos(p_new))*((nz-1)/pi))+1)
                     eul_indx(ich,1,1)=i_ibm(1)
                     eul_indx(ich,2,1)=j_ibm(1)
                     eul_indx(ich,3,1)=k_ibm(1)

!--------------------------------------------------------------------------------------------------
                   if ((k.ge.2).and.(j.ge.2)) then

                     ! Geting the points 'slave 1' in azimuth T
                     xh_0= a_h*(cos(U_h)**3)*(cos(T_h0)**3)
                      xh_l(ich,2)= xh_0

                     yh_0= a_h*(sin(U_h)**3)*(cos(T_h0)**3)   ! the second term controls the diameter
                      yh_l(ich,2)= yh_0

                     zh_0= -a_h*(sin(T_h0)**3)
                      zh_l(ich,2)= zh_0

                     ! Geting the points 'slave 2' in radia U
                    xh_01= a_h*(cos(U_h0)**3)*(cos(T_h)**3)
                    xh_l(ich,3)= xh_01

                    yh_01= a_h*(sin(U_h0)**3)*(cos(T_h)**3)
                    yh_l(ich,3)= yh_01

                    zh_01 =-a_h*(sin(T_h)**3)
                     zh_l(ich,3)= zh_01

                    else
                    xh_0= a_h*(cos(U_h)**3)*(cos(T_h)**3)
                      xh_l(ich,2)= xh_0
                    yh_0= a_h*(sin(U_h)**3)*(cos(T_h)**3)   ! the second term controls the diameter
                      yh_l(ich,2)= yh_0
                    zh_0= -a_h*(sin(T_h)**3)
                      zh_l(ich,2)= zh_0

                    xh_01= a_h*(cos(U_h)**3)*(cos(T_h)**3)
                     xh_l(ich,3)= xh_01
                    yh_01= a_h*(sin(U_h)**3)*(cos(T_h)**3)
                     yh_l(ich,3)= yh_01
                    zh_01 = -a_h*(sin(T_h)**3)
                     zh_l(ich,3)= zh_01
                  endif
!------------------------------------------------------------------------------------------------

         enddo
      enddo
call ibm_write(eul_indx, stept)
return
end subroutine ini_astroidal


subroutine ini_elipsoid(xh_l,yh_l, zh_l)

use commondata
use grid
use sim_par
use ibm_membrane
double precision :: xh_l(ny_h*nz_h,3), yh_l(ny_h*nz_h,3), zh_l(ny_h*nz_h,3)
integer :: eul_indx(ny_h*nz_h,3,3)
integer :: ich, j, k
integer :: i_ibm_01,j_ibm_01,k_ibm_01
integer :: i_ibm_0,j_ibm_0,k_ibm_0
integer :: stept

!timestep 0
stept=0
  n_turns=1.0d0         !One side of the elipsoid if 1
  theta_t=n_turns*pi
  theta_u=pi          !1pi revolution

   ich=0
      do k=1,(nz_h)
         T_h=(real(k)-1.0)*theta_t/nz_h
         T_h0= (real(k)-2.0)*theta_t/nz_h
         do j=1,(ny_h)
           U_h=(real(j)-1)*theta_u/ny_h
            U_h0=(real(j)-2)*theta_u/ny_h
               ich=ich+1

                  xh= a_eli*cos(U_h)*cos(T_h)   ! the second term controls the diameter
                   xh_l(ich,1)= xh

                  yh= b_eli*sin(U_h)*cos(T_h)   ! the second term controls the diameter
                    yh_l(ich,1)= yh

                  zh= c_eli*(sin(T_h))
                    zh_l(ich,1)= zh

                     i_ibm= int((nx)*(xh + lx_cub*0.5)/lx_cub +1)
                     j_ibm= int((ny)*(yh + ly_cub*0.5)/ly_cub +1)
                     p_new=(zh - lz_cub*0.2)*2.0d0/lz_cub
                     k_ibm=int((abs(acos(p_new))*((nz-1)/pi))+1)
                     eul_indx(ich,1,1)=i_ibm(1)
                     eul_indx(ich,2,1)=j_ibm(1)
                     eul_indx(ich,3,1)=k_ibm(1)
                     ! write(*,*) ' i_ibm,j_ibm,k_ibm', eul_indx(ich,1,1), eul_indx(ich,2,1), eul_indx(ich,3,1)

 !--------------------------------------------------------------------------------------------------
                   if ((k.ge.2).and.(j.ge.2)) then

                     ! Geting the points 'slave 1' in azimuth T
                     xh_0= a_eli*cos(U_h)*cos(T_h0)   ! the second term controls the diameter
                      xh_l(ich,2)= xh_0
                     yh_0= b_eli*sin(U_h)*cos(T_h0)   ! the second term controls the diameter
                      yh_l(ich,2)= yh_0
                     zh_0= c_eli*(sin(T_h0))
                      zh_l(ich,2)= zh_0


                     ! Geting the points 'slave 2' in radia U
                    xh_01 = a_eli*cos(U_h0)*cos(T_h)
                     xh_l(ich,3)= xh_01
                    yh_01 = b_eli*sin(U_h0)*cos(T_h)
                     yh_l(ich,3)= yh_01
                    zh_01 = c_eli*(sin(T_h))
                     zh_l(ich,3)= zh_01

                    else
                    xh_0 = a_eli*cos(U_h)*cos(T_h)
                     xh_l(ich,2)= xh_0
                    yh_0 = b_eli*sin(U_h)*cos(T_h)
                     yh_l(ich,2)= yh_0
                    zh_0 = c_eli*(sin(T_h))
                     zh_l(ich,2)= zh_0

                    xh_01 = a_eli*cos(U_h)*cos(T_h)
                     xh_l(ich,3)= xh_01
                    yh_01 = b_eli*sin(U_h)*cos(T_h)
                     yh_l(ich,3)= yh_01
                    zh_01 = c_eli*(sin(T_h))
                     zh_l(ich,3)= zh_01
                  endif
       enddo
   enddo

call ibm_write(eul_indx, stept)

return
end subroutine ini_elipsoid


subroutine ini_helicoid(xh_l, yh_l, zh_l)

use commondata
use grid
use sim_par
use ibm_membrane
double precision :: xh_l(ny_h*nz_h,3), yh_l(ny_h*nz_h,3), zh_l(ny_h*nz_h,3)
integer :: eul_indx(ny_h*nz_h,3,3)
integer :: ich, j, k
integer :: stept

stept=0

  theta_t=1.0d0*n_turns*pi  !1pi revolution
  theta_u=1.0d0*pi

   ich=0
    do k=1,(nz_h)
         T_h=-pi+(real(k)-1.0)*theta_t/nz_h
           T_h0=-pi+(real(k)-2.0)*theta_t/nz_h

         do j=1,(ny_h)
           U_h=-pi+(real(j)-1.0)*theta_u/ny_h
            U_h0=-pi+(real(j)-2.0)*theta_u/ny_h

               ich=ich+1
                 xh= a_helic*sinh(U_h)*sin(T_h)
                   xh_l(ich,1)= xh

                 yh= b_helic*cosh(U_h)*cos(T_h)
                   yh_l(ich,1)= yh

                 zh= c_helic*T_h
                   zh_l(ich,1)= zh            ! height

                  i_ibm= int((nx)*(xh + lx_cub*0.5)/lx_cub +1)
                  j_ibm= int((ny)*(yh + ly_cub*0.5)/ly_cub +1)
                     p_new=(zh - lz_cub*0.2)*2.0d0/lz_cub
                  k_ibm=int((abs(acos(p_new))*((nz-1)/pi))+1)
                eul_indx(ich,1,1)=i_ibm(1)
                eul_indx(ich,2,1)=j_ibm(1)
                eul_indx(ich,3,1)=k_ibm(1)



          if ((k.ge.2).and.(j.ge.2)) then

         ! Geting the points 'slave 1' in azimuth T
               xh_0= a_helic*sinh(U_h)*sin(T_h0)
                 xh_l(ich,2)= xh_0
               yh_0= b_helic*cosh(U_h)*cos(T_h0)
                 yh_l(ich,2)= yh_0
               zh_0= c_helic*T_h0                      ! height
                 zh_l(ich,2)= zh_0

         ! Geting the points 'slave 2' in azimuth U

           xh_01= a_helic*sinh(U_h0)*sin(T_h)
              xh_l(ich,3)= xh_01
           yh_01= b_helic*cosh(U_h0)*cos(T_h)
               yh_l(ich,3)= yh_01
           zh_01= c_helic*T_h
               zh_l(ich,3)= zh_01
           else
                 !xh_0= a_helic*sinh(U_h)*sin(T_h)
                   xh_l(ich,2)= xh
                 !yh_0= b_helic*cosh(U_h)*cos(T_h)
                   yh_l(ich,2)= yh
                 !zh_0= c_helic*T_h
                   zh_l(ich,2)= zh

                 !xh_01= a_helic*sinh(U_h)*sin(T_h)
                   xh_l(ich,3)= xh

                 !yh_01= b_helic*cosh(U_h)*cos(T_h)
                   yh_l(ich,3)= yh

                 !zh_01= c_helic*T_h
                   zh_l(ich,3)= zh



           endif
          enddo
         enddo

 call ibm_write(eul_indx, stept)

return
end subroutine ini_helicoid





subroutine ibm_write(indics_eul, ntime)

use commondata
use grid
use sim_par
use ibm_membrane

integer          :: indics_eul(nz_h,3), i
double precision, allocatable, dimension(:,:,:) :: ibm_eu
double precision :: xmin, ymin, zmin, deltax, deltay, deltaz
integer          :: ntime
character(len=40):: namefile



call ibm_read_input
allocate (ibm_eu(nx,ny,nz))
 ibm_eu=0.0d0
 !Smoothing with sigmoid function
! smoothslope=4.5           !how fast the curve decrease see sigmoid_func.m
 ntot= 100.00

        do i=1,nz_h
!        write(*,*) indics_eul(i,1,1),indics_eul(i,2,1), indics_eul(i,3,1)
         ibm_eu(indics_eul(i,1),indics_eul(i,2), indics_eul(i,3))= 1.0d0!/(1.0d0+exp(-sigma_slope))

        enddo
 ! Write VTK File
  xmin = 0.0d0
!  xmax = lx_cub
  ymin = 0.0d0
!  ymax = ly_cub
  zmin = 0.0d0
!  zmax = lz_cub
  deltax = (lx_cub-xmin)/nx
  deltay = (ly_cub-ymin)/ny
  deltaz = (lz_cub-zmin)/nz



  write(namefile,'(a,i8.8,a)') './IBM/ibm_',ntime,'.vtr'

   ! vtr file writing
   open(43,file=trim(namefile),form = 'formatted',status='replace',access='stream',convert='big_endian')

! open(unit=70,file='./sc_compiled/input_ibm.f90',form='formatted',status='old',action='read')
   write(43,'(A)') '<VTKFile type="RectilinearGrid" version="0.1" byte_order="LittleEndian">'
   write(43,*) '<RectilinearGrid WholeExtent="',1,nx,1,ny,1,nz,'">'
   write(43,*) '<Piece Extent="',1,nx,1,ny,1,nz,'">'
   write(43,'(A)') '<PointData>'
   write(43,'(A)') '<DataArray type="Float32" Name="IBM_to_Eul" NumberOfComponents="1" format="ascii">'
   write(43,*)     ibm_eu(1:nx,1:ny,1:nz)
   write(43,'(A)') '</DataArray>'
   write(43,'(A)') '</PointData>'
   write(43,'(A)') '<CellData>'
   write(43,'(A)') '</CellData>'
   write(43,'(A)') '<Coordinates>'
   write(43,'(A)') '<DataArray type="Float32" Name="X_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(43,*)     (xmin+(i-0.5)*deltax,i=1,nx)
   write(43,'(A)') '</DataArray>'
   write(43,'(A)') '<DataArray type="Float32" Name="Y_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(43,*)     (ymin+(i-0.5)*deltay,i=1,ny)
   write(43,'(A)') '</DataArray>'
   write(43,'(A)') '<DataArray type="Float32" Name="Z_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(43,*)     (cos(((i-1)*pi)/(nz-1)),i=1,nz)!(zmin+(i-0.5)*deltaz,i=1,nz)
   write(43,'(A)') '</DataArray>'
   write(43,'(A)') '</Coordinates>'
   write(43,'(A)') '</Piece>'
   write(43,'(A)') '</RectilinearGrid>'
   write(43,'(A)') '</VTKFile> '

  close(43)

deallocate (ibm_eu)




return
end subroutine ibm_write


subroutine ibm_frc_write(ntime,frz_ibm)

use commondata
use grid
use sim_par
use ibm_membrane
use par_size
!integer          :: indics_eul(nz_h,3), i, ii, jj, kk
double precision, allocatable, dimension(:,:,:) :: ibm_forza
double precision :: frz_ibm(nx,nz,ny,3)
double precision :: xmin, ymin, zmin, deltax, deltay, deltaz
integer          :: ntime
character(len=40):: namefile



call ibm_read_input
allocate (ibm_forza(nx,ny,nz))
 ibm_forza=0.0d0


!

        do ii=1,nx
           do jj=1,ny
             do kk= 1,nz

             ibm_forza(ii,jj,kk)=sqrt((frz_ibm(ii,kk,jj,1)**2)&
             +  (frz_ibm(ii,kk,jj,2))**2&
             +  (frz_ibm(ii,kk,jj,3))**2)
             enddo
           enddo
        enddo



 ! Write VTK File
  xmin = 0.0d0
!  xmax = lx_cub
  ymin = 0.0d0
!  ymax = ly_cub
  zmin = 0.0d0
!  zmax = lz_cub
  deltax = (lx_cub-xmin)*re/(nx-1)
  deltay = (ly_cub-ymin)*re/(ny-1)
  deltaz = (lz_cub-zmin)*re/nz



  write(namefile,'(a,i8.8,a)') './IBM/ibm_frz',ntime,'.vtr'

   ! vtr file writing
   open(143,file=trim(namefile),form = 'formatted',status='replace',access='stream',convert='big_endian')

! open(unit=70,file='./sc_compiled/input_ibm.f90',form='formatted',status='old',action='read')
   write(143,'(A)') '<VTKFile type="RectilinearGrid" version="0.1" byte_order="LittleEndian">'
   write(143,*) '<RectilinearGrid WholeExtent="',1,nx,1,ny,1,nz,'">'
   write(143,*) '<Piece Extent="',1,nx,1,ny,1,nz,'">'
   write(143,'(A)') '<PointData>'
   write(143,'(A)') '<DataArray type="Float32" Name="Force_ibm" NumberOfComponents="1" format="ascii">'
   write(143,*)     ibm_forza(1:nx,1:ny,1:nz)
   write(143,'(A)') '</DataArray>'
   write(143,'(A)') '</PointData>'
   write(143,'(A)') '<CellData>'
   write(143,'(A)') '</CellData>'
   write(143,'(A)') '<Coordinates>'
   write(143,'(A)') '<DataArray type="Float32" Name="X_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(143,*)     (xmin+(i-1.0)*deltax,i=1,nx)
   write(143,'(A)') '</DataArray>'
   write(143,'(A)') '<DataArray type="Float32" Name="Y_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(143,*)     (ymin+(i-1.0)*deltay,i=1,ny)
   write(143,'(A)') '</DataArray>'
   write(143,'(A)') '<DataArray type="Float32" Name="Z_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(143,*)     (cos(((i-1)*pi)/(nz-1))*re+re ,i=1,nz)!(zmin+(i-0.5)*deltaz,i=1,nz)
   write(143,'(A)') '</DataArray>'
   write(143,'(A)') '</Coordinates>'
   write(143,'(A)') '</Piece>'
   write(143,'(A)') '</RectilinearGrid>'
   write(143,'(A)') '</VTKFile> '

  close(143)

deallocate (ibm_forza)




return
end subroutine ibm_frc_write


subroutine ibm_object_gen(xh_lag,yh_lag, zh_lag,ind_eu, ntime)

use commondata
use grid
use sim_par
use ibm_membrane
use par_size
integer          :: ind_eu(nz_h,3), i, ii, jj, kk,i_bu
double precision, allocatable, dimension(:,:,:) :: ibm_forza
!double precision, dimension(nx,ny,nz) :: old_forza
double precision :: xmin, ymin, zmin, deltax, deltay, deltaz
integer          :: ntime
character(len=40):: namefile
!Indexes
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
!spreading
double precision :: expon,deltaxyz
double precision :: xh_lag(nz_h),yh_lag(nz_h), zh_lag(nz_h)
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz

call ibm_read_input

allocate (ibm_forza(nx,ny,nz))
ibm_forza=0.0d0
!write(*,*) "forza i_eul", ind_eu
!################# Support#######################################
do i=1,nz_h

if(tresd_sim.eq.0) then

do j=1,nx!2*tresd_supp+1
do k=1,2*ny_supp+1
do l=1,2*nz_supp+1

indx_supp(j)=j!ind_eu(i,1)+j-tresd_supp-1
! call period_supp(indx_supp(j), nx)
! dist_map_ibmx=x(indx_supp(j)) - (xh_lag(i)+lx_cub*lx_pos)
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag(i))

indy_supp(k)=ind_eu(i,2)+k-ny_supp-1
 ! call period_supp(indy_supp(k), ny)
 ! dist_map_ibmy=y(indy_supp(k)) - (yh_lag(i)+ly_cub*ly_pos)
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag(i))

indz_supp(l)=ind_eu(i,3)+l-nz_supp-1
call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag(i))
!#### detatchment

expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2 + (dist_map_ibmz)**2)&
-rad_esf)/(sqrt(2.0)*eta_sol))


deltaxyz=-expon/(1+expon)+1

ibm_forza(indx_supp(j),indy_supp(k), indz_supp(l))=deltaxyz

enddo
enddo
enddo

elseif(tresd_sim.eq.1) then

  do j=1,2*nx_supp+1
  do k=1,2*ny_supp+1
  do l=1,2*nz_supp+1

  indx_supp(j)=ind_eu(i,1)+j-nx_supp-1
  call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag(i))

  indy_supp(k)=ind_eu(i,2)+k-ny_supp-1
  call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag(i))

  indz_supp(l)=ind_eu(i,3)+l-nz_supp-1
  call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag(i))
  !#### detatchment

  expon=exp((sqrt((dist_map_ibmx)**2+&
  (dist_map_ibmy)**2 + (dist_map_ibmz)**2)&
  -rad_esf)/(sqrt(2.0)*eta_sol))


  deltaxyz=-expon/(1+expon)+1

  ibm_forza(indx_supp(j),indy_supp(k), indz_supp(l))=deltaxyz

  enddo
  enddo
  enddo

endif

enddo
ibm_forza=ibm_forza+old_forza
old_forza=ibm_forza

 ! Write VTK File
  xmin = 0.0d0
!  xmax = lx_cub
  ymin = 0.0d0
!  ymax = ly_cub
  zmin = 0.0d0
!  zmax = lz_cub
  deltax = (lx_cub-xmin)*re/(nx-1)
  deltay = (ly_cub-ymin)*re/(ny-1)
  deltaz = (lz_cub-zmin)*re/nz



  write(namefile,'(a,i8.8,a)') './IBM/ibm_patch',ntime,'.vtr'

   ! vtr file writing
   open(149,file=trim(namefile),form = 'formatted',status='replace',access='stream',convert='big_endian')

! open(unit=70,file='./sc_compiled/input_ibm.f90',form='formatted',status='old',action='read')
   write(149,'(A)') '<VTKFile type="RectilinearGrid" version="0.1" byte_order="LittleEndian">'
   write(149,*) '<RectilinearGrid WholeExtent="',1,nx,1,ny,1,nz,'">'
   write(149,*) '<Piece Extent="',1,nx,1,ny,1,nz,'">'
   write(149,'(A)') '<PointData>'
   write(149,'(A)') '<DataArray type="Float32" Name="Force_ibm" NumberOfComponents="1" format="ascii">'
   write(149,*)     ibm_forza(1:nx,1:ny,1:nz)
   write(149,'(A)') '</DataArray>'
   write(149,'(A)') '</PointData>'
   write(149,'(A)') '<CellData>'
   write(149,'(A)') '</CellData>'
   write(149,'(A)') '<Coordinates>'
   write(149,'(A)') '<DataArray type="Float32" Name="X_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(149,*)     (xmin+(i-1.0)*deltax,i=1,nx)
   write(149,'(A)') '</DataArray>'
   write(149,'(A)') '<DataArray type="Float32" Name="Y_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(149,*)     (ymin+(i-1.0)*deltay,i=1,ny)
   write(149,'(A)') '</DataArray>'
   write(149,'(A)') '<DataArray type="Float32" Name="Z_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(149,*)     (cos(((i-1)*pi)/(nz-1))*re+re ,i=1,nz)!(zmin+(i-0.5)*deltaz,i=1,nz)
   write(149,'(A)') '</DataArray>'
   write(149,'(A)') '</Coordinates>'
   write(149,'(A)') '</Piece>'
   write(149,'(A)') '</RectilinearGrid>'
   write(149,'(A)') '</VTKFile> '

  close(149)

deallocate (ibm_forza)

return
end subroutine ibm_object_gen

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

subroutine ibm_frc_write_rank(indics_eul, ntime,frz_ibm,i_budito)

use commondata
use grid
use sim_par
use ibm_membrane
use par_size
integer          :: indics_eul(nz_h,3), i, ii, jj, kk,i_budito
double precision, allocatable, dimension(:,:,:) :: ibm_forza
double precision :: frz_ibm(nx,nz,ny,3)
double precision :: xmin, ymin, zmin, deltax, deltay, deltaz
integer          :: ntime
character(len=40):: namefile



call ibm_read_input
allocate (ibm_forza(nx,ny,nz))
 ibm_forza=0.0d0


!

        do ii=1,nx
           do jj=1,ny
             do kk= 1,nz

             ibm_forza(ii,jj,kk)=sqrt((frz_ibm(ii,kk,jj,1)**2)&
             +  (frz_ibm(ii,kk,jj,2))**2&
             +  (frz_ibm(ii,kk,jj,3))**2)
             enddo
           enddo
        enddo



 ! Write VTK File
  xmin = 0.0d0
!  xmax = lx_cub
  ymin = 0.0d0
!  ymax = ly_cub
  zmin = 0.0d0
!  zmax = lz_cub
  deltax = (lx_cub-xmin)*re/(nx-1)
  deltay = (ly_cub-ymin)*re/(ny-1)
  deltaz = (lz_cub-zmin)*re/nz



  write(namefile,'(a,i8.8,a,i8.8,a)') './IBM/ibm_frz',i_budito,'_',ntime,'.vtr'

   ! vtr file writing
   open(143,file=trim(namefile),form = 'formatted',status='replace',access='stream',convert='big_endian')

! open(unit=70,file='./sc_compiled/input_ibm.f90',form='formatted',status='old',action='read')
   write(143,'(A)') '<VTKFile type="RectilinearGrid" version="0.1" byte_order="LittleEndian">'
   write(143,*) '<RectilinearGrid WholeExtent="',1,nx,1,ny,1,nz,'">'
   write(143,*) '<Piece Extent="',1,nx,1,ny,1,nz,'">'
   write(143,'(A)') '<PointData>'
   write(143,'(A)') '<DataArray type="Float32" Name="Force_ibm" NumberOfComponents="1" format="ascii">'
   write(143,*)     ibm_forza(1:nx,1:ny,1:nz)
   write(143,'(A)') '</DataArray>'
   write(143,'(A)') '</PointData>'
   write(143,'(A)') '<CellData>'
   write(143,'(A)') '</CellData>'
   write(143,'(A)') '<Coordinates>'
   write(143,'(A)') '<DataArray type="Float32" Name="X_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(143,*)     (xmin+(i-1.0)*deltax,i=1,nx)
   write(143,'(A)') '</DataArray>'
   write(143,'(A)') '<DataArray type="Float32" Name="Y_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(143,*)     (ymin+(i-1.0)*deltay,i=1,ny)
   write(143,'(A)') '</DataArray>'
   write(143,'(A)') '<DataArray type="Float32" Name="Z_COORDINATES" NumberOfComponents="1" format="ascii">'
   write(143,*)     (cos(((i-1)*pi)/(nz-1))*re+re ,i=1,nz)!(zmin+(i-0.5)*deltaz,i=1,nz)
   write(143,'(A)') '</DataArray>'
   write(143,'(A)') '</Coordinates>'
   write(143,'(A)') '</Piece>'
   write(143,'(A)') '</RectilinearGrid>'
   write(143,'(A)') '</VTKFile> '

  close(143)

deallocate (ibm_forza)
return
end subroutine ibm_frc_write_rank

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

subroutine ibm_lag_to_vtk(xh_l,yh_l, zh_l, ntime)

use commondata
use grid
use sim_par
use ibm_membrane

integer          ::  i, j!indics_eul(nz_h,3,2),
double precision :: xh_l(nz_h), yh_l(nz_h), zh_l(nz_h)
!double precision, allocatable, dimension(:,:,:) :: ibm_eu
double precision :: xmin, ymin, zmin, deltax, deltay, deltaz
integer          :: ntime
character(len=40):: namefile
call ibm_read_input

  xmin = 0.0d0
!  xmax = lx_cub
  ymin = 0.0d0
!  ymax = ly_cub
  zmin = 0.0d0
!  zmax = lz_cub
  deltax = (lx_cub-xmin)/nx_h
  deltay = (ly_cub-ymin)/ny_h
  deltaz = (lz_cub-zmin)/nz_h



  write(namefile,'(a,i8.8,a)') './IBM/lagi_',ntime,'.vtk'

   ! vtr file writing
open(76,file=trim(namefile),form = 'formatted',status='replace',access='stream',convert='big_endian')

! open(unit=70,file='./sc_compiled/input_ibm.f90',form='formatted',status='old',action='read')
 write(76,'(A)') '# vtk DataFile Version 2.0'
 write(76,'(A)') 'Lagrangians'
   write(76,'(A)') 'ASCII'
   write(76,*)
    write(76,'(A)') 'DATASET UNSTRUCTURED_GRID'
    write(76,*) 'POINTS', nz_h, 'float'
 do i=1,nz_h
   write(76,*) (xh_l(i)+lx_cub*0.5)*re , (yh_l(i) +ly_cub*0.5)*re, (zh_l(i)+1.0d0)*re
 enddo
   write(76,*)
!   write(76,*) 'POINT_DATA', nz_h
!   write(76,'(A)') ' SCALARS ', ' lagi ', 'double'
!   write(76,'(A)') 'LOOKUP_TABLE default'
!   write(76,*)
!   do j=1,nz_h
!     write(76,*) 1.0d0
!   enddo
!   write(76,*)

close(76)

return
end subroutine ibm_lag_to_vtk



subroutine ibm_particulas(xh_l,yh_l, zh_l, ntime)

use commondata
use grid
use sim_par
use ibm_membrane

character(len=10) :: lf
character(len=80) :: buffer
character(len=16) :: str4
character(len=40):: namefile
integer          ::  i, j
double precision :: xh_l(nz_h), yh_l(nz_h), zh_l(nz_h)
integer          :: ntime

call ibm_read_input


lf=achar(10)
write(str4(1:16),'(i16)') nz_h


write(namefile,'(a,i8.8,a)') './IBM/laguna_',ntime,'.vtk'
if(rank.eq.0) then

   ! vtr file writing
open(555,file=trim(namefile),form = 'unformatted',&
status='new',access='stream',convert='big_endian')

buffer='# vtk DataFile Version 3.0'//lf
write(555) trim(buffer)
buffer='Particle data'//lf
write(555) trim(buffer)

buffer='BINARY'//lf
write(555) trim(buffer)
buffer='DATASET UNSTRUCTURED_GRID'//lf
write(555) trim(buffer)
buffer='POINTS '//str4//' float'//lf
write(555) trim(buffer)
do i=1,nz_h
write(555) real(xh_l(i)),real(yh_l(i)), real(zh_l(i))
enddo

buffer='CELL_TYPES'//str4//lf
write(555) trim(buffer)
do i=1,nz_h
 write(555) 1 ! cell type 1, VTK_VERTEX
enddo

buffer='POINT_DATA '//str4//lf
write(555) trim(buffer)
buffer='SCALARS position integer 1'//lf
write(555) trim(buffer)
buffer='LOOKUP_TABLE default'//lf
write(555) trim(buffer)
do i=1,nz_h
 write(555) 1 ! empty buffer
enddo

buffer=lf
write(555) trim(buffer)

close(555,status='keep')
endif
return
end subroutine ibm_particulas


subroutine write_vel(zh_l,vel_lag,time_step)!(xh_l,yh_l, zh_l,vel_lag, time_step,f_hyd, mass_vel_lag, lag_mass_p)

use commondata
use grid
use sim_par
use ibm_membrane
double precision :: zh_l
double precision :: vel_lag(3)
double precision :: f_hyd(3)
double precision :: area_cross, vel_part_diff
double precision :: yh_l_old,vel_old,cd_drag_old,width_part,time_step_old, dtime_sec
!double precision :: mass_vel_lag(nz_h,3), lag_mass_p(nz_h,3), mass_vel_old, lag_mass
integer:: i,time_step

area_cross=pi*((rad_esf*h_dim)**2) !Physical meters2
width_part=1.0!(0.001*h_dim)   !Physical meters
dtime_sec=dt*sqrt(h_dim)/(froude_ibm*sqrt(9.81))

vel_lag(:)=vel_lag(:)*froude_ibm*sqrt(9.81*h_dim) !m/s
!f_hyd(:)=f_hyd(:)*9.81*(froude_ibm**2)    !m/s2*kg Newtons

open(unit=13,file='./IBM/daty.dat' ,access='direct',recl=132,form='formatted')


if ((time_step/1000).gt.1) then
! --- read all force, vel, pos etc
!read(13,'(f20.12,f20.8,f20.8,f20.8,f20.8,f20.8)',rec=time_step/1000 - 1) time_step_old, yh_l_old, vel_old, &
!cd_drag_old, mass_vel_old, lag_mass

!------ read just vel, position and time
read(13,'(f20.12,f20.8,f20.8)',rec=time_step/1000 - 1) time_step_old, yh_l_old, vel_old

elseif ((time_step/1000).eq.1) then
time_step_old=0.0d0
yh_l_old=0.0d0
vel_old=0.0d0
cd_drag_old=0.0d0
mass_vel_old=0.0d0
lag_mass=0.0d0
endif

vel_part_diff=vel_lag(3) - vel_old!sum(vel_lag(3)) - vel_old       !m/s
!drag=-f_hyd(3)+ (rho_fld*area_cross*width_part*vel_part_diff/dtime_sec)  !Newton

!cd_drag=2.0d0*abs(drag)/(rho_fld*(rad_esf*h_dim)*width_part*((vel_part_diff+vel_old)**2))
!if (cd_drag.gt.1e+6) cd_drag=0.0d0

!do i=1,nz_h
!----------      writing veloc and drag
!write(13,'(f20.12,f20.8,f20.8,f20.8,f20.8,f20.8,a)',rec=time_step/1000) dble(time_step*dtime_sec), &
!(zh_l(nz_h)+1.0)*h_dim ,vel_part_diff+vel_old , cd_drag,&
!mass_vel_lag(nz_h,3)*froude_ibm*sqrt(9.81*h_dim), lag_mass_p(nz_h,3)*h_dim, char(10)
!-------------- writing just velocities and position in z
write(13,'(f20.12,f20.8,f20.8,a)',rec=time_step/1000) dble(time_step*dtime_sec), &
(zh_l+1.0)*h_dim ,vel_part_diff+vel_old , char(10)

!enddo

close(13)


end subroutine write_vel
