subroutine move_lagrangian_point_positions(del_t, xL_P, yL_P, zL_P,&
indics_eul, perxzy)
use commondata
use par_size !paralelization chunks
use grid
use sim_par  !pi, simulation parameters
use ibm_membrane

integer          :: indics_eul(nz_h,3),i,j
double precision :: xL_P(nz_h), yL_P(nz_h), zL_P(nz_h)
double precision :: diste_l(nz_h,3,2*n_supp+1)
!double precision :: u_e(2*n_supp+1,2*n_supp+1,2*n_supp+1),&
!v_e(2*n_supp+1,2*n_supp+1,2*n_supp+1), w_e(2*n_supp+1,2*n_supp+1,2*n_supp+1)
double precision :: delta_k(nz_h,3,2*n_supp+1), rez_esf(2*n_supp+1)
double precision :: perxzy(nz_h,3)
double precision :: del_t
double precision :: r_g(nz_h,3)
double precision :: ang_vel(3)
! write(*,*) "w_e",w_e
!Find the indices of the points (xi, zk, yj) in EULERIAN FRAME
call delta_indices(xL_P, yL_P, zL_P, indics_eul, diste_l)
!  call delta_kernel(diste_l, indics_eul,delta_k, rez_esf)

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  call center_grav(xL_P, yL_P, zL_P, r_g)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!call perturbed_distance(u_e,v_e,w_e,delta_k, indics_eul, perxzy, r_g,&
!  ang_vel,xL_P,yL_P,zL_P)

!  call rot_lag_pts(del_t, xL_P, yL_P, zL_P, r_g, ang_vel)

! call collision_contrib(del_t,diste_l,indics_eul,perxzy,zL_P)
!
!        xL_P(:)=xL_P(:) + del_t*(perxzy(:,1))
!
!        yL_P(:)=yL_P(:) + del_t*(perxzy(:,2))
!
!        zL_P(:)=zL_P(:) + del_t*(perxzy(:,3))
!#
! call delta_indices(xL_P, yL_P, zL_P, indics_eul, diste_l)
!#
write(*,*) 'perxzy(:,2),perxzy(:,3)' , perxzy(:,2), perxzy(:,3)
return
end subroutine move_lagrangian_point_positions

subroutine move_lagrangian_point_positions_half(del_t, xL_P, yL_P, zL_P,xL_P_half,&
yL_P_half, zL_P_half,indics_eul_half, perxzy)
use commondata
use par_size !paralelisation chunks
use grid
use sim_par  !pi, simulation parameters
use ibm_membrane

integer          :: indics_eul(nz_h,3),i,j
double precision :: xL_P(nz_h), yL_P(nz_h), zL_P(nz_h)
double precision :: diste_l(nz_h,3,2*n_supp+1)
!double precision :: u_e(2*n_supp+1,2*n_supp+1,2*n_supp+1),&
!v_e(2*n_supp+1,2*n_supp+1,2*n_supp+1), w_e(2*n_supp+1,2*n_supp+1,2*n_supp+1)
double precision :: delta_k(nz_h,3,2*n_supp+1), rez_esf(2*n_supp+1)
double precision :: perxzy(nz_h,3)
double precision :: del_t
double precision :: r_g(nz_h,3)
double precision :: ang_vel(3)
!half-
double precision :: xL_P_half(nz_h), yL_P_half(nz_h), zL_P_half(nz_h)
integer          :: indics_eul_half(nz_h,3)
!Find the indices of the points (xi, zk, yj) in EULERIAN FRAME
!perxzy=0.0d0

call delta_indices(xL_P, yL_P, zL_P, indics_eul, diste_l)
!  call delta_kernel(diste_l, indics_eul,delta_k, rez_esf)

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  call center_grav(xL_P, yL_P, zL_P, r_g)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!call perturbed_distance(u_e,v_e,w_e,delta_k, indics_eul, perxzy, r_g,&
!ang_vel,xL_P,yL_P,zL_P)

!  call rot_lag_pts(del_t, xL_P, yL_P, zL_P, r_g, ang_vel)

! call collision_contrib(del_t,diste_l,indics_eul,perxzy,zL_P_half)
!        xL_P_half(:)=xL_P(:) + del_t*(perxzy(:,1))
!
!        yL_P_half(:)=yL_P(:) + del_t*(perxzy(:,2))
!
!        zL_P_half(:)=zL_P(:) + del_t*(perxzy(:,3))
! !#
! call delta_indices(xL_P_half, yL_P_half, zL_P_half, indics_eul_half, diste_l)
!#
write(*,*) 'perxzy(:,2),perxzy(:,3)' , perxzy(:,2), perxzy(:,3)
return
end subroutine move_lagrangian_point_positions_half



subroutine delta_indices(xh_lag, yh_lag, zh_lag, eul_indics, dis)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane

!interpolated indices in eulerian and eulerian-lagrangian distance
integer :: i, k, ii, indic_supp_u, indic_supp_l
integer :: eul_indics(nz_h,3)
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h), z_bef(nz_h)
integer, dimension(1) :: x_e_in, y_e_in, z_e_in
double precision :: distancex,distancey,distancez
double precision :: e_x, e_y, e_z
double precision :: dis(nz_h,3,2*n_supp+1)
! double precision :: perxzy(nz_h,3)

do i=1,nz_h

  x_e_in= minloc(abs(x - (xh_lag(i) + lx_cub*lx_pos)))!int((nx)*(xh_lag(i) + lx_cub*0.5)/lx_cub +1)

  y_e_in= minloc(abs(y - (yh_lag(i) + ly_cub*ly_pos)))!int((ny)*(yh_lag(i) + ly_cub*0.5)/ly_cub +1)

  z_e_in= minloc(abs(z-  (zh_lag(i) + lz_cub*lz_pos)))!int((abs(acos(p_new))*((nz-1)/pi))+1)

   eul_indics(i,1)=x_e_in(1)
   eul_indics(i,2)=y_e_in(1)
   eul_indics(i,3)=z_e_in(1)
if(eul_indics(i,3).le.0) then
write(*,*)'eul_indics(i,3), zh_lag(i)', eul_indics(i,3), zh_lag(i)
endif
!---------------%%%%%%%Periodicity%%%%%%%%%%%%%%--------------------------
!-------------In y---------------------------------------------------------
!do j=1,2
 if((yh_lag(i) + ly_cub*ly_pos).gt.ly_cub)then
 yh_lag(i)=yh_lag(i)-ly_cub
 y_e_in= minloc(abs(y - (yh_lag(i) + ly_cub*ly_pos)))!int((ny)*(yh_lag(i) + ly_cub*0.5)/ly_cub +1)
 eul_indics(i,2)=y_e_in(1)
endif
!enddo

!---------------------- reversa--------------------------------------------
!do j=1,2
 if((yh_lag(i) + ly_cub*ly_pos).lt.0)then
 yh_lag(i)=yh_lag(i) + ly_cub
 y_e_in= minloc(abs(y - (yh_lag(i) + ly_cub*ly_pos)))!int((ny)*(yh_lag(i) + ly_cub*0.5)/ly_cub +1)
 eul_indics(i,2)=y_e_in(1)
 endif
!enddo
!--- in x------------------------------------------------------------------
!do j=1,2
 if((xh_lag(i) + lx_cub*lx_pos).gt.lx_cub) then
 xh_lag(i)=xh_lag(i)-lx_cub
 x_e_in= minloc(abs(x - (xh_lag(i) + lx_cub*lx_pos)))!int((nx)*(xh_lag(i) + lx_cub*0.5)/lx_cub +1)
 eul_indics(i,1)=x_e_in(1)
 endif
!enddo

!do j=1,2
 if((xh_lag(i) + lx_cub*lx_pos).lt.0)then
 xh_lag(i)=xh_lag(i) + lx_cub
 x_e_in= minloc(abs(x - (xh_lag(i) + lx_cub*lx_pos)))!int((nx)*(xh_lag(i) + lx_cub*0.5)/lx_cub +1)
 eul_indics(i,1)=x_e_in(1)
 endif
!enddo


!----------%%%% END Wall boundary cndtn in Z %%%------------------------------------
 e_x=x(eul_indics(i,1))
 e_y=y(eul_indics(i,2))
 e_z=z(eul_indics(i,3))
 distancex=abs( e_x - (xh_lag(i) + lx_cub*lx_pos))
 distancey=abs( e_y - (yh_lag(i) + ly_cub*ly_pos))
 distancez=abs( e_z - (zh_lag(i) - lz_cub*lz_pos))
 dis(i,1,n_supp+1)= distancex
 dis(i,2,n_supp+1)= distancey
 dis(i,3,n_supp+1)= distancez
!--------adding support cells------------------------------------------------------
if(tresd_sim.eq.0) then
tresd_supp=0
do ii=1,2*n_supp+1
!###################### 2D simulation ########################################
indy_supp(ii)=eul_indics(i,2)+ii-n_supp-1
call period_supp(indy_supp(ii), ny)
indz_supp(ii)=eul_indics(i,3)+ii-n_supp-1
call period_supp_z(indz_supp(ii), nz)

dis(i,2,ii)= abs(y(indy_supp(ii)) - (yh_lag(i) + ly_cub*ly_pos))
call period_dis(dis(i,2,ii),eul_indics(i,2),ii, ny, ly_cub)

dis(i,3,ii)= abs(z(indz_supp(ii)) - (zh_lag(i) + lz_cub*lz_pos))
enddo

do ii=1,nx!2*tresd_supp+1
indx_supp(ii)=ii!eul_indics(i,1)+ii-tresd_supp-1
call period_supp(indx_supp(ii), nx)

 dis(i,1,ii)= abs(x(indx_supp(ii)) - (xh_lag(i) + lx_cub*lx_pos))
 call period_dis(dis(i,1,ii),eul_indics(i,1),ii, nx, lx_cub)
enddo
 !###################### 3D simulation ##############
elseif(tresd_sim.eq.1) then
do ii=1,2*n_supp+1
indx_supp(ii)=eul_indics(i,1)+ii-n_supp-1
call period_supp(indx_supp(ii), nx)

indy_supp(ii)=eul_indics(i,2)+ii-n_supp-1
call period_supp(indy_supp(ii), ny)
indz_supp(ii)=eul_indics(i,3)+ii-n_supp-1
call period_supp_z(indz_supp(ii), nz)


dis(i,1,ii)= abs(x(indx_supp(ii)) - (xh_lag(i) + lx_cub*lx_pos))
call period_dis(dis(i,1,ii),eul_indics(i,1),ii, nx, lx_cub)

dis(i,2,ii)= abs(y(indy_supp(ii)) - (yh_lag(i) + ly_cub*ly_pos))
call period_dis(dis(i,2,ii),eul_indics(i,2),ii, ny, ly_cub)

dis(i,3,ii)= abs(z(indz_supp(ii)) - (zh_lag(i) + lz_cub*lz_pos))
enddo

endif

!-------------------------------------------------------


enddo


return
end subroutine delta_indices



subroutine center_grav(xh_lag, yh_lag, zh_lag, r_g)
use commondata
!use par_size
!use grid
use sim_par
use ibm_membrane
double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h)
double precision :: lag_cg(3)
double precision :: r_g(nz_h,3)

lag_cg(1)=sum(xh_lag(:))/size(xh_lag(:)) !Geometric center x
lag_cg(2)=sum(yh_lag(:))/size(yh_lag(:)) !Geometric center y
lag_cg(3)=sum(zh_lag(:))/size(zh_lag(:)) !Geometric center z

r_g(:,1)=(xh_lag(:)-lag_cg(1))
r_g(:,2)=(yh_lag(:)-lag_cg(2))
r_g(:,3)=(zh_lag(:)-lag_cg(3))
!write(*,*) lag_cg(1),lag_cg(2),lag_cg(3)
return
end subroutine center_grav



subroutine perturbed_distance(u_eu,v_eu,w_eu,delta_k,ind_eu, move_lag, &
r_g,ang_vel,xL_P,yL_P,zL_P)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i,j,k,l
integer          :: ind_eu(nz_h,3)
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
double precision :: dx, dy, dz(nz)
double precision :: u_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1),&
v_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1), w_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1)
double precision :: delta_k(nz_h,3,2*n_supp+1)!, rez_esf(2*n_supp+1)
double precision, allocatable, dimension(:,:) :: per!(nz_h,3,3)
double precision :: move_lag(nz_h,3)
double precision :: r_g(nz_h,3)
double precision :: ang_vel(3)
double precision :: zL_P(nz_h),xL_P(nz_h),yL_P(nz_h)
!spreading
double precision :: expon,deltaxyz
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
move_lag=0.0d0

dx=lx_cub/nx
dy=ly_cub/ny

do i=1,nz
 if (i.gt.3) then
 dz(i)=abs(cos(dble((i-1)*pi)/(nz-1)) - cos(dble((i-2)*pi)/(nz-1)))
 else
 dz(i)=abs(cos(0.0d0)-cos(pi/(nz-1)))
 endif
enddo
ang_vel=0.0d0
allocate(per(nz_h,3))
per=0.0d0

 !---------------------------------------------------------------------------
do i=1, nz_h

! if(tresd_sim.eq.0) then
! tresd_supp=0
! elseif(tresd_sim.eq.1) then
! tresd_supp=n_supp
! endif

 do j=1,2*n_supp+1
 do k=1,2*n_supp+1
 do l=1,2*n_supp+1

!Boundary periiodicity
indx_supp(j)=ind_eu(i,1)+j-n_supp-1
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xL_P(i))

indy_supp(k)=ind_eu(i,2)+k-n_supp-1
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yL_P(i))

indz_supp(l)=ind_eu(i,3)+l-n_supp-1
call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zL_P(i))

!# Grid Detatchment
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+(dist_map_ibmz)**2)&
-rad_esf)/(sqrt(2.0)*0.01))

!###############
deltaxyz=1/(1+expon) !-expon/(1+expon)+1!

per(i,1)=per(i,1)+u_eu(j,l,k)&
*deltaxyz!*(1/(n_supp**2))!delta_k(i,2,k)*delta_k(i,3,l)*dy*dz(ind_eu(i,3)+l-n_supp-1)*delta_k(i,1,j)*dx  !3D
per(i,2)=per(i,2)+v_eu(j,l,k)&
*deltaxyz!*(1/(n_supp**2))!delta_k(i,2,k)*delta_k(i,3,l)*dy*dz(ind_eu(i,3)+l-n_supp-1)*delta_k(i,1,j)*dx  !3D
per(i,3)=per(i,3)+w_eu(j,l,k)&
*deltaxyz!*(1/(n_supp**2))!delta_k(i,2,k)*delta_k(i,3,l)*dy*dz(ind_eu(i,3)+l-n_supp-1)*delta_k(i,1,j)*dx  !3D

 enddo
 enddo
 enddo


!  if(rank.le.ntask_gl) write(*,*) 'rank,per(:,3)', rank,'[', &
! per(:,3),']'
!  if(rank.le.ntask_gl) write(*,*) '                               '

 !----------------------------------------------------------------------------

!if((per(i,1,j).ne.0).or.(per(i,2,j).ne.0).or.(per(i,3,j).ne.0))then
! write(*,*) 'per(i,1,j),per(i,2,j),per(i,3,j)', per(i,1,j),per(i,2,j),per(i,3,j)
!endif
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!     if(memz(1,i).eq.1) then      !down
!     per(i,3)=-per(i,3)!per(i,3)+abs(per(i,3))*sqrt(1-sqrt(1 - (zL_P(i)-lz_cub*0.1 + 1)/lz_cub*0.2))
!     endif

!     if(memz(2,i).eq.1) then      !up
!     per(i,3)=-per(i,3)!per(i,3)-abs(per(i,3))*sqrt(1-sqrt(1 - (zL_P(i)-lz_cub*0.1 + 1)/lz_cub*0.2))
!     endif

!Rotation w
!if (r_g(i,3).eq.0) then
!    ang_vel(1)=ang_vel(1) + per(i,3)/r_g(i,2)
!    ang_vel(2)=ang_vel(2) - per(i,3)/r_g(i,1)

!  else
!    ang_vel(1)=ang_vel(1) + per(i,3)/r_g(i,2) - per(i,2)/r_g(i,3)
!    ang_vel(2)=ang_vel(2) + per(i,1)/r_g(i,3) - per(i,3)/r_g(i,1)

!endif
!   ang_vel(3)=ang_vel(2) + per(i,2)/r_g(i,1) - per(i,1)/r_g(i,2)
 enddo
!integral aprox for each Lag.pnt.

move_lag(:,:)=per(:,:)/((n_supp**3.0d0))

! do j=1,3
!  do k=1,2
!   move_lag(j,k)=sum(per(:,j,k))
!  enddo
! enddo

!write(*,*) move_lag(1,1), move_lag(2,1), move_lag(3,1)

deallocate(per)
return
end subroutine perturbed_distance



subroutine rot_lag_pts(del_t, xh_lag, yh_lag, zh_lag, r_g, ang_vel)

use commondata
!use par_size
!use grid
use sim_par
use ibm_membrane
double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h)
double precision :: r_g(nz_h,3)
double precision :: ang_vel(3)
double precision :: ang_rot(3)
double precision :: del_t

ang_rot(:)= ang_vel(:)*del_t
!write(*,*) ang_rot(1,1),ang_rot(2,1), ang_rot(3,1), del_t

!do j=1,2

!axis  z
!xh_lag(:)= (r_g(:,1))*cos(ang_rot(3)) - (r_g(:,2))*sin(ang_rot(3)) + (xh_lag(:) -r_g(:,1))!&
!yh_lag(:)= (r_g(:,1))*sin(ang_rot(3)) + (r_g(:,2))*cos(ang_rot(3)) + (yh_lag(:) -r_g(:,2)) !&

!_in y
!zh_lag(:)= (r_g(:,3))*cos(ang_rot(2)) - (r_g(:,1))*sin(ang_rot(2))+(zh_lag(:) - r_g(:,3))
!xh_lag(:)= (r_g(:,3))*sin(ang_rot(2)) + (r_g(:,1))*cos(ang_rot(2))+(xh_lag(:) - r_g(:,1))

!_in x
!yh_lag(:)= (r_g(:,2))*cos(ang_rot(1)) - (r_g(:,3))*sin(ang_rot(1)) + (yh_lag(:) - r_g(:,2))
!zh_lag(:)= (r_g(:,2))*sin(ang_rot(1)) + (r_g(:,3))*cos(ang_rot(1)) + (zh_lag(:) - r_g(:,3))
!enddo

return
end subroutine rot_lag_pts



subroutine move_massive_boundary(del_t, massiv_xyz, m_vel_lag)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i

double precision :: massiv_xyz(3)
double precision :: del_kern(nz_h,3,2*n_supp+1), rez_esf(2*n_supp+1)
double precision :: dx, dy, dz(nz)
double precision :: m_vel_lag(nz_h,3)
double precision :: r_g(nz_h,3)
double precision :: ang_vel(3),del_t

!r_g,ang_vel,massiv_xyz(:,3), rez_esf)
!call buoyancy_mass_vel_contrib(del_t,m_vel_lag)

!do i=1,nz_h
!write(*,*) "m_vel_lag(i,3) is antes?",massiv_xyz(i,3)
massiv_xyz(1)=massiv_xyz(1) + del_t*m_vel_lag(1,1)
massiv_xyz(2)=massiv_xyz(2) + del_t*m_vel_lag(1,2)
massiv_xyz(3)=massiv_xyz(3) + del_t*m_vel_lag(1,3)
!write(*,*) "delta_T", del_t


return
end subroutine move_massive_boundary

subroutine move_massive_boundary_half(del_t, massiv_xyz,  massiv_xyz_half,&
m_vel_lag)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i
double precision :: massiv_xyz(nz_h,3)
double precision :: mvel(nx,nz,ny,3),del_t
double precision :: del_kern(nz_h,3,2*n_supp+1), rez_esf(2*n_supp+1)
double precision :: dx, dy, dz(nz)
double precision :: m_vel_lag(nz_h,3)
double precision :: r_g(nz_h,3)
double precision :: ang_vel(3)
!half
double precision :: massiv_xyz_half(nz_h,3)

!call delta_kernel(dis, ind_eu ,del_kern, rez_esf)
!r_g,ang_vel,massiv_xyz(:,3), rez_esf)
!call buoyancy_mass_vel_contrib(del_t,m_vel_lag)

do i=1,nz_h

massiv_xyz_half(i,1)=massiv_xyz(i,1) + del_t*m_vel_lag(i,1)
massiv_xyz_half(i,2)=massiv_xyz(i,2) + del_t*m_vel_lag(i,2)
massiv_xyz_half(i,3)=massiv_xyz(i,3) + del_t*m_vel_lag(i,3)

enddo

return
end subroutine move_massive_boundary_half

subroutine collision_contrib(del_t,dis,ind_eu,m_vel_lag,zh_lag)
!############# collision #############################
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i,j,k
integer          :: ind_eu(nz_h,3)
!double precision :: mvel(nx,nz,ny,3)
double precision :: fz_pw!, allocatable, dimension(:,:,:) ::fz_pw
double precision :: m_vel_lag(nz_h,3)
double precision :: del_t
double precision :: dis(nz_h,3,2*n_supp+1)
double precision :: delta_k(nz_h,3,2*n_supp+1), rez_esf(nz_h,2*n_supp+1)
double precision :: zh_lag(nz_h)
!double precision :: frz_mass(nx,nz,ny,3)

!call delta_kernel(dis, ind_eu ,delta_k, rez_esf)
!allocate(fz_pw(nx,nz,ny))
fz_pw=0.0d0
call wall_col(ind_eu, zh_lag , fz_pw, m_vel_lag)

!do i=1,nz_h*ny_h
m_vel_lag(:,1)=m_vel_lag(:,1)
m_vel_lag(:,2)=m_vel_lag(:,2)
m_vel_lag(:,3)=m_vel_lag(:,3) +del_t*fz_pw/(froude_ibm**2.0d0)!(ind_eu(:,1),ind_eu(:,3),ind_eu(:,2))))!
!+del_t*max(abs(fz_pw(ind_eu(i,1),ind_eu(i,3),ind_eu(i,2))))
!enddo
!deallocate(fz_pw)

return
end subroutine collision_contrib

subroutine update_massive_boundary_vel_half(del_t,m_vel_lag,frz_mass,&
 ind_eu,m_vel_lag_half)
!############# Buoyancy Force #############################
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i,j,k
integer          :: ind_eu(nz_h,3)
double precision :: m_vel_lag(nz_h,3),m_vel_lag_half(nz_h,3)
double precision :: del_t
double precision :: frz_mass(nx,nz,ny,3),fmx,fmy,fmz
double precision :: sol_f(3),sol_fprev(3)
!integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)

!write(*,*) 'inde_eux, ind_euy, ind_euz', '[', ind_eu,']'
do i=1,nz_h
fmx=0.0d0
fmy=0.0d0
fmz=0.0d0
! do j=1,2*n_supp+1
! do k=1,2*n_supp+1
! do l=1,2*n_supp+1
!
! indx_supp(j)=ind_eu(i,1)+j-n_supp-1
! call period_supp(indx_supp(j), nx)
! indy_supp(k)=ind_eu(i,2)+k-n_supp-1
! call period_supp(indy_supp(k), ny)
! indz_supp(l)=ind_eu(i,3)+l-n_supp-1
! call period_supp_z(indz_supp(l), nz)
!
! fmx=fmx+frz_mass(indx_supp(j), indz_supp(l),indy_supp(k),1)
! fmy=fmy+frz_mass(indx_supp(j), indz_supp(l),indy_supp(k),2)
! fmz=fmz+frz_mass(indx_supp(j), indz_supp(l),indy_supp(k),3)
!
! enddo
! enddo
! enddo
!
! !########### Integral average ##########
! fmx=fmx/(n_supp**3)
! fmy=fmy/(n_supp**3)
! fmz=fmz/(n_supp**3)
! !#######################################

m_vel_lag(i,1)=0.0d0!m_vel_lag(i,1) -  del_t*(solid_force(1))/(rho_part-rho_fld)!
m_vel_lag(i,2)=m_vel_lag(i,2) -  del_t*(sol_f(2))/(rho_part*9.81*(froude_ibm**2))!!/(rho_part-rho_fld)!
m_vel_lag(i,3)=m_vel_lag(i,3) -  del_t*(sol_f(3))/(rho_part*9.81*(froude_ibm**2))&
- del_t/(froude_ibm**2)!(rho_part-rho_fld) - del_t/(froude_ibm**2)!

enddo
return
end subroutine update_massive_boundary_vel_half

subroutine update_massive_boundary_vel(del_t,m_vel_lag,frz_mass,&
 ind_eu)
!############# Buoyancy Force #############################
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i,j,k
integer          :: ind_eu(nz_h,3)
double precision :: m_vel_lag(nz_h,3)
double precision :: del_t
double precision :: frz_mass(nx,nz,ny,3),fmx,fmy,fmz
!integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
double precision :: sol_f(3),sol_fprev(3)

do i=1,nz_h
fmx=0.0d0
fmy=0.0d0
fmz=0.0d0
! do j=1,2*n_supp+1
! do k=1,2*n_supp+1
! do l=1,2*n_supp+1
!
! indx_supp(j)=ind_eu(i,1)+j-n_supp-1
! call period_supp(indx_supp(j), nx)
! indy_supp(k)=ind_eu(i,2)+k-n_supp-1
! call period_supp(indy_supp(k), ny)
! indz_supp(l)=ind_eu(i,3)+l-n_supp-1
! call period_supp_z(indz_supp(l), nz)
!
! fmx=fmx+frz_mass(indx_supp(j), indz_supp(l),indy_supp(k),1)
! fmy=fmy+frz_mass(indx_supp(j), indz_supp(l),indy_supp(k),2)
! fmz=fmz+frz_mass(indx_supp(j), indz_supp(l),indy_supp(k),3)
!
! enddo
! enddo
! enddo
!
! !########### Integral average ##########
! fmx=fmx/(n_supp**3)
! fmy=fmy/(n_supp**3)
! fmz=fmz/(n_supp**3)
! !########################################
m_vel_lag(i,1)=0.0d0!m_vel_lag(i,1) -  del_t*(solid_force(1))/(rho_part-rho_fld)!
m_vel_lag(i,2)=m_vel_lag(i,2) -  del_t*(sol_f(2))/(rho_part*9.81*(froude_ibm**2))!!/(rho_part-rho_fld)!
m_vel_lag(i,3)=m_vel_lag(i,3) -  del_t*(sol_f(3))/(rho_part*9.81*(froude_ibm**2))&
- del_t/(froude_ibm**2)!(rho_part-rho_fld) - del_t/(froude_ibm**2)!

enddo
return
end subroutine update_massive_boundary_vel


subroutine massive_lag_force(ind_eu,xh_lag,yh_lag,zh_lag,frz_mass,massiv_xyz, dis, dtempo)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i, ii, count_force
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
double precision :: massiv_xyz(nz_h,3)
double precision :: frz_mass(nx,nz,ny,3)
double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h)
double precision, allocatable, dimension(:,:,:) :: fz_pw
integer          :: ind_eu(nz_h,3)
double precision ::kstiff, ds
double precision ::dmp_lpx,dmp_lpy
double precision :: delta_k(nz_h,3,2*n_supp+1), rez_esf(2*n_supp+1)
double precision :: del_kern_force(nx,nz,ny,2*n_supp+1)
double precision :: dis(nz_h,3,2*n_supp+1)
double precision :: m_vel_lag(nz_h,3)
double precision :: dV_xs2s1, dV_ys2s1, dV_zs2s1, b_d_spring,dtempo
double precision :: dx,dy,dfs
!spreading
double precision :: expon,deltaxyz
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
double precision :: sol_f(3),sol_fprev(3)

! kstiff=5.6e+14    !kg/s2
! kstiff=kstiff/(rho_fld*9.81*(froude_ibm**2))

vel_shear=dyn_visc*re/(rho_fld*h_dim) !shear velocity
dfs=4.0d0/3.0d0*(pi*(rad_esf)**3) ! volume of the body
kstiff=5.6e+12    !kg/s2
kstiff=kstiff!*(h_dim**2)/(100*rho_part*(vel_shear**2))!(dfs*rho_part*(vel_shear**2))  !Withoud froude acceleartion units force


frz_mass=0.0d0
dx=lx_cub/nx
dy=ly_cub/ny
ds=dx*dy*dy
!dfs=(2*(rad_esf-0.05))**3
!write(*,*) "dfs", 2*rad_esf/dy
b_d_spring=5.0e-5 !5000 seems to be a base value then 8000 improves the situation. While we grow, we dump faster the distance
count_force=0
do i=1,nz_h

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!periodicity force correction

!Distance Mass to lagpoint
dmp_lpx=0.d0
dmp_lpy=0.d0
!-------------------------------x---------------------------------------------------------------
dmp_lpx=massiv_xyz(i,1)-xh_lag(i)
call period_forc_dist(dmp_lpx, lx_cub)
!------------------------------y--------------------------------------------------------------------
dmp_lpy=massiv_xyz(i,2)-yh_lag(i)
call period_forc_dist(dmp_lpy, ly_cub)

!########
dV_xs2s1=massiv_xyz(i,1)-xh_lag(i)
call period_forc_dist(dV_xs2s1, lx_cub)
dV_ys2s1=massiv_xyz(i,2)-yh_lag(i)
call period_forc_dist(dV_ys2s1, ly_cub)
dV_zs2s1=massiv_xyz(i,3)-zh_lag(i)

dV_xs2s1=dV_xs2s1/dtempo
dV_ys2s1=dV_ys2s1/dtempo
dV_zs2s1=dV_zs2s1/dtempo
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sol_f(1)=kstiff*(dmp_lpx)/dfs

sol_f(2)=kstiff*(dmp_lpy)/dfs

sol_f(3)=kstiff*(massiv_xyz(i,3)-zh_lag(i))/dfs

enddo
!call delta_kernel(dis, ind_eu ,delta_k, rez_esf, fz_massiv)
!################# Support#######################################
do i=1,nz_h
if(tresd_sim.eq.0) then

do j=1,nx!2*tresd_supp+1
do k=1,2*n_supp+1
do l=1,nz!do k=1,2*n_supp+1


indx_supp(j)=j!ind_eu(i,1)+j-tresd_supp-1
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag(i))

indy_supp(k)=ind_eu(i,2)+k-n_supp-1
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag(i))

! indz_supp(l)=ind_eu(i,3)+l-n_supp-1
! call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag(i))

!######### grid detatchment
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+ (z(l)-(zh_lag(i) - lz_cub*lz_pos))**2)&
-rad_esf)/(sqrt(2.0)*eta_sol))
!#############################
deltaxyz=1/(1+expon)

if(deltaxyz.gt.0.5d0)then !just the important
count_force=count_force+1
endif
frz_mass(indx_supp(j), l,indy_supp(k),1)=&
frz_mass(indx_supp(j), l,indy_supp(k),1)+&
sol_f(1)*deltaxyz!*(2*rad_esf)**3!/ds

frz_mass(indx_supp(j), l,indy_supp(k),2)=&
frz_mass(indx_supp(j), l,indy_supp(k),2)+&
sol_f(2)*deltaxyz!*(2*rad_esf)**3!/ds

frz_mass(indx_supp(j), l,indy_supp(k),3)=&
frz_mass(indx_supp(j), l,indy_supp(k),3)+&
sol_f(3)*deltaxyz!*(2*rad_esf)**3!/ds

enddo
enddo
enddo

frz_mass=frz_mass/(count_force)  !Integral average
elseif(tresd_sim.eq.1) then

do j=1,2*n_supp+1
do k=1,2*n_supp+1
do l=1,nz!do k=1,2*n_supp+1

indx_supp(j)=ind_eu(i,1)+j-n_supp-1
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag(i))

indy_supp(k)=ind_eu(i,2)+k-n_supp-1
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag(i))

! indz_supp(l)=ind_eu(i,3)+l-n_supp-1
! call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag(i))

!######### grid detatchment
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+ (z(l)-(zh_lag(i) - lz_cub*lz_pos))**2)&
-rad_esf)/(sqrt(2.0)*eta_sol))
!#############################
deltaxyz=1/(1+expon)

if(deltaxyz.gt.0.5d0)then
count_force=count_force+1
endif
frz_mass(indx_supp(j), l,indy_supp(k),1)=&
frz_mass(indx_supp(j), l,indy_supp(k),1)+&
sol_f(1)*deltaxyz!*(2*rad_esf)**3!/ds

frz_mass(indx_supp(j), l,indy_supp(k),2)=&
frz_mass(indx_supp(j), l,indy_supp(k),2)+&
sol_f(2)*deltaxyz!*(2*rad_esf)**3!/ds

frz_mass(indx_supp(j), l,indy_supp(k),3)=&
frz_mass(indx_supp(j), l,indy_supp(k),3)+&
sol_f(3)*deltaxyz!*(2*rad_esf)**3!/ds

enddo
enddo
enddo

frz_mass=frz_mass/(count_force)  !Integral average
endif

enddo

return
end subroutine massive_lag_force

!############Solid Volume fraction #############################################

subroutine svf_force(velpred,m_vel_lag,ind_eu,xh_lag,yh_lag,zh_lag,frz_mass,&
massiv_xyz, dis, dtempo, sol_f, sol_fprev,  id_rigid)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
use phase_field
use three_phase

integer          :: i, ii, count_force
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
double precision :: massiv_xyz(nz_h,3)
double precision :: frz_mass(nx,nz,ny,3)
double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h)
double precision, allocatable, dimension(:,:,:) :: fz_pw
integer          :: ind_eu(nz_h,3)
double precision ::kstiff, ds
double precision ::dmp_lpx,dmp_lpy
double precision :: delta_k(nz_h,3,2*n_supp+1), rez_esf(2*n_supp+1)
double precision :: del_kern_force(nx,nz,ny,2*n_supp+1)
double precision :: dis(nz_h,3,2*n_supp+1)
double precision :: dV_xs2s1, dV_ys2s1, dV_zs2s1, b_d_spring,dtempo
double precision :: dx,dy,dfs
!spreading
double precision :: expon,deltaxyz
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
!Solid Volume fraction
double precision :: m_vel_lag(nz_h,3)
double precision :: velpred(3)
double precision :: sol_f(3),sol_fprev(3)
!immersersed Voulume Fraction
integer :: id_rigid

frz_mass=0.0d0
dx=lx_cub/nx
dy=ly_cub/ny
ds=dx*dy*dy
dfs=4.0d0/3.0d0*(pi*(rad_esf)**3) ! volume of the body
!write(*,*) "dfs", 2*rad_esf/dy
b_d_spring=5.0e-5 !5000 seems to be a base value then 8000 improves the situation. While we grow, we dump faster the distance
count_force=0
! Saving force of a previous step
sol_fprev(:) = sol_f(:)

do i=1,nz_h
!Distance Mass to lagpoint
dmp_lpx=0.d0
dmp_lpy=0.d0
!-------------------------------x---------------------------------------------------------------
dmp_lpx=massiv_xyz(i,1)-xh_lag(i)
call period_forc_dist(dmp_lpx, lx_cub)
!------------------------------y--------------------------------------------------------------------
dmp_lpy=massiv_xyz(i,2)-yh_lag(i)
call period_forc_dist(dmp_lpy, ly_cub)

vel_shear=dyn_visc*re/(rho_fld*h_dim) !shear velocity

sol_f(1)=(m_vel_lag(1,1) - velpred(1))/(dtempo)

sol_f(2)=(m_vel_lag(1,2) - velpred(2))/(dtempo)

sol_f(3)=(m_vel_lag(1,3) - velpred(3))/(dtempo)

enddo
!call delta_kernel(dis, ind_eu ,delta_k, rez_esf, fz_massiv)
!################# Support#######################################
do i=1,nz_h
if(tresd_sim.eq.0) then

do j=1,nx!2*tresd_supp+1
do k=1,2*n_supp+1
do l=1,nz!do k=1,2*n_supp+1


indx_supp(j)=j!ind_eu(i,1)+j-tresd_supp-1
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag(i))

indy_supp(k)=ind_eu(i,2)+k-n_supp-1
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag(i))

! indz_supp(l)=ind_eu(i,3)+l-n_supp-1
! call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag(i))

!######### grid detatchment
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+ (z(l)-(zh_lag(i) - lz_cub*lz_pos))**2)&
-rad_esf)/(sqrt(2.0)*eta_sol))
!#############################
deltaxyz=1.0d0/(1.0d0+expon)

if(deltaxyz.gt.0.5d0)then
count_force=count_force+1
endif
frz_mass(indx_supp(j), l,indy_supp(k),1)=&
frz_mass(indx_supp(j), l,indy_supp(k),1)+&
sol_f(1)*deltaxyz!*(2*rad_esf)**3!/ds

frz_mass(indx_supp(j), l,indy_supp(k),2)=&
frz_mass(indx_supp(j), l,indy_supp(k),2)+&
sol_f(2)*deltaxyz!*(2*rad_esf)**3!/ds

frz_mass(indx_supp(j), l,indy_supp(k),3)=&
frz_mass(indx_supp(j), l,indy_supp(k),3)+&
sol_f(3)*deltaxyz!*(2*rad_esf)**3!/ds

enddo
enddo
enddo

frz_mass=frz_mass!*((1.0d0-immers(id_rigid))+rhor*immers(id_rigid))  !immersersed body average
elseif(tresd_sim.eq.1) then

do j=1,2*n_supp+1
do k=1,2*n_supp+1
do l=1,nz!do k=1,2*n_supp+1

indx_supp(j)=ind_eu(i,1)+j-n_supp-1
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag(i))

indy_supp(k)=ind_eu(i,2)+k-n_supp-1
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag(i))

! indz_supp(l)=ind_eu(i,3)+l-n_supp-1
! call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag(i))

!######### grid detatchment
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+ (z(l)-(zh_lag(i) - lz_cub*lz_pos))**2)&
-rad_esf)/(sqrt(2.0)*eta_sol))
!#############################
deltaxyz=1.0d0/(1.0d0+expon)

if(deltaxyz.gt.0.5d0)then
count_force=count_force+1
endif
frz_mass(indx_supp(j), l,indy_supp(k),1)=&
frz_mass(indx_supp(j), l,indy_supp(k),1)+&
sol_f(1)*deltaxyz!*(2*rad_esf)**3!/ds

frz_mass(indx_supp(j), l,indy_supp(k),2)=&
frz_mass(indx_supp(j), l,indy_supp(k),2)+&
sol_f(2)*deltaxyz!*(2*rad_esf)**3!/ds

frz_mass(indx_supp(j), l,indy_supp(k),3)=&
frz_mass(indx_supp(j), l,indy_supp(k),3)+&
sol_f(3)*deltaxyz!*(2*rad_esf)**3!/ds

enddo
enddo
enddo

frz_mass=frz_mass!*((1.0d0-immers(id_rigid))+rhor*immers(id_rigid))  !immersersed body average
endif

enddo

return
end subroutine svf_force

subroutine svf_update_mvel(del_t,m_vel_lag,m_vel_lag_n&
, m_vel_lag_prev, sol_f, sol_fprev, id_rigid)
!############# Buoyancy Force #############################
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
use three_phase
use phase_field

integer          :: i,j,k
!integer          :: ind_eu(nz_h,3)
double precision :: m_vel_lag(nz_h,3), m_vel_lag_prev(nz_h,3)&
,m_vel_lag_n(nz_h,3)
double precision :: del_t
double precision :: frz_mass(nx,nz,ny,3),fmx,fmy,fmz,dfs
double precision :: sol_f(3),sol_fprev(3)
integer:: id_rigid
double precision :: rho_m
!integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)

!vel_shear=dyn_visc*re/(rho_fld*h_dim) !shear velocity
dfs=4.0d0/3.0d0*(pi*(rad_esf**3))

rho_m=rho_fld*((1.0d0-immers(id_rigid))+rhor*immers(id_rigid))!rho_fld*rhor

do i=1,nz_h

m_vel_lag(i,1)=m_vel_lag(i,1)! - del_t*(rho_fld/rho_part)&
 !*(1.5d0*sol_f(1) - 0.5d0*sol_fprev(1))+&
 !(rho_fld/rho_part)*(m_vel_lag(i,1) - m_vel_lag_prev(i,1))

m_vel_lag(i,2)=m_vel_lag(i,2) !- del_t*(rho_fld/rho_part)&
!*(1.5d0*sol_f(2) - 0.5d0*sol_fprev(2))+&
!(rho_fld/rho_part)*(m_vel_lag(i,1) - m_vel_lag_prev(i,1))

m_vel_lag(i,3)=m_vel_lag(i,3) - del_t*((rho_m)/rho_part)&
*(sol_f(3)/tau_fld)+&
0.5*(rho_m/rho_part)*(m_vel_lag(i,3) - m_vel_lag_prev(i,3))&
- del_t*((rho_part-rho_m)/rho_part)/(froude_ibm**2)!

enddo
relfluidrhobud(id_rigid)=rho_m
addedmassbud(id_rigid)=0.5*(rho_m/rho_part)*(m_vel_lag(1,3) - m_vel_lag_prev(1,3))/del_t
dragforcebud(id_rigid)=(rho_m/rho_part)*(sol_f(3))
buoyforcebud(id_rigid)=((rho_part-rho_m)/rho_part)/(froude_ibm**2)

return
end subroutine svf_update_mvel




subroutine svf_move_massive(del_t, massiv_xyz, m_vel_lag, vel_pred)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i

double precision :: massiv_xyz(3)
double precision :: del_kern(nz_h,3,2*n_supp+1), rez_esf(2*n_supp+1)
double precision :: dx, dy, dz(nz)
double precision :: m_vel_lag(nz_h,3), vel_pred(3)
double precision :: r_g(nz_h,3)
double precision :: ang_vel(3),del_t

!r_g,ang_vel,massiv_xyz(:,3), rez_esf)
!call buoyancy_mass_vel_contrib(del_t,m_vel_lag)
vel_shear=dyn_visc*re/(rho_fld*h_dim) !shear velocity


!do i=1,nz_h
!write(*,*) "m_vel_lag(i,3) is antes?",massiv_xyz(i,3)
massiv_xyz(1)=massiv_xyz(1) + (del_t)*(m_vel_lag(1,1))!+m_vel_lag_h(1,1))/2.0d0
massiv_xyz(2)=massiv_xyz(2) + (del_t)*(m_vel_lag(1,2))!+m_vel_lag_h(1,2))/2.0d0
massiv_xyz(3)=massiv_xyz(3) + (del_t)*(m_vel_lag(1,3))!+m_vel_lag_h(1,3))/2.0d0
!write(*,*) "delta_T", del_t


return
end subroutine svf_move_massive

!#######################end of SVF ########################################################
subroutine delta_kernel_force(eul_indics ,del_kern,del_kern_force)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane

integer :: i
integer :: eul_indics(nz_h,3)
double precision :: del_kern(nz_h,3,2*n_supp+1)
double precision :: del_kern_force(nx,nz,ny,2*n_supp+1)

do i=1, nz_h
 del_kern_force(eul_indics(i,1),eul_indics(i,3),eul_indics(i,2),1)=&
 del_kern(i,1,1)*del_kern(i,2,1)*del_kern(i,3,1)
 do j=1, n_supp

 del_kern_force(eul_indics(i,1)+j,eul_indics(i,3)+j,eul_indics(i,2)+j,1+j)=&
 del_kern(i,1,1+j)*del_kern(i,2,1+j)*del_kern(i,3,1+j)

 del_kern_force(eul_indics(i,1)-j,eul_indics(i,3)-j,eul_indics(i,2)-j,1+n_supp+j)=&
 del_kern(i,1,1+n_supp+j)*del_kern(i,2,1+n_supp+j)*del_kern(i,3,1+n_supp+j)

 enddo
enddo
return
end subroutine delta_kernel_force



subroutine massive_indices(massiv_lag, eul_indics, dis)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane

!interpolated indices in eulerian and eulerian-lagrangian distance
integer :: eul_indics(nz_h,3)
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
double precision :: massiv_lag(nz_h,3),z_bef(nz_h)
integer, dimension(1) :: x_e_in, y_e_in, z_e_in
integer :: i, k, ii, indic_supp_u, indic_supp_l
double precision :: e_x, e_y, e_z
double precision :: mvel(nx,nz,ny,3), dis(nz_h,3,2*n_supp+1)
double precision :: distancex,distancey,distancez
! double precision :: m_vel_lag(nz_h,3)

do i=1,nz_h

x_e_in=  minloc(abs(x-(massiv_lag(i,1) + lx_cub*lx_pos)))!int((nx)*(massiv_lag(i,1) + lx_cub*0.5)/lx_cub +1)

y_e_in=  minloc(abs(y-(massiv_lag(i,2) + ly_cub*ly_pos)))!int((ny)*(massiv_lag(i,2) + ly_cub*0.5)/ly_cub +1)

z_e_in=  minloc(abs(z-(massiv_lag(i,3) + lz_cub*lz_pos)))!int((abs(acos(p_new))*((nz-1)/pi))+1)


eul_indics(i,1)=x_e_in(1)
eul_indics(i,2)=y_e_in(1)
eul_indics(i,3)=z_e_in(1)
!----------------------Periodicity---------------------------------------
!-------------In y---------------------------------------------------------


  if((massiv_lag(i,2) + ly_cub*ly_pos).gt.ly_cub)then

   massiv_lag(i,2)=massiv_lag(i,2)-ly_cub
   y_e_in= minloc(abs(y-(massiv_lag(i,2) + ly_cub*ly_pos)))!int((ny)*(massiv_lag(i,2) + ly_cub*0.5)/ly_cub +1)
   eul_indics(i,2)=y_e_in(1)
   endif

!---------------------- reversa--------------------------------------------

  if((massiv_lag(i,2) + ly_cub*0.5).lt.0)then

  massiv_lag(i,2)=massiv_lag(i,2) + ly_cub
  y_e_in= minloc(abs(y-(massiv_lag(i,2) + ly_cub*ly_pos)))!int((ny)*(massiv_lag(i,2) + ly_cub*0.5)/ly_cub +1)
  eul_indics(i,2)=y_e_in(1)
  endif


!--- in x------------------------------------------------------------------
 if((massiv_lag(i,1) + lx_cub*lx_pos).gt.lx_cub)then

 massiv_lag(i,1)=massiv_lag(i,1)-lx_cub
 x_e_in= minloc(abs(x-(massiv_lag(i,1) + lx_cub*lx_pos)))!int((nx)*(massiv_lag(i,1) + lx_cub*0.5)/lx_cub +1)
 eul_indics(i,1)=x_e_in(1)
 endif

 if((massiv_lag(i,1) + lx_cub*lx_pos).lt.0)then

 massiv_lag(i,1)=massiv_lag(i,1) + lx_cub
 x_e_in= minloc(abs(x-(massiv_lag(i,1) + lx_cub*lx_pos)))!int((nx)*(massiv_lag(i,1) + lx_cub*0.5)/lx_cub +1)
 eul_indics(i,1)=x_e_in(1)
 endif

 !%%%%%%%%% distances %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 e_x=x(eul_indics(i,1))
 e_y=y(eul_indics(i,2))
 e_z=z(eul_indics(i,3))

 distancex=abs( e_x - (massiv_lag(i,1) + lx_cub*lx_pos))
 distancey=abs( e_y - (massiv_lag(i,2) + ly_cub*ly_pos))
 distancez=abs( e_z - (massiv_lag(i,3) - lz_cub*lz_pos))
 dis(i,1,n_supp+1)= distancex
 dis(i,2,n_supp+1)= distancey
 dis(i,3,n_supp+1)= distancez

!--------adding support cells------------------------------------------------------
if(tresd_sim.eq.0) then

do ii=1,2*n_supp+1

indy_supp(ii)=eul_indics(i,2)+ii-n_supp-1
call period_supp(indy_supp(ii), ny)
indz_supp(ii)=eul_indics(i,3)+ii-n_supp-1
call period_supp_z(indz_supp(ii), nz)

dis(i,2,ii)= abs(y(indy_supp(ii)) - (massiv_lag(i,2) + ly_cub*ly_pos))
call period_dis(dis(i,2,ii),eul_indics(i,2),ii, ny, ly_cub)

dis(i,3,ii)= abs(z(indz_supp(ii)) - (massiv_lag(i,3) + lz_cub*lz_pos))

enddo

do ii=1,nx!2*tresd_supp+1
indx_supp(ii)=ii!eul_indics(i,1)+ii-tresd_supp-1
call period_supp(indx_supp(ii), nx)
!############################## 2D simulation #######################################
dis(i,1,ii)= abs(x(indx_supp(ii)) - (massiv_lag(i,1) + lx_cub*lx_pos))
call period_dis(dis(i,1,ii),eul_indics(i,1),ii, nx, lx_cub)
!####################################################################################

enddo
!3D simulations
elseif(tresd_sim.eq.1) then

do ii=1,2*n_supp+1

indx_supp(ii)=eul_indics(i,1)+ii-n_supp-1   !3D
call period_supp(indx_supp(ii), nx)
indy_supp(ii)=eul_indics(i,2)+ii-n_supp-1
call period_supp(indy_supp(ii), ny)
indz_supp(ii)=eul_indics(i,3)+ii-n_supp-1
call period_supp_z(indz_supp(ii), nz)

!############################## 2D simulation #######################################
dis(i,1,ii)= abs(x(indx_supp(ii)) - (massiv_lag(i,1) + lx_cub*lx_pos))
call period_dis(dis(i,1,ii),eul_indics(i,1),ii, nx, lx_cub)
!####################################################################################
dis(i,2,ii)= abs(y(indy_supp(ii)) - (massiv_lag(i,2) + ly_cub*ly_pos))
call period_dis(dis(i,2,ii),eul_indics(i,2),ii, ny, ly_cub)

dis(i,3,ii)= abs(z(indz_supp(ii)) - (massiv_lag(i,3) + lz_cub*lz_pos))

enddo
endif



enddo

return
end subroutine massive_indices


subroutine give_me_periodic_index(ii, eul_ind,num_cellsx, indic_supp_u, indic_supp_l)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane

integer :: indic_supp_u,indic_supp_l, ii, eul_ind, num_cellsx

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!%
!%       Function to check boundary and
!%       Periodicity in x and y eulerian
!%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!%
if(eul_ind+ii .gt. num_cellsx) then
indic_supp_u=eul_ind-num_cellsx
else
indic_supp_u=eul_ind
endif
if(eul_ind-ii .lt. num_cellsx) then
indic_supp_l=eul_ind+num_cellsx
else
indic_supp_l=eul_ind
endif

return
end subroutine


subroutine wall_col(eul_indics, lgz, f_pw, vibm)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i, ii, j
integer          :: eul_indics(nz_h,3)
double precision :: vibm(nz_h,3), vibm_prom, f_pw!(nx,nz,ny)
double precision :: f_pw_temp!, allocatable, dimension(:,:,:) ::f_pw_temp
double precision :: c1, diff,dz(nz), tol,diffup
double precision :: lgz(nz_h)
double precision :: dy, eps_1, eps_2

eps_1=0.5*0.25    !8.0e-4 |   0.5*0.25    !fenj2005
eps_2=0.02    !1.0e-5 |   0.02  fenj2005

vibm_prom=vibm(1,3)/nz_h!sum(vibm(:,3))/nz_h
c1=(1.0d0-rho_fld/rho_part) !-2*(vibm_prom**2)/(rad_esf*2)   !

do ii=1,nz
if (ii.ge.3) then
 dz(ii)=abs(cos(dble((ii-1)*pi)/(nz-1)) - cos(dble((ii-2)*pi)/(nz-1)))
 else
 dz(ii)=abs(cos(0.0d0)-cos(pi/(nz-1)))
 endif
enddo

tol=0.25*rad_esf!0.0d0
! do j=1,n_supp+1
! tol=tol+dz(j)
! enddo

dy=ly_cub/ny
!rad_esf= n_supp*dy


!allocate(f_pw_temp(nx,nz,ny))
f_pw_temp=0.0d0
do i=1,nz_h

diff=(lgz(i) + 0.5*lz_cub) + rad_esf !La differcence du particle et son reflex
diffup=(lgz(i) + 0.5*lz_cub) - (lz_cub+rad_esf)  !La differcence du particle et son reflex

if ((abs(diff).gt.2*rad_esf).and.(abs(diff).le.(2*rad_esf+tol)))then

!f_pw_temp(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))=&
f_pw_temp=(c1/eps_1)*(((abs(diff) - 2*rad_esf - tol)/tol)**2)*(diff/abs(diff))
write(*,*) 'estoy en lw mild collision'

elseif (abs(diff).lt.2*rad_esf) then

!f_pw_temp(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))=&
f_pw_temp=(c1/eps_1)*((((abs(diff) - 2*rad_esf - tol)/tol)**2)&
+ (c1/eps_2)*((2*rad_esf- abs(diff))/tol))*(diff/abs(diff))

write(*,*) 'estoy en lw hard collision'

endif


if ((abs(diffup).gt.2*rad_esf).and.(abs(diffup).le.(2*rad_esf+tol)))then

!f_pw_temp(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))=&
f_pw_temp=(c1/eps_1)*(((abs(diffup) - 2*rad_esf - tol)/tol)**2)*(diffup/abs(diffup))
write(*,*) 'estoy en tw mild collision'

elseif (abs(diffup).lt.2*rad_esf) then

!f_pw_temp(eul_indics(i,1), eul_indics(i,3) ,eul_indics(i,2))=&
f_pw_temp=(c1/eps_1)*((((abs(diffup) - 2*rad_esf - tol)/tol)**2)&
+ (c1/eps_2)*((2*rad_esf- abs(diffup))/tol))*(diffup/abs(diffup))

write(*,*) 'estoy en tw hard collision'

endif
enddo


f_pw=f_pw_temp
!write(*,*) sum(f_pw)
! deallocate(f_pw_temp)
return
end subroutine wall_col


subroutine period_supp(indx_supp, num_cellx)

integer ::  indx_supp, num_cellx
if((indx_supp).gt.num_cellx)  indx_supp=indx_supp-num_cellx
if((indx_supp).lt.1)  indx_supp=indx_supp+num_cellx
return
end subroutine period_supp


subroutine period_supp_z(indx_supp, num_cellx)

integer ::  indx_supp, num_cellx
if((indx_supp).gt.num_cellx)  indx_supp=num_cellx
if((indx_supp).lt.1)  indx_supp=1
return
end subroutine period_supp_z

subroutine period_supp_distx(dist,long_x, posit_x,indx_supp, num_cellx,xh_c)
 use grid
integer ::  indx_supp, num_cellx
double precision :: dist,long_x,posit_x
double precision :: xh_c

if(((indx_supp).gt.num_cellx).and.(mod(indx_supp,num_cellx).ne.0)) then
  indx_supp=mod(indx_supp,num_cellx)
dist=x(indx_supp) - (xh_c+long_x*posit_x)
dist=long_x-dabs(dist)
elseif((indx_supp.lt.0).and.(mod(indx_supp,num_cellx).ne.0)) then
  indx_supp=num_cellx-mod(abs(indx_supp),num_cellx)
dist=x(indx_supp) - (xh_c+long_x*posit_x)
dist=long_x-dabs(dist)
elseif((mod(indx_supp,num_cellx).eq.0).and.(indx_supp.lt.1)) then
  indx_supp=num_cellx-mod(abs(indx_supp),num_cellx)
dist=x(indx_supp) - (xh_c+long_x*posit_x)
dist=long_x-dabs(dist)
elseif((mod(indx_supp,num_cellx).eq.0).and.(indx_supp.gt.num_cellx)) then
  indx_supp=num_cellx-mod(abs(indx_supp),num_cellx)
dist=x(indx_supp) - (xh_c+long_x*posit_x)
else
dist=x(indx_supp) - (xh_c+long_x*posit_x)
endif

return
end subroutine period_supp_distx

subroutine period_supp_disty(dist,long_x, posit_x,indx_supp, num_cellx,yh_c)
 use grid
integer ::  indx_supp, num_cellx
double precision :: dist,long_x,posit_x
double precision :: yh_c

if((indx_supp).gt.num_cellx) then
  indx_supp=mod(indx_supp,num_cellx)
dist=y(indx_supp) - (yh_c+long_x*posit_x)
dist=long_x-dabs(dist)
elseif((indx_supp).lt.1) then
  indx_supp=num_cellx-mod(abs(indx_supp),num_cellx)
dist=y(indx_supp) - (yh_c+long_x*posit_x)
dist=long_x-dabs(dist)
elseif((indx_supp).eq.0) then
  indx_supp=num_cellx-mod(abs(indx_supp),num_cellx)
  dist=y(indx_supp) - (yh_c+long_x*posit_x)
  dist=long_x-dabs(dist)
else
dist=y(indx_supp) - (yh_c+long_x*posit_x)
endif

return
end subroutine period_supp_disty

subroutine period_supp_distz(dist,long_x, posit_x,indx_supp, num_cellx,zh_c)
 use grid
integer ::  indx_supp, num_cellx
double precision :: dist,long_x,posit_x
double precision :: zh_c

if((indx_supp).gt.num_cellx) then
  indx_supp=num_cellx
dist=z(indx_supp) - (zh_c+long_x*posit_x)
elseif((indx_supp).lt.1) then
  indx_supp=1
dist=z(indx_supp) - (zh_c+long_x*posit_x)
else
dist=z(indx_supp) - (zh_c+long_x*posit_x)
endif

return
end subroutine period_supp_distz

subroutine period_dis(dis,indx,ii, num_cellx, long_x)
use ibm_membrane

integer ::  ii,num_cellx, indx
double precision :: dis, long_x

if(((indx+ii-n_supp-1).gt.num_cellx)&
.or.((indx+ii-n_supp-1).lt.1)) dis=abs(long_x-dis)

return
end subroutine

subroutine period_forc_dist(dis, long_x)

double precision :: dis, long_x

  if(abs(dis).gt.long_x*0.5) then
    dis=sign(1.0d0,dis)*abs(long_x-abs(dis))
  endif

return
end subroutine



subroutine indx_box_ibm(xh_lag, yh_lag, zh_lag, indx_box)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane

integer :: i, k, ii,jj,kk, indic_supp_u, indic_supp_l
integer :: eul_indics(3)
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
double precision :: xh_lag, yh_lag, zh_lag
integer, dimension(1) :: x_e_in, y_e_in, z_e_in
double precision :: distancex,distancey,distancez
double precision :: e_x, e_y, e_z
double precision :: dis(3,2*n_supp+1)
integer, dimension(6) :: indx_box

! do jj=1,nz_h
!   do kk=1,n_budies
    x_e_in= minloc(abs(x - (xh_lag + lx_cub*0.5)))!int((nx)*(xh_lag(i) + lx_cub*0.5)/lx_cub +1)

    y_e_in= minloc(abs(y - (yh_lag + ly_cub*0.5)))!int((ny)*(yh_lag(i) + ly_cub*0.5)/ly_cub +1)

    z_e_in= minloc(abs(z-  (zh_lag - lz_cub*0.0)))!int((abs(acos(p_new))*((nz-1)/pi))+1)

    eul_indics(1)=x_e_in(1)
    eul_indics(2)=y_e_in(1)
    eul_indics(3)=z_e_in(1)

!---------------%%%%%%%Periodicity%%%%%%%%%%%%%%--------------------------
!-------------In y---------------------------------------------------------

  if((yh_lag + ly_cub*0.5).gt.ly_cub)then
    yh_lag=yh_lag-ly_cub
    y_e_in= minloc(abs(y - (yh_lag + ly_cub*0.5)))!int((ny)*(yh_lag(i) + ly_cub*0.5)/ly_cub +1)
    eul_indics(2)=y_e_in(1)
  endif

!---------------------- reversa--------------------------------------------
!do j=1,2
   if((yh_lag + ly_cub*0.5).lt.0)then
   yh_lag=yh_lag + ly_cub
   y_e_in= minloc(abs(y - (yh_lag + ly_cub*0.5)))!int((ny)*(yh_lag(i) + ly_cub*0.5)/ly_cub +1)
   eul_indics(2)=y_e_in(1)
   endif
     !enddo
  !--- in x------------------------------------------------------------------
  !do j=1,2
   if((xh_lag + lx_cub*0.5).gt.lx_cub) then
   xh_lag=xh_lag-lx_cub
   x_e_in= minloc(abs(x - (xh_lag + lx_cub*0.5)))!int((nx)*(xh_lag(i) + lx_cub*0.5)/lx_cub +1)
   eul_indics(1)=x_e_in(1)
   endif
  !enddo

   if((xh_lag + lx_cub*0.5).lt.0)then
   xh_lag=xh_lag + lx_cub
   x_e_in= minloc(abs(x - (xh_lag + lx_cub*0.5)))!int((nx)*(xh_lag(i) + lx_cub*0.5)/lx_cub +1)
   eul_indics(1)=x_e_in(1)
   endif

if(tresd_sim.eq.0) then

do ii=1,2*n_supp+1

  indy_supp(ii)=eul_indics(2)+ii-n_supp-1
call period_supp(indy_supp(ii), ny)
  indz_supp(ii)=eul_indics(3)+ii-n_supp-1
call period_supp_z(indz_supp(ii), nz)

enddo

do ii=1,nx!2*tresd_supp+1

  indx_supp(ii)=ii!eul_indics(1)+ii-tresd_supp-1
call period_supp(indx_supp(ii), nx)
enddo
!3D simulations
elseif(tresd_sim.eq.1) then

do ii=1,2*n_supp+1

  indx_supp(ii)=eul_indics(1)+ii-n_supp-1
call period_supp(indx_supp(ii), nx)
  indy_supp(ii)=eul_indics(2)+ii-n_supp-1
call period_supp(indy_supp(ii), ny)
  indz_supp(ii)=eul_indics(3)+ii-n_supp-1
call period_supp_z(indz_supp(ii), nz)

enddo
endif



  indx_box(1)=eul_indics(1)-n_supp
  indx_box(2)=eul_indics(1)+n_supp
  indx_box(3)=eul_indics(2)-n_supp
  indx_box(4)=eul_indics(2)+n_supp
  indx_box(5)=eul_indics(3)-n_supp
  indx_box(6)=eul_indics(3)+n_supp

! enddo
! enddo

end subroutine indx_box_ibm



subroutine aura_psi(xh_l, yh_l, zh_l,psi_co)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i,j,k,l
integer          :: ind_eu(nz_h,3)
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
!spreading
double precision :: expon,deltaxyz
double precision :: psi_co(2*n_supp+1,2*n_supp+1,2*n_supp+1)
double precision :: dis(nz_h,3,2*n_supp+1)
double precision :: xh_l(nz), yh_l(nz), zh_l(nz)
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz

call delta_indices(xh_l, yh_l, zh_l, ind_eu, dis)
do i=1, nz_h

if(tresd_sim.eq.0) then
tresd_supp=0
elseif(tresd_sim.eq.1) then
tresd_supp=n_supp
endif

do j=1,nx!2*tresd_supp+1
do k=1,2*n_supp+1
do l=1,2*n_supp+1

!Boundary periiodicity
indx_supp(j)=j!ind_eu(i,1)+j-tresd_supp-1
! dist_map_ibmx=x(indx_supp(j)) - (xh_l(1)+lx_pos*lx_cub)
! call period_supp(indx_supp(j), nx)
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_l(i))

indy_supp(k)=ind_eu(i,2)+k-n_supp-1
! dist_map_ibmy=y(indy_supp(k)) - (yh_l(1)+ly_pos*ly_cub)
! call period_supp(indy_supp(k), ny)
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_l(i))

indz_supp(l)=ind_eu(i,3)+l-n_supp-1
! dist_map_ibmz=z(indz_supp(l)) - (zh_l(1)+lz_pos*lz_cub)
call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_l(i))

!# Grid Detatchement
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+(dist_map_ibmz)**2)&
-rad_esf)/(sqrt(2.0)*0.01))
!####

psi_co(j,l,k)=1.0*expon/(1+expon)**2

enddo
enddo
enddo
enddo


end subroutine aura_psi

subroutine psi_ibm_ini(xh_l,yh_l,zh_l)

use commondata
use par_size
use phase_field
use grid
use ibm_membrane
use surfactant
double precision :: xh_l(nz_h), yh_l(nz_h), zh_l(nz_h),psi_co
!double precision :: xl_c,yl_c,zl_c
integer   :: i,j,k
integer :: jg,kg
double precision :: dis(nz_h,3,2*n_supp+1)
integer          :: ind_eu(nz_h,3)

call delta_indices(xh_l, yh_l, zh_l, ind_eu, dis)

do j=1,fpy
  do k=1,fpz
    do i=1,nx
      jg=fstart(3)+j
      kg=fstart(2)+k

! expon=exp(((sqrt((x(i) - x(ind_eu(1,1)))**2+(y(jg) - y(ind_eu(1,2)))**2+(z(kg) - z(ind_eu(1,3)))**2))&
! -rad_esf)/(sqrt(2.0)*0.01))
!##Grid detatchement
expon=exp((sqrt((x(i) - (xh_l(1)+lx_pos*lx_cub))**2+&
(y(jg) - (yh_l(1)+ly_pos*ly_cub))**2+&
(z(kg) - (zh_l(1)+lz_pos*lz_cub))**2)&
-rad_esf)/(sqrt(2.0)*0.01))
!###########
psi_co=expon/(1+expon)**2 !4.0*

      if(psi_co.gt.0.1)then !.ne.0
        if(psi(i,k,j).ne.0.0)then
          psi(i,k,j)=(psi(i,k,j)+psi_co)*0.5
        else
          psi(i,k,j)=psi_co
        endif
      endif
    enddo
  enddo
enddo

return
end subroutine psi_ibm_ini
