!######################### Direct forcing with solid volume fraction ##################

subroutine svf_solver_1st(xh_lag, yh_lag, zh_lag,&
lag_mass_p, mass_vel_lag, mass_vel_lag_n, mass_vel_lag_prev&
,perxzy,f_hyd, sol_f, sol_f_prev, id_rigbody)

use commondata
use par_size !paralelisation chunks
use grid
use sim_par  !pi, simulation parameters
use ibm_membrane
use phase_field
use three_phase

#define masspoint_flag masspointflag
integer          :: indics_eul(nz_h,3),i
double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h)
double precision :: lag_mass_p(nz_h,3)
integer :: eul_ind_mass(nz_h,3)
double precision :: mass_dis(nz_h,3,2*n_supp+1)
double precision :: mass_vel_lag(nz_h,3),perxzy(3),&
 mass_vel_lag_prev(nz_h,3)
double precision :: f_hyd(3)
!half_step_varuables
double precision :: xh_lag_half(nz_h), yh_lag_half(nz_h), zh_lag_half(nz_h)
double precision :: lag_mass_p_half(nz_h,3),mass_vel_lag_n(nz_h,3)
integer          :: indics_eul_half(nz_h,3)
integer :: eul_ind_mass_half(nz_h,3)
double precision :: sol_f(3),sol_f_prev(3)
integer :: id_rigbody

mass_vel_lag_prev = mass_vel_lag_n
mass_vel_lag_n  = mass_vel_lag
!calculating v^{n+1} and saving v^{n-1}
call svf_update_mvel(dt,mass_vel_lag,mass_vel_lag_n,&
 mass_vel_lag_prev, sol_f, sol_f_prev, id_rigbody)

!################################ V.5.1######################################################
return
end subroutine svf_solver_1st


subroutine svf_solver_2nd(xh_lag, yh_lag, zh_lag,&
frz_ibm_svf, lag_mass_pepe, mass_vel_lag,&
perxzy,f_hyd, sol_f, sol_f_prev, id_rigbody)

use commondata
use par_size !paralelisation chunks
use grid
use sim_par  !pi, simulation parameters
use ibm_membrane
use phase_field
use three_phase

#define masspoint_flag masspointflag
integer          :: indics_eul(nz_h,3),i
double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h)
double precision :: frz_ibm_svf(nx,nz,ny,3)
double precision :: lag_mass_pepe(3)
integer :: eul_ind_mass(nz_h,3)
double precision :: mass_dis(nz_h,3,2*n_supp+1)
double precision :: mass_vel_lag(nz_h,3), perxzy(3)
double precision :: f_hyd(3)
!half variables
!double precision :: mass_vel_lag_half(nz_h,3)
double precision :: sol_f(3),sol_f_prev(3)
integer :: id_rigbody
call ibm_read_input

!Step 7: Time advance dt
! call move_lagrangian_point_positions(dt, xh_lag, yh_lag,&
! zh_lag, indics_eul, perxzy)

!write(*,*) 'after move_lagrangian_point_positions'
#if masspoint_flag == 1
! mass_vel_lag_half(1,:)=perxzy(:)

call massive_indices(lag_mass_pepe, eul_ind_mass, mass_dis)

call svf_force(perxzy,mass_vel_lag,eul_ind_mass,xh_lag, yh_lag, zh_lag,&
frz_ibm_svf,lag_mass_pepe, mass_dis, dt, sol_f, sol_f_prev, id_rigbody)

! call svf_update_mvel(dt,mass_vel_lag,eul_ind_mass) !Gravity contribution to velocity

call svf_move_massive(dt, lag_mass_pepe,&
mass_vel_lag,perxzy )

call collision_contrib(dt,mass_dis,eul_ind_mass,mass_vel_lag,zh_lag)

#endif



return
end subroutine svf_solver_2nd




! subroutine ibm_solver_1st(xh_lag, yh_lag, zh_lag,&
!  frz_ibm, lag_mass_p, mass_vel_lag,mass_vel_lag_half, rest_length, ang_bend, lenteja,&
!  rest_inv_beam,perxzy,f_hyd)
!
! use commondata
! use par_size !paralelisation chunks
! use grid
! use sim_par  !pi, simulation parameters
! use ibm_membrane
! #define masspoint_flag masspointflag
! integer          :: indics_eul(nz_h,3),i
! double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h)
! !double precision :: u_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1),&
! !v_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1), w_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1)
! double precision :: frz_ibm(nx,nz,ny,3)
! !integer :: memy_pass(nz_h,3), memly_pass(nz_h,3)
! double precision :: lag_mass_p(nz_h,3)
! double precision :: mass_vel(nx,nz,ny,3)
! double precision, allocatable, dimension (:,:,:,:)::frz_massiv
! double precision :: rest_length(nz_h), lenteja(nz_h)
! double precision :: ang_bend(nz_h,3)
! double precision :: rest_inv_beam(nz_h,3)
!
! integer :: eul_ind_mass(nz_h,3)
! double precision :: mass_dis(nz_h,3,2*n_supp+1)
! double precision :: mass_vel_lag(nz_h,3),perxzy(nz_h,3)
! double precision :: f_hyd(3)
! !half_step_varuables
! double precision :: xh_lag_half(nz_h), yh_lag_half(nz_h), zh_lag_half(nz_h)
! double precision :: lag_mass_p_half(nz_h,3),mass_vel_lag_half(nz_h,3)
! integer          :: indics_eul_half(nz_h,3)
! integer :: eul_ind_mass_half(nz_h,3)
!
! call ibm_read_input
!
! allocate(frz_massiv(nx,nz,ny,3))
! frz_massiv=0.0
! !Step 1: Time advance dt
! call move_lagrangian_point_positions_half(dt/2, xh_lag, yh_lag,&
! zh_lag, xh_lag_half, yh_lag_half,zh_lag_half&
! , indics_eul_half, perxzy)
! !write(*,*) 'after move_lagrangian_point_positions'
! #if masspoint_flag == 1
! !call massive_indices(lag_mass_p_half, eul_ind_mass_half, mass_dis)
! call move_massive_boundary_half(dt/2, lag_mass_p,lag_mass_p_half,&
! mass_vel_lag)
! ! write(*,*) "(lag_mass_p(1,3)-lag_mass_p_half(1,3))/lag_mass_p(1,3)",(lag_mass_p(1,3)-lag_mass_p_half(1,3))/lag_mass_p(1,3)
! call massive_indices(lag_mass_p_half, eul_ind_mass_half, mass_dis)
! !Step 2: Force comming from membrana
!
! call massive_lag_force(eul_ind_mass_half,xh_lag_half, yh_lag_half, zh_lag_half,&
! frz_massiv,lag_mass_p_half, mass_dis, dt/2)
!
! !write(*,*) '  lag_mass_p, lag_mass_p_half', rank,'[', lag_mass_p(1,3),lag_mass_p_half(1,3),']'
!
! ! call massive_lag_uforce(eul_ind_mass_half,xh_lag_half, yh_lag_half, zh_lag_half,&
! ! frz_massiv,lag_mass_p_half, mass_dis, dt/2,mass_vel_lag,perxzy)
!
! !write(*,*) 'after massive lag force'
! !####################### If after force contribution at dt, I return lag_mass=lag_point
! !lag_mass_p(:,1)=xh_lag(:)
! !lag_mass_p(:,2)=yh_lag(:)
! !lag_mass_p(:,3)=zh_lag(:)
! !call massive_indices(lag_mass_p, eul_ind_mass, mass_dis,mass_vel_lag)
! !###################################################
! #endif
!
! !call find_lag_forces_in_eul(xh_lag_half, yh_lag_half, zh_lag_half, indics_eul_half, &
! !frz_ibm,frz_massiv, rest_length, ang_bend, lenteja, rest_inv_beam, dt/2,f_hyd)
!
! !################################ V.5.1######################################################
! #if masspoint_flag == 1
!   frz_ibm(:,:,:,1)=frz_massiv(:,:,:,1)
!   frz_ibm(:,:,:,2)=frz_massiv(:,:,:,2)
!   frz_ibm(:,:,:,3)=frz_massiv(:,:,:,3)
! !write(*,*) "sum fr mass", sum(frz_mass(:,:,:,3))
! #endif
!
! f_hyd=0.d0
! !######################################################################################
!
! #if masspoint_flag == 1
! call update_massive_boundary_vel_half(dt/2,mass_vel_lag,frz_massiv,&
! eul_ind_mass_half,mass_vel_lag_half) !Gravity contribution to velocity
!
! call collision_contrib(dt/2,mass_dis,eul_ind_mass_half,mass_vel_lag_half,zh_lag_half)
! #endif
!
! deallocate(frz_massiv)
! return
! end subroutine ibm_solver_1st
!
!
! subroutine ibm_solver_2nd(xh_lag, yh_lag, zh_lag,&
! frz_ibm, lag_mass_pepe, mass_vel_lag,mass_vel_lag_half, rest_length,&
! ang_bend, lenteja,&
! rest_inv_beam,perxzy,f_hyd)
!
! use commondata
! use par_size !paralelisation chunks
! use grid
! use sim_par  !pi, simulation parameters
! use ibm_membrane
! #define masspoint_flag masspointflag
! integer          :: indics_eul(nz_h,3),i
! double precision :: xh_lag(nz_h), yh_lag(nz_h), zh_lag(nz_h)
! !double precision :: u_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1),&
! !v_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1), w_eu(2*n_supp+1,2*n_supp+1,2*n_supp+1)
! double precision :: frz_ibm(nx,nz,ny,3)
! !integer :: memy_pass(nz_h,3), memly_pass(nz_h,3)
! double precision :: lag_mass_pepe(3)
! !double precision :: mass_vel(nx,nz,ny,3)
! double precision :: rest_length(nz_h), lenteja(nz_h)
! double precision :: ang_bend(nz_h,3)
! double precision :: rest_inv_beam(nz_h,3)
!
! integer :: eul_ind_mass(nz_h,3)
! double precision :: mass_dis(nz_h,3,2*n_supp+1)
! double precision :: mass_vel_lag(nz_h,3), perxzy(nz_h,3)
! double precision :: f_hyd(3)
! !half variables
! double precision :: mass_vel_lag_half(nz_h,3)
! call ibm_read_input
!
! !Step 7: Time advance dt
! call move_lagrangian_point_positions(dt, xh_lag, yh_lag,&
! zh_lag, indics_eul, perxzy)
!
! !write(*,*) 'after move_lagrangian_point_positions'
! #if masspoint_flag == 1
!
! call move_massive_boundary(dt, lag_mass_pepe,&
! mass_vel_lag_half)
!
! !mass_vel_lag=mass_vel_lag_half
!
! call massive_indices(lag_mass_pepe, eul_ind_mass, mass_dis)
!
! call update_massive_boundary_vel(dt,mass_vel_lag,frz_ibm,&
! eul_ind_mass) !Gravity contribution to velocity
!
! call collision_contrib(dt,mass_dis,eul_ind_mass,mass_vel_lag,zh_lag)
!
! #endif
!
!
!
! return
! end subroutine ibm_solver_2nd
!
