subroutine initialize_psisol

use commondata
use par_size
use grid
use phase_field
use velocity_old
use velocity
use sterms
use sim_par
use dual_grid
use wavenumber
use ibm_membrane
use three_phase
!allocate(psi_sol(nx,nz,ny))
!allocate(psi_solc(spx,nz,spy,2))
!allocate(spsi_solo(spx,nz,spy,2))

allocate(p_psisol(nx,fpz,fpy))
allocate(p_psisolc(spx,nz,spy,2))
allocate(p_alfa_psi_sol(nx,fpz,fpy,n_budies))
allocate(solid_force(n_budies,3))
allocate(solid_force_prev(n_budies,3))
allocate(immers(n_budies))
!------ Plot -----------
allocate(cline_adv(n_budies))
allocate(relfluidrho(n_budies))
allocate(addedmass(n_budies))
allocate(dragforce(n_budies))
allocate(buoyforce(n_budies))

allocate(relfluidrhobud(n_budies))
allocate(addedmassbud(n_budies))
allocate(dragforcebud(n_budies))
allocate(buoyforcebud(n_budies))

!initialing everything as fluid
!psi_sol=0.0d0
p_psisol=0.0d0
p_psisolc=0.0d0
p_alfa_psi_sol=0.0d0
solid_force=0.0d0
solid_force_prev=0.0d0
immers=0.0d0
!----- plot ------------
cline_adv=0.0d0
relfluidrho=0.0d0
addedmass=0.0d0
dragforce=0.0d0
buoyforce=0.0d0
!plotting parameters
relfluidrhobud=0.0d0
addedmassbud=0.0d0
dragforcebud=0.0d0
buoyforcebud=0.0d0

!initialize solid diffuse spreading
!take information to the spectral space
allocate(frz_ibm_rank(nx,nz,ny,3))
allocate(frz_ibm(nx,nz,ny,3))
frz_ibm_rank=0.0d0
frz_ibm_ibud=0.0d0

return
end

!#######################################################
! subroutine ini_bodies(xh_lag,yh_lag, zh_lag)
! use commondata
! use grid
! use sim_par
! use ibm_membrane
! use par_size
! use three_phase
! integer :: j, k, l
! integer :: eul_indx(3)
! double precision :: xh_lag, yh_lag, zh_lag
! double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
! !Indexes
! integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1)&
! , indz_supp(2*n_supp+1)
! !spreading
! double precision :: expon,deltaxyz
!
! i_ibm=minloc(abs(x-(xh_lag + lx_cub*lx_pos)))
! j_ibm=minloc(abs(y-(yh_lag + ly_cub*ly_pos)))
! k_ibm=minloc(abs(z-(zh_lag - lz_cub*lz_pos)))
! eul_indx(1)=i_ibm(1)
! eul_indx(2)=j_ibm(1)
! eul_indx(3)=k_ibm(1)
! !write(*,*) eul_indx
! if(tresd_sim.eq.0) then
!
! do j=1,nx!2*tresd_supp+1
! do k=1,2*n_supp+1
! do l=1,2*n_supp+1
! indx_supp(j)=j!eul_indx(1)+j-n_supp-1
! call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag)
!
! indy_supp(k)=eul_indx(2)+k-n_supp-1
! call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag)
!
! indz_supp(l)=eul_indx(3)+l-n_supp-1
! call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag)
! !######### grid detatchment
! expon=exp((sqrt((dist_map_ibmx)**2+&
! (dist_map_ibmy)**2+ (dist_map_ibmz)**2)&
! -(rad_esf*0.5d0))/(sqrt(2.0)*eta_sol))
! !#############################
! deltaxyz=1/(1+expon)
!
! !psi_sol(indx_supp(j), indz_supp(l),indy_supp(k))= deltaxyz
!
! enddo
! enddo
! enddo
!
! elseif(tresd_sim.eq.1) then
!
! do j=1,2*n_supp+1
! do k=1,2*n_supp+1
! do l=1,2*n_supp+1
! !
! indx_supp(j)=eul_indx(1)+j-n_supp-1
! call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag)
!
! indy_supp(k)=eul_indx(2)+k-n_supp-1
! call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag)
!
! indz_supp(l)=eul_indx(3)+l-n_supp-1
! call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag)
! !######### grid detatchment
! expon=exp((sqrt((dist_map_ibmx)**2+&
! (dist_map_ibmy)**2+ (dist_map_ibmz)**2)&
! -(rad_esf*0.5d0))/(sqrt(2.0)*eta_sol))
! !#############################
! deltaxyz=1/(1+expon)
!
! !psi_sol(indx_supp(j), indz_supp(l),indy_supp(k))= deltaxyz
!
! enddo
! enddo
! enddo
!
! endif
!
! return
! end
!##################################################################################
! !############################ NOT USED CURRENTLY generate psisol in the whole z stripe instead in a box ########
! subroutine ini_domainbodies(xh_lag,yh_lag, zh_lag)
! use commondata
! use grid
! use sim_par
! use ibm_membrane
! use par_size
! use three_phase
! use phase_field
! integer :: j, k, l, kg,jg
! integer :: eul_indx(3)
! double precision :: xh_lag, yh_lag, zh_lag
! double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
! !Indexes
! integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1),&
!  indz_supp(2*n_supp+1)
! !spreading
! double precision :: expon,deltaxyz
!
! i_ibm=minloc(abs(x-(xh_lag + lx_cub*lx_pos)))
! j_ibm=minloc(abs(y-(yh_lag + ly_cub*ly_pos)))
! ! k_ibm=minloc(abs(z-(zh_lag - lz_cub*lz_pos)))
! eul_indx(1)=i_ibm(1)
! eul_indx(2)=j_ibm(1)
! ! eul_indx(3)=k_ibm(1)
! !write(*,*) eul_indx
! if(tresd_sim.eq.0) then
!
! do j=1,nx!2*tresd_supp+1
! do k=1,2*n_supp+1
! do l=1,nz!do k=1,2*n_supp+1
!
! indx_supp(j)=j!eul_indx(1)+j-n_supp-1
! call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag)
!
! indy_supp(k)=eul_indx(2)+k-n_supp-1
! call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag)
!
! ! indz_supp(l)=eul_indx(3)+l-n_supp-1
! ! call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag)
! !######### grid detatchment
! expon=exp((sqrt((dist_map_ibmx)**2+&
! (dist_map_ibmy)**2+ (z(l)-(zh_lag - lz_cub*lz_pos))**2)&
! -(rad_esf*0.5d0))/(sqrt(2.0)*eta_sol))
! !#############################
! deltaxyz=1/(1+expon)
!
! !psi_sol(indx_supp(j), l,indy_supp(k))= deltaxyz
!
! enddo
! enddo
! enddo
!
! elseif(tresd_sim.eq.1) then
!
! do j=1,2*n_supp+1
! do k=1,2*n_supp+1
! do l=1,nz!do k=1,2*n_supp+1
!     !
! indx_supp(j)=eul_indx(1)+j-n_supp-1
! call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag)
!
! indy_supp(k)=eul_indx(2)+k-n_supp-1
! call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag)
!
! ! indz_supp(l)=eul_indx(3)+l-n_supp-1
! ! call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag)
! !######### grid detatchment
! expon=exp((sqrt((dist_map_ibmx)**2+&
! (dist_map_ibmy)**2+ (z(l)-(zh_lag - lz_cub*lz_pos))**2)&
! -(rad_esf*0.5d0))/(sqrt(2.0)*eta_sol))
! !#############################
! deltaxyz=1/(1+expon)
!
! !psi_sol(indx_supp(j), l,indy_supp(k))= deltaxyz
!
! enddo
! enddo
! enddo
!
! endif
!
! return
! end
! !##################################################################################

!############################ generate psisol in the whole domain with partitionned psi a box ########
subroutine ini_pbodies(xh_lag,yh_lag, zh_lag, id_sol)
use commondata
use grid
use sim_par
use ibm_membrane
use par_size
use three_phase
use phase_field
integer :: j, k, l, kg,jg
!integer :: eul_indx(3)
double precision :: xh_lag, yh_lag, zh_lag
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
!Indexes
!integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
!spreading
double precision :: expon,deltaxyz

!if 2*rad_esf + lag_x is out of bounds, in the right
!compute phi from left. (lx_cub -(xh_lag + lx_cub*lx_pos))

if(tresd_sim.eq.0) then
do j=1,fpy
  do k=1,fpz
    do i=1,nx
      jg=fstart(3)+j
      kg=fstart(2)+k
p_alfa_psi_sol(i,k,j,id_sol)=1.d0-0.5d0*(dtanh((dsqrt((x(i)-(xh_lag + lx_cub*lx_pos))**2+ &
(y(jg)-(yh_lag + ly_cub*ly_pos))**2+(z(kg)-(zh_lag - lz_cub*lz_pos))**2)&
-rad_esf)/(2.d0*eta_sol*dsqrt(2.0d0))) + 1.d0)
!periodicity
if((2*rad_esf + (yh_lag + ly_cub*ly_pos)).gt.ly_cub) then
p_alfa_psi_sol(i,k,j,id_sol)=p_alfa_psi_sol(i,k,j,id_sol)+1.d0-0.5d0*(dtanh((dsqrt((x(i)-(xh_lag + lx_cub*lx_pos))**2+ &
(y(jg)+(ly_cub-(yh_lag + ly_cub*ly_pos)))**2+(z(kg)-(zh_lag - lz_cub*lz_pos))**2)&
-rad_esf)/(2.d0*eta_sol*dsqrt(2.0d0))) + 1.d0)
elseif(((yh_lag + ly_cub*ly_pos)-2*rad_esf).lt.ly_cub) then
p_alfa_psi_sol(i,k,j,id_sol)=p_alfa_psi_sol(i,k,j,id_sol)+1.d0-0.5d0*(dtanh((dsqrt((x(i)-(xh_lag + lx_cub*lx_pos))**2+ &
(y(jg)-(ly_cub+(yh_lag + ly_cub*ly_pos)))**2+(z(kg)-(zh_lag - lz_cub*lz_pos))**2)&
-rad_esf)/(2.d0*eta_sol*dsqrt(2.0d0))) + 1.d0)
endif

    enddo
  enddo
enddo
elseif(tresd_sim.eq.1) then

  do j=1,fpy
    do k=1,fpz
      do i=1,nx
        jg=fstart(3)+j
        kg=fstart(2)+k
      p_alfa_psi_sol(i,k,j,id_sol)=1.d0-0.5d0*(dtanh((dsqrt((x(i)-(xh_lag + lx_cub*lx_pos))**2+ &
        (y(jg)-(yh_lag + ly_cub*ly_pos))**2+(z(kg)-(zh_lag - lz_cub*lz_pos))**2)&
        -rad_esf)/(2.d0*eta_sol*dsqrt(2.0d0))) + 1.d0)
  !periodicity
  if((2*rad_esf + (xh_lag + lx_cub*lx_pos)).gt.lx_cub) then
  p_alfa_psi_sol(i,k,j,id_sol)=p_alfa_psi_sol(i,k,j,id_sol)+1.d0-0.5d0*(dtanh((dsqrt((x(i)+(lx_cub-(xh_lag + lx_cub*lx_pos)))**2+&
    (y(jg)-(yh_lag + ly_cub*ly_pos))**2+(z(kg)-(zh_lag - lz_cub*lz_pos))**2)&
    -rad_esf)/(2.d0*eta_sol*dsqrt(2.0d0))) + 1.d0)
  elseif(((xh_lag + lx_cub*lx_pos)-2*rad_esf).lt.lx_cub) then
  p_alfa_psi_sol(i,k,j,id_sol)=p_alfa_psi_sol(i,k,j,id_sol)+1.d0-0.5d0*(dtanh((dsqrt((x(i)-(lx_cub+(xh_lag + lx_cub*lx_pos)))**2+&
    (y(jg)-(yh_lag + ly_cub*ly_pos))**2+(z(kg)-(zh_lag - lz_cub*lz_pos))**2)&
    -rad_esf)/(2.d0*eta_sol*dsqrt(2.0d0))) + 1.d0)
  endif

  if((2*rad_esf + (yh_lag + ly_cub*ly_pos)).gt.ly_cub) then
  p_alfa_psi_sol(i,k,j,id_sol)=p_alfa_psi_sol(i,k,j,id_sol)+1.d0-0.5d0*(dtanh((dsqrt((x(i)-(xh_lag + lx_cub*lx_pos))**2+&
    (y(jg)+(ly_cub-(yh_lag + ly_cub*ly_pos)))**2+(z(kg)-(zh_lag - lz_cub*lz_pos))**2)&
    -rad_esf)/(2.d0*eta_sol*dsqrt(2.0d0))) + 1.d0)
  elseif(((yh_lag + ly_cub*ly_pos)-2*rad_esf).lt.ly_cub) then
  p_alfa_psi_sol(i,k,j,id_sol)=p_alfa_psi_sol(i,k,j,id_sol)+1.d0-0.5d0*(dtanh((dsqrt((x(i)-(xh_lag + lx_cub*lx_pos))**2+&
    (y(jg)-(ly_cub+(yh_lag + ly_cub*ly_pos)))**2+(z(kg)-(zh_lag - lz_cub*lz_pos))**2)&
    -rad_esf)/(2.d0*eta_sol*dsqrt(2.0d0))) + 1.d0)
  endif

      enddo
    enddo
  enddo

endif

p_psisol(:,:,:)=p_psisol(:,:,:)+p_alfa_psi_sol(:,:,:,id_sol)
return
end
!##################################################################################

!################# Initialize psisol in phi ########################################

!#######################################################
subroutine inipsisolphi(xh_lag,yh_lag, zh_lag,pisolphi)
use commondata
use grid
use sim_par
use ibm_membrane
use par_size
use three_phase
integer :: j, k, l
integer :: eul_indx(3)
double precision :: xh_lag, yh_lag, zh_lag
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
!Indexes
integer          :: indx_supp(2*nx_supp+1),indy_supp(2*ny_supp+1),&
 indz_supp(2*nz_supp+1)
!spreading
double precision :: expon,deltaxyz
double precision :: pisolphi(nx,nz,ny)

pisolphi=carrier_solid

i_ibm=minloc(abs(x-(xh_lag + lx_cub*lx_pos)))
j_ibm=minloc(abs(y-(yh_lag + ly_cub*ly_pos)))
k_ibm=minloc(abs(z-(zh_lag - lz_cub*lz_pos)))
eul_indx(1)=i_ibm(1)
eul_indx(2)=j_ibm(1)
eul_indx(3)=k_ibm(1)
!write(*,*) eul_indx
if(tresd_sim.eq.0) then

do j=1,nx!2*tresd_supp+1
do k=1,2*ny_supp+1
do l=1,2*nz_supp+1
indx_supp(j)=j!eul_indx(1)+j-n_supp-1
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag)

indy_supp(k)=eul_indx(2)+k-ny_supp-1
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag)

indz_supp(l)=eul_indx(3)+l-nz_supp-1
call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag)
!######### grid detatchment
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+ (dist_map_ibmz)**2)&
-rad_esf)/(sqrt(2.0)*eta_sol)- s_thikness)
!#############################
deltaxyz=(wet_par-0.1d0-carrier_solid)/(1+expon)+carrier_solid


pisolphi(indx_supp(j), indz_supp(l),indy_supp(k))= deltaxyz
!write(*,*) psi_sol(indx_supp(j), indz_supp(l),indy_supp(k))
enddo
enddo
enddo

elseif(tresd_sim.eq.1) then

do j=1,2*nx_supp+1
do k=1,2*ny_supp+1
do l=1,2*nz_supp+1
!
indx_supp(j)=eul_indx(1)+j-nx_supp-1
call period_supp_distx(dist_map_ibmx,lx_cub,lx_pos,indx_supp(j), nx,xh_lag)

indy_supp(k)=eul_indx(2)+k-ny_supp-1
call period_supp_disty(dist_map_ibmy,ly_cub,ly_pos,indy_supp(k), ny,yh_lag)

indz_supp(l)=eul_indx(3)+l-nz_supp-1
call period_supp_distz(dist_map_ibmz,lz_cub,lz_pos,indz_supp(l), nz,zh_lag)
!######### grid detatchment
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+ (dist_map_ibmz)**2)&
-rad_esf)/(sqrt(2.0)*eta_sol)- s_thikness)
!#############################
deltaxyz=(wet_par-0.1d0-carrier_solid)/(1+expon)+carrier_solid


pisolphi(indx_supp(j), indz_supp(l),indy_supp(k))= deltaxyz
!write(*,*) psi_sol(indx_supp(j), indz_supp(l),indy_supp(k))
enddo
enddo
enddo

endif

return
end

!###################################################################################
subroutine phi_ibm_ini(xh_l,yh_l,zh_l)

use commondata
use par_size
use phase_field
use grid
use ibm_membrane
use three_phase
double precision :: xh_l, yh_l, zh_l,psi_part
integer   :: j,k,l
integer :: jg,kg
integer          :: ind_eu(nz_h,3)
!new parameters
integer :: jj_corr,ii_corr,kk_corr
integer :: jj,ii,kk
integer :: ic, jc, kc
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
double precision, allocatable :: pisolphi(:,:,:)

allocate (pisolphi(nx,nz,ny))
pisolphi=carrier_solid

call inipsisolphi(xh_l, yh_l, zh_l, pisolphi)
!########### Method 2: substracting the phase psi_sol from phi taking into account phi_a+phi_b+psi_sol=1###############
do i=fstart(1)+1,fstart(1)+nx
 ic=i-fstart(1)
  do j=fstart(3)+1,fstart(3)+fpy
  jc=j-fstart(3)
   do k=fstart(2)+1,fstart(2)+fpz
    kc=k-fstart(2)
!if (psi_sol(i,k,j).ne.0) then
   ! if(pisolphi(i,k,j).gt.carrier_solid) then
   !    phi(ic,kc,jc)=pisolphi(i,k,j)

phi(ic,kc,jc)=-phi(ic,kc,jc)*pisolphi(i,k,j)
!    endif
   enddo
  enddo
enddo
deallocate (pisolphi)
return
end subroutine phi_ibm_ini

!########### Cleaning phase of fluxes #############################################

subroutine phi_clean

use commondata
use par_size
use phase_field
use grid
use ibm_membrane
use three_phase
!double precision :: xh_l(nz_h), yh_l(nz_h), zh_l(nz_h),psi_part
integer   :: j,k,l
integer :: jg,kg
!double precision :: dis(nz_h,3,2*n_supp+1)
integer          :: ind_eu(nz_h,3)
!new parameters
!integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
!integer :: box_cut_ini(3),box_cut_fin(3)
integer :: jj_corr,ii_corr,kk_corr
integer :: jj,ii,kk
integer :: ic, jc, kc

do i=fstart(1)+1,fstart(1)+nx
 ic=i-fstart(1)
  do j=fstart(3)+1,fstart(3)+fpy
  jc=j-fstart(3)
   do k=fstart(2)+1,fstart(2)+fpz
    kc=k-fstart(2)

! if(phi(ic,kc,jc).gt.0.99d0) then
!     phi(ic,kc,jc)=1.0d0
! elseif(phi(ic,kc,jc).lt.-0.99d0) then
!     phi(ic,kc,jc)=-1.0d0
! endif
if(k.gt.(nz-nz/15)) then
 phi(ic,kc,jc)=1.0d0
endif
if(k.lt.(nz/15)) then
 phi(ic,kc,jc)=-1.0d0
endif


   enddo
  enddo
enddo
!deallocate (pisolphi)
return
end subroutine phi_clean



subroutine phi_cleanovershot

use commondata
use par_size
use phase_field
use grid
use ibm_membrane
use three_phase
!double precision :: xh_l(nz_h), yh_l(nz_h), zh_l(nz_h),psi_part
integer   :: j,k,l
integer :: jg,kg
!double precision :: dis(nz_h,3,2*n_supp+1)
integer          :: ind_eu(nz_h,3)
!new parameters
!integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
!integer :: box_cut_ini(3),box_cut_fin(3)
integer :: jj_corr,ii_corr,kk_corr
integer :: jj,ii,kk
integer :: ic, jc, kc

do i=fstart(1)+1,fstart(1)+nx
 ic=i-fstart(1)
  do j=fstart(3)+1,fstart(3)+fpy
  jc=j-fstart(3)
   do k=fstart(2)+1,fstart(2)+fpz
    kc=k-fstart(2)

if(phi(ic,kc,jc).gt.0.99d0) then
    phi(ic,kc,jc)=1.0d0
elseif(phi(ic,kc,jc).lt.-0.99d0) then
    phi(ic,kc,jc)=-1.0d0
endif
if(k.gt.(nz-nz/15)) then
 phi(ic,kc,jc)=1.0d0
endif
if(k.lt.(nz/15)) then
 phi(ic,kc,jc)=-1.0d0
endif


   enddo
  enddo
enddo
!deallocate (pisolphi)
return
end subroutine phi_cleanovershot
!##################################################################################
subroutine destroy_psisol
use commondata
use grid
use sim_par
use ibm_membrane
use par_size
use three_phase

!deallocate(psi_sol)
!deallocate(psi_solc)
!deallocate(spsi_solo)

deallocate(p_psisol)
deallocate(p_psisolc)
deallocate(p_alfa_psi_sol)

deallocate(solid_force)
deallocate(solid_force_prev)

deallocate(frz_ibm_rank)
deallocate(frz_ibm)
deallocate(immers)
!----------plotting parameters
deallocate(cline_adv)
deallocate(relfluidrho)
deallocate(addedmass)
deallocate(dragforce)
deallocate(buoyforce)

deallocate(relfluidrhobud)
deallocate(addedmassbud)
deallocate(dragforcebud)
deallocate(buoyforcebud)
return
end
!##############################
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine genpsi(ntime)
use commondata
use grid
use sim_par
use ibm_membrane
use par_size
use three_phase
use mpi

integer :: i,j,k,ic,jc,kc
double precision :: xh_lag, yh_lag, zh_lag
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz
!Indexes
!integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
!spreading
double precision :: expon,deltaxyz
!writing the phase_field
!integer          :: i
double precision :: xmin, ymin, zmin, deltax, deltay, deltaz
integer          :: ntime
character(len=40):: namefile
double precision, allocatable :: psi_solrank(:,:,:), alfas(:,:,:)
allocate (psi_sol(nx,nz,ny))
allocate (psi_solrank(nx,nz,ny))
allocate (alfas(nx,ny,nz))
alfas=0.0d0
psi_solrank=0.0d0
psi_sol=0.0d0
do i=fstart(1)+1,fstart(1)+nx
 ic=i-fstart(1)
  do j=fstart(3)+1,fstart(3)+fpy
  jc=j-fstart(3)
   do k=fstart(2)+1,fstart(2)+fpz
    kc=k-fstart(2)
       psi_solrank(i,k,j)=p_psisol(ic,kc,jc)
    enddo
  enddo
enddo

call MPI_ALLREDUCE (psi_solrank(:,:,:), psi_sol(:,:,:),&
nx*ny*nz,MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm, ierr)

do i=1,nx
 do j=1,ny
  do k=1,nz
alfas(i,j,k)=psi_sol(i,k,j)
  enddo
 enddo
enddo

deallocate(psi_solrank)

   ! Write VTK File
  xmin = 0.0d0
  !  xmax = lx_cub
  ymin = 0.0d0
  !  ymax = ly_cub
  zmin = 0.0d0
  !  zmax = lz_cub
  deltax = (lx_cub-xmin)*re/(nx-1)
  deltay = (ly_cub-ymin)*re/(ny-1)
  deltaz = (lz_cub-zmin)*re/nz



write(namefile,'(a,i8.8,a)') './IBM/body_gen',ntime,'.vtr'

     ! vtr file writing
open(231,file=trim(namefile),form = 'formatted',status='replace',access='stream',convert='big_endian')

  ! open(unit=70,file='./sc_compiled/input_ibm.f90',form='formatted',status='old',action='read')
     write(231,'(A)') '<VTKFile type="RectilinearGrid" version="0.1" byte_order="LittleEndian">'
     write(231,*) '<RectilinearGrid WholeExtent="',1,nx,1,ny,1,nz,'">'
     write(231,*) '<Piece Extent="',1,nx,1,ny,1,nz,'">'
     write(231,'(A)') '<PointData>'
     write(231,'(A)') '<DataArray type="Float32" Name="Force_ibm" NumberOfComponents="1" format="ascii">'
     write(231,*)     alfas(1:nx,1:ny,1:nz)
     write(231,'(A)') '</DataArray>'
     write(231,'(A)') '</PointData>'
     write(231,'(A)') '<CellData>'
     write(231,'(A)') '</CellData>'
     write(231,'(A)') '<Coordinates>'
     write(231,'(A)') '<DataArray type="Float32" Name="X_COORDINATES" NumberOfComponents="1" format="ascii">'
     write(231,*)     (xmin+(i-1.0)*deltax,i=1,nx)
     write(231,'(A)') '</DataArray>'
     write(231,'(A)') '<DataArray type="Float32" Name="Y_COORDINATES" NumberOfComponents="1" format="ascii">'
     write(231,*)     (ymin+(i-1.0)*deltay,i=1,ny)
     write(231,'(A)') '</DataArray>'
     write(231,'(A)') '<DataArray type="Float32" Name="Z_COORDINATES" NumberOfComponents="1" format="ascii">'
     write(231,*)     (cos(((i-1)*pi)/(nz-1))*re+re ,i=1,nz)!(zmin+(i-0.5)*deltaz,i=1,nz)
     write(231,'(A)') '</DataArray>'
     write(231,'(A)') '</Coordinates>'
     write(231,'(A)') '</Piece>'
     write(231,'(A)') '</RectilinearGrid>'
     write(231,'(A)') '</VTKFile> '

close(231)

deallocate(psi_sol)
deallocate(alfas)
return
end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!##################  Finding heads and tails of the box for the body ###################################
subroutine head_tail_box(xl_c, yl_c, zl_c, box_cut_ini, box_cut_fin, box_indic)

use commondata
use par_size
use grid
use phase_field
use velocity_old
use velocity
use sterms
use sim_par
use dual_grid
use wavenumber
use ibm_membrane
use three_phase

double precision :: xl_c,yl_c,zl_c
integer :: i_blq(nx),j_blq(fpy),k_blq(fpz)
integer, dimension(6) :: box_indic
integer :: box_cut_ini(3),box_cut_fin(3)
integer :: iblock_found(2*n_supp+1),jblock_found(2*n_supp+1),kblock_found(2*n_supp+1)
integer :: jj_corr,ii_corr,kk_corr
integer :: jj,ii,kk,j,k,i

!call box_indic_ibm(xl_c, yl_c,zl_c, box_indic)
!---------- all the indexes in the block ------------------
do i=fstart(1)+1,fstart(1)+nx
  i_blq(i-fstart(1))=i
enddo
do j=fstart(3)+1,fstart(3)+fpy
  j_blq(j-fstart(3))=j
enddo
do k=fstart(2)+1,fstart(2)+fpz
  k_blq(k-fstart(2))=k
enddo
!------------------------------------------------------------
 iblock_found=0
  do ii=box_indic(1),box_indic(2)
   ii_corr=ii  !correcting on the way the indx because of periodicity
   call period_supp(ii_corr, nx)

  if ( any(i_blq.eq.ii_corr) )then
    iblock_found(ii-box_indic(1)+1)=ii
  end if
  enddo
!write(*,*) "iblock_found",iblock_found
  if ( any(iblock_found.ne.0) ) then
    box_cut_ini(1)=int(minval(iblock_found,mask=(iblock_found.gt.0)))
    box_cut_fin(1)=int(maxval(iblock_found))
 elseif( sum(iblock_found).eq.0 ) then
 box_cut_ini(1)=0
 box_cut_fin(1)=0
  end if

 jblock_found=0
   do jj=box_indic(3),box_indic(4)
  jj_corr=jj  !correcting on the way the indx because of periodicity
   call period_supp(jj_corr, ny)

   if ( any(j_blq.eq.jj_corr) )then
     jblock_found(jj-box_indic(3)+1)=jj
   end if
   enddo

 if ( any(jblock_found.ne.0) ) then
   box_cut_ini(2)=int(minval(jblock_found,mask=(jblock_found.gt.0)))
   box_cut_fin(2)=int(maxval(jblock_found))
  elseif( sum(jblock_found).eq.0 ) then
 box_cut_ini(2)=0
 box_cut_fin(2)=0
  endif

 kblock_found=0
   do kk=box_indic(5),box_indic(6)
  kk_corr=kk  !correcting on the way the indx because of periodicity
  call period_supp_z(kk_corr, nz)

   if ( any(k_blq.eq.kk_corr ) )then
     kblock_found(kk-box_indic(5)+1)=kk
   end if
   enddo

  if ( any(kblock_found.ne.0) ) then
     box_cut_ini(3)=int(minval(kblock_found,mask=(kblock_found.gt.0)))
     box_cut_fin(3)=int(maxval(kblock_found))
  elseif( sum(kblock_found).eq.0 ) then

 box_cut_ini(3)=0
 box_cut_fin(3)=0
  endif


return
end
!###################################################################################

subroutine single_well(xl_c, yl_c,zl_c,box_cut_ini, box_cut_fin,box_indic)

use commondata
use par_size
use grid
use phase_field
use velocity_old
use velocity
use sterms
use sim_par
use dual_grid
use wavenumber
use ibm_membrane
use three_phase
double precision, allocatable, dimension (:,:,:)::phi_co
integer :: box_cut_ini(3),box_cut_fin(3)
integer :: jj_corr,ii_corr,kk_corr
integer :: jj,ii,kk,ic,jc,kc
integer,dimension(6) :: box_indic

allocate(phi_co(2*n_supp+1,2*n_supp+1,2*n_supp+1))

if(((box_cut_ini(1).ne.0).and.(box_cut_fin(1).ne.0)).and.&
((box_cut_ini(2).ne.0).and.(box_cut_fin(2).ne.0)).and.&
((box_cut_ini(3).ne.0).and.(box_cut_fin(3).ne.0)))then     !filtering exportation of information just from the blocks containing information

call aura_phi(xl_c, yl_c,zl_c, phi_co)

do ii=box_cut_ini(1),box_cut_fin(1)
  ii_corr=ii
  call period_supp(ii_corr, nx)
  ic=ii_corr-fstart(1)
  do jj=box_cut_ini(2),box_cut_fin(2)
    jj_corr=jj
    call period_supp(jj_corr, ny)
    jc=jj_corr-fstart(3)
    do kk=box_cut_ini(3),box_cut_fin(3)
      kk_corr=kk
      call period_supp(kk_corr, nz)
      kc=kk_corr-fstart(2)

!########## first method #####################################################
if(phi_co(ii-box_indic(1)+1,kk-box_indic(5)+1,jj-box_indic(3)+1).gt.0.9d0)then
!  write(*,*) phi_co(ii-box_indic(1)+1,kk-box_indic(5)+1,jj-box_indic(3)+1)
   if(phi(ic,kc,jc).gt.0.0d0) then
     phi(ic,kc,jc)=1-phi_co(ii-box_indic(1)+1,kk-box_indic(5)+1,jj-box_indic(3)+1)
   elseif(phi(ic,kc,jc).lt.0.0d0)then
     phi(ic,kc,jc)=-(1-phi_co(ii-box_indic(1)+1,kk-box_indic(5)+1,jj-box_indic(3)+1))
   endif
endif

enddo
enddo
enddo

endif

deallocate(phi_co)


return
end
!##########################################################

subroutine aura_phi(xh_l, yh_l, zh_l,phi_co)
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
integer          :: i,j,k,l
integer          :: ind_eu(nz_h,3)
integer          :: indx_supp(2*n_supp+1),indy_supp(2*n_supp+1), indz_supp(2*n_supp+1)
!spreading
double precision :: expon,deltaxyz
double precision :: phi_co(2*n_supp+1,2*n_supp+1,2*n_supp+1)
double precision :: dis(nz_h,3,2*n_supp+1)
double precision :: xh_l(nz_h), yh_l(nz_h), zh_l(nz_h)
double precision :: dist_map_ibmx,dist_map_ibmy,dist_map_ibmz

call delta_indices(xh_l, yh_l, zh_l, ind_eu, dis)

do i=1, nz_h
do j=1,2*n_supp+1
do k=1,2*n_supp+1
do l=1,2*n_supp+1

!Boundary periiodicity
indx_supp(j)=ind_eu(i,1)+j-n_supp-1
! dist_map_ibmx=x(indx_supp(j)) - (xh_l(i)+lx_pos*lx_cub)
! call period_supp(indx_supp(j), nx)
call period_supp_distx(dist_map_ibmx,lx_cub,&
lx_pos,indx_supp(j), nx,xh_l(i))

indy_supp(k)=ind_eu(i,2)+k-n_supp-1
! dist_map_ibmy=y(indy_supp(k)) - (yh_l(i)+ly_pos*ly_cub)
!call period_supp(indy_supp(k), ny)
call period_supp_disty(dist_map_ibmy,ly_cub,&
ly_pos,indy_supp(k), ny,yh_l(i))

indz_supp(l)=ind_eu(i,3)+l-n_supp-1
! dist_map_ibmz=z(indz_supp(l)) - (zh_l(i)+lz_pos*lz_cub)
call period_supp_distz(dist_map_ibmz,lz_cub,&
lz_pos,indz_supp(l), nz,zh_l(i))
!#### detatchment
expon=exp((sqrt((dist_map_ibmx)**2+&
(dist_map_ibmy)**2+ (dist_map_ibmz)**2)&
-rad_esf)/(sqrt(2.0)*eta_sol))
!####
phi_co(j,l,k)=1/(1+expon) ! -1.5!4*expon/(1+expon)**2 - 1.0 !4.0*

enddo
enddo
enddo
enddo


end subroutine aura_phi

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine sphase_coupledfce
use commondata
use par_size
use grid
use phase_field
use velocity_old
use velocity
use sterms
use sim_par
use dual_grid
use wavenumber
use ibm_membrane
use three_phase

allocate (aeu1(spx,nz,spy,2))
allocate (aeu2(spx,nz,spy,2))
allocate (aeu3(spx,nz,spy,2))
allocate (aeu4(spx,nz,spy,2))
allocate (aeu5(spx,nz,spy,2))
allocate (aeu6(spx,nz,spy,2))
allocate (aeu7(spx,nz,spy,2))

allocate (aeu1f(nx,fpz,fpy))
allocate (aeu2f(nx,fpz,fpy))
allocate (aeu3f(nx,fpz,fpy))
allocate(fnsx_psisol(nx,fpz,fpy))
allocate(fnsy_psisol(nx,fpz,fpy))
allocate(fnsz_psisol(nx,fpz,fpy))

!Starting: Chem. Pot. respect phi
!Gradient of phi
call dz(phic,aeu3)

do j=1,spy
  do k=1,nz
    do i=1,spx
      aeu1(i,k,j,1)=-kx(i+cstart(1))*phic(i,k,j,2)
      aeu1(i,k,j,2)=+kx(i+cstart(1))*phic(i,k,j,1)
      aeu2(i,k,j,1)=-ky(j+cstart(3))*phic(i,k,j,2)
      aeu2(i,k,j,2)=+ky(j+cstart(3))*phic(i,k,j,1)
    enddo
  enddo
enddo
aeu1=-ch**(2.00)/pe*aeu1
aeu2=-ch**(2.00)/pe*aeu2
aeu3=-ch**(2.00)/pe*aeu3
! coupling term phi*psi_sol

call spectral_to_phys(phic,aeu1f,1)

do j=1,fpy
  do k=1,fpz
    do i=1,nx
      aeu1f(i,k,j)=coef_ternary*(aeu1f(i,k,j)-wet_par)*(p_psisol(i,k,j))
    enddo
  enddo
enddo
call phys_to_spectral(aeu1f,aeu4,1)
!grad
call dz(aeu4,aeu7)

do j=1,spy
  do k=1,nz
    do i=1,spx
      aeu5(i,k,j,1)=-kx(i+cstart(1))*aeu4(i,k,j,2)
      aeu5(i,k,j,2)=+kx(i+cstart(1))*aeu4(i,k,j,1)
      aeu6(i,k,j,1)=-ky(j+cstart(3))*aeu4(i,k,j,2)
      aeu6(i,k,j,2)=+ky(j+cstart(3))*aeu4(i,k,j,1)
    enddo
  enddo
enddo

aeu1=aeu1+aeu5
aeu2=aeu2+aeu6
aeu3=aeu3+aeu7
!-ch^2 nabla^2 phi
call dz(phic,aeu5)
call dz(aeu5,aeu4)

do j=1,spy
  do i=1,spx
    aeu4(i,:,j,1)=aeu4(i,:,j,1)-k2(i+cstart(1),j+cstart(3))*phic(i,:,j,1)
    aeu4(i,:,j,2)=aeu4(i,:,j,2)-k2(i+cstart(1),j+cstart(3))*phic(i,:,j,2)
  enddo
enddo
!grad
call dz(aeu4,aeu7)

do j=1,spy
  do k=1,nz
    do i=1,spx
      aeu5(i,k,j,1)=-kx(i+cstart(1))*aeu4(i,k,j,2)
      aeu5(i,k,j,2)=+kx(i+cstart(1))*aeu4(i,k,j,1)
      aeu6(i,k,j,1)=-ky(j+cstart(3))*aeu4(i,k,j,2)
      aeu6(i,k,j,2)=+ky(j+cstart(3))*aeu4(i,k,j,1)
    enddo
  enddo
enddo
aeu1=aeu1- (ch**2.0d0)*aeu5/pe
aeu2=aeu2- (ch**2.0d0)*aeu6/pe
aeu3=aeu3- (ch**2.0d0)*aeu7/pe

!nabla phi^3
aeu1f=phi**(3.0d0)
call phys_to_spectral(aeu1f,aeu4,1)
!grad
call dz(aeu4,aeu7)

do j=1,spy
  do k=1,nz
    do i=1,spx
      aeu5(i,k,j,1)=-kx(i+cstart(1))*aeu4(i,k,j,2)
      aeu5(i,k,j,2)=+kx(i+cstart(1))*aeu4(i,k,j,1)
      aeu6(i,k,j,1)=-ky(j+cstart(3))*aeu4(i,k,j,2)
      aeu6(i,k,j,2)=+ky(j+cstart(3))*aeu4(i,k,j,1)
    enddo
  enddo
enddo

aeu1=aeu1+ aeu5/pe
aeu2=aeu2+ aeu6/pe
aeu3=aeu3+ aeu4/pe

!interfacial energies term for the fluid particle
! do j=1,fpy
!   do k=1,fpz
!     do i=1,nx
! if(p_psisol(i,k,j).gt.0.0d0) then ! Constraining the interfacial energies to the solid phase surroundings
! aeu1f(i,k,j)=0.5d0*(1.0d0-phi(i,k,j)-2.0d0*p_psisol(i,k,j))
! else
! aeu1f(i,k,j)=0.0d0
! endif
!     enddo
!   enddo
! enddo
!
! call phys_to_spectral(aeu1f,aeu4,1)
!
! call dz(aeu4,aeu5)
! call dz(aeu5,aeu6)
!
! do j=1,spy
!   do i=1,spx
!     aeu4(i,:,j,1)=aeu6(i,:,j,1)-k2(i+cstart(1),j+cstart(3))*aeu4(i,:,j,1)
!     aeu4(i,:,j,2)=aeu6(i,:,j,2)-k2(i+cstart(1),j+cstart(3))*aeu4(i,:,j,2)
!   enddo
! enddo
! !grad
! call dz(aeu4,aeu7)
!
! do j=1,spy
!   do k=1,nz
!     do i=1,spx
!       aeu5(i,k,j,1)=-kx(i+cstart(1))*aeu4(i,k,j,2)
!       aeu5(i,k,j,2)=+kx(i+cstart(1))*aeu4(i,k,j,1)
!       aeu6(i,k,j,1)=-ky(j+cstart(3))*aeu4(i,k,j,2)
!       aeu6(i,k,j,2)=+ky(j+cstart(3))*aeu4(i,k,j,1)
!     enddo
!   enddo
! enddo
! aeu1=aeu1+ (0.5d0)*aeu5*(eta_fp**(2.0d0))/pe
! aeu2=aeu2+ (0.5d0)*aeu6*(eta_fp**(2.0d0))/pe
! aeu3=aeu3+ (0.5d0)*aeu7*(eta_fp**(2.0d0))/pe
!
! ! for the drop particle interface energies
! do j=1,fpy
!   do k=1,fpz
!     do i=1,nx
! if(p_psisol(i,k,j).gt.0.0d0) then ! Constraining the interfacial energies to the solid phase surroundings
! aeu1f(i,k,j)=0.5d0*(1.0d0+phi(i,k,j)-2.0d0*p_psisol(i,k,j))
! else
! aeu1f(i,k,j)=0.0d0
! endif
!     enddo
!   enddo
! enddo
!
! call phys_to_spectral(aeu1f,aeu4,1)
!
! call dz(aeu4,aeu5)
! call dz(aeu5,aeu6)
!
! do j=1,spy
!   do i=1,spx
!     aeu4(i,:,j,1)=aeu6(i,:,j,1)-k2(i+cstart(1),j+cstart(3))*aeu4(i,:,j,1)
!     aeu4(i,:,j,2)=aeu6(i,:,j,2)-k2(i+cstart(1),j+cstart(3))*aeu4(i,:,j,2)
!   enddo
! enddo
! !grad
! call dz(aeu4,aeu7)
!
! do j=1,spy
!   do k=1,nz
!     do i=1,spx
!       aeu5(i,k,j,1)=-kx(i+cstart(1))*aeu4(i,k,j,2)
!       aeu5(i,k,j,2)=+kx(i+cstart(1))*aeu4(i,k,j,1)
!       aeu6(i,k,j,1)=-ky(j+cstart(3))*aeu4(i,k,j,2)
!       aeu6(i,k,j,2)=+ky(j+cstart(3))*aeu4(i,k,j,1)
!     enddo
!   enddo
! enddo
! aeu1=aeu1- (0.5d0)*aeu5*(eta_dp**(2.0d0))/pe
! aeu2=aeu2- (0.5d0)*aeu6*(eta_dp**(2.0d0))/pe
! aeu3=aeu3- (0.5d0)*aeu7*(eta_dp**(2.0d0))/pe

! Summing up all the  terms of the chemical potential and multiplying by phi
call spectral_to_phys(aeu1,aeu1f,1)
call spectral_to_phys(aeu2,aeu2f,1)
call spectral_to_phys(aeu3,aeu3f,1)

do j=1,fpy
  do k=1,fpz
    do i=1,nx
      fnsx_psisol(i,k,j)=-phi(i,k,j)*aeu1f(i,k,j)
      fnsy_psisol(i,k,j)=-phi(i,k,j)*aeu2f(i,k,j)
      fnsz_psisol(i,k,j)=-phi(i,k,j)*aeu3f(i,k,j)
    enddo
  enddo
enddo
! aeu1=0.0d0
! aeu2=0.0d0
! aeu3=0.0d0
!
! !#################  the chemical potential for the solid phase #################
! !copling term nabla phi^2
!
! aeu1f=coef_ternary*phi**(2.0d0)
! call phys_to_spectral(aeu1f,aeu4,1)
! !grad
! call dz(aeu4,aeu7)
!
! do j=1,spy
!   do k=1,nz
!     do i=1,spx
!       aeu5(i,k,j,1)=-kx(i+cstart(1))*aeu4(i,k,j,2)
!       aeu5(i,k,j,2)=+kx(i+cstart(1))*aeu4(i,k,j,1)
!       aeu6(i,k,j,1)=-ky(j+cstart(3))*aeu4(i,k,j,2)
!       aeu6(i,k,j,2)=+ky(j+cstart(3))*aeu4(i,k,j,1)
!     enddo
!   enddo
! enddo
!
! aeu1=aeu5/pe
! aeu2=aeu6/pe
! aeu3=aeu4/pe
!
! !interfacial energy fluid particle
! do j=1,fpy
!   do k=1,fpz
!     do i=1,nx
! if(p_psisol(i,k,j).gt.0.0d0) then ! Constraining the interfacial energies to the solid phase surroundings
!   aeu1f(i,k,j)=0.5d0*(1.0d0-phi(i,k,j)-2.0d0*p_psisol(i,k,j))
! else
!   aeu1f(i,k,j)=0.0d0
! endif
!     enddo
!   enddo
! enddo
!
! call phys_to_spectral(aeu1f,aeu4,1)
!
! call dz(aeu4,aeu5)
! call dz(aeu5,aeu6)
!
! do j=1,spy
!   do i=1,spx
!     aeu4(i,:,j,1)=aeu6(i,:,j,1)-k2(i+cstart(1),j+cstart(3))*aeu4(i,:,j,1)
!     aeu4(i,:,j,2)=aeu6(i,:,j,2)-k2(i+cstart(1),j+cstart(3))*aeu4(i,:,j,2)
!   enddo
! enddo
! !grad
! call dz(aeu4,aeu7)
!
! do j=1,spy
!   do k=1,nz
!     do i=1,spx
!       aeu5(i,k,j,1)=-kx(i+cstart(1))*aeu4(i,k,j,2)
!       aeu5(i,k,j,2)=+kx(i+cstart(1))*aeu4(i,k,j,1)
!       aeu6(i,k,j,1)=-ky(j+cstart(3))*aeu4(i,k,j,2)
!       aeu6(i,k,j,2)=+ky(j+cstart(3))*aeu4(i,k,j,1)
!     enddo
!   enddo
! enddo
! aeu1=aeu1+ aeu5*(eta_fp**(2.0d0))/pe
! aeu2=aeu2+ aeu6*(eta_fp**(2.0d0))/pe
! aeu3=aeu3+ aeu7*(eta_fp**(2.0d0))/pe
!
! !Interface energy drop particle
! do j=1,fpy
!   do k=1,fpz
!     do i=1,nx
! if(p_psisol(i,k,j).gt.0.0d0) then ! Constraining the interfacial energies to the solid phase surroundings
!   aeu1f(i,k,j)=0.5d0*(1.0d0+phi(i,k,j)-2.0d0*p_psisol(i,k,j))
! else
!   aeu1f(i,k,j)=0.0d0
! endif
!     enddo
!   enddo
! enddo
!
! call phys_to_spectral(aeu1f,aeu4,1)
!
! call dz(aeu4,aeu5)
! call dz(aeu5,aeu6)
!
! do j=1,spy
!   do i=1,spx
!     aeu4(i,:,j,1)=aeu6(i,:,j,1)-k2(i+cstart(1),j+cstart(3))*aeu4(i,:,j,1)
!     aeu4(i,:,j,2)=aeu6(i,:,j,2)-k2(i+cstart(1),j+cstart(3))*aeu4(i,:,j,2)
!   enddo
! enddo
! !grad
! call dz(aeu4,aeu7)
!
! do j=1,spy
!   do k=1,nz
!     do i=1,spx
!       aeu5(i,k,j,1)=-kx(i+cstart(1))*aeu4(i,k,j,2)
!       aeu5(i,k,j,2)=+kx(i+cstart(1))*aeu4(i,k,j,1)
!       aeu6(i,k,j,1)=-ky(j+cstart(3))*aeu4(i,k,j,2)
!       aeu6(i,k,j,2)=+ky(j+cstart(3))*aeu4(i,k,j,1)
!     enddo
!   enddo
! enddo
! aeu1=aeu1+ aeu5*(eta_dp**(2.0d0))/pe
! aeu2=aeu2+ aeu6*(eta_dp**(2.0d0))/pe
! aeu3=aeu3+ aeu7*(eta_dp**(2.0d0))/pe
!
!
! ! Summing up all the  terms of the chemical potential and multiplying by psi_sol
! call spectral_to_phys(aeu1,aeu1f,1)
! call spectral_to_phys(aeu2,aeu2f,1)
! call spectral_to_phys(aeu3,aeu3f,1)
!
! do j=1,fpy
!   do k=1,fpz
!     do i=1,nx
!       fnsx_psisol(i,k,j)=fnsx_psisol(i,k,j) - p_psisol(i,k,j)*aeu1f(i,k,j)
!       fnsy_psisol(i,k,j)=fnsy_psisol(i,k,j) - p_psisol(i,k,j)*aeu2f(i,k,j)
!       fnsz_psisol(i,k,j)=fnsz_psisol(i,k,j) - p_psisol(i,k,j)*aeu3f(i,k,j)
!     enddo
!   enddo
! enddo


call phys_to_spectral(fnsx_psisol,fnsx_psisolc,1)
call phys_to_spectral(fnsy_psisol,fnsy_psisolc,1)
call phys_to_spectral(fnsz_psisol,fnsz_psisolc,1)

deallocate(aeu1,aeu2,aeu3,aeu4,aeu5,aeu6,aeu7)
deallocate(aeu1f,aeu2f,aeu3f)
deallocate(fnsx_psisol,fnsy_psisol,fnsz_psisol)

return
end

!!!!!!!!!!!!!!!!###################################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine interp_vel(movi,id_sol)
use commondata
use par_size
use grid
use phase_field
use velocity_old
use velocity
use sterms
use sim_par
use dual_grid
use wavenumber
use ibm_membrane
use three_phase
use mpi

double precision, dimension(3) :: per, movi
double precision, allocatable :: move_lag(:)
double precision ::  count_intr,  count_sum
integer :: id_sol
!###########################  ghost phase velocity interpolation ##########

!clockstart = MPI_Wtime() !timing
per=0.0d0
movi=0.0d0

count_intr=0.0d0
 do j=1,fpy
   do k=1,fpz
     do i=1,nx
!a1f(i,k,j)
if (p_psisol(i,k,j).gt.0.5d0) then
count_intr=count_intr+1.d0
endif
per(1)=per(1)+u(i,k,j)*p_alfa_psi_sol(i,k,j,id_sol)
per(2)=per(2)+v(i,k,j)*p_alfa_psi_sol(i,k,j,id_sol)
per(3)=per(3)+w(i,k,j)*p_alfa_psi_sol(i,k,j,id_sol)

    enddo
  enddo
enddo

!write(*,*) "id_sol, rank, counter,perx,y,z", id_sol,rank,count_intr , per

allocate (move_lag(3))
move_lag=0.0d0
!allocate (count_sum(1))
call MPI_Allreduce(per(:),move_lag(:),3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(count_intr,count_sum, 1,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

movi(:)=move_lag(:)/count_sum
!clockend = MPI_Wtime() !timing
!write(*,*) 'That took ',clockend-clockstart,' seconds'
deallocate(move_lag)
!deallocate(count_sum)


return
end
!################# collisions #############################################################

!################ Collisions solid vs solid ###################################

subroutine coll_detector
use commondata
use par_size
use grid
use velocity_old
use velocity
use sterms
use sim_par
use dual_grid
use wavenumber
use ibm_membrane
use three_phase
use mpi

double precision :: dist_ss,tol_ss,fcollss,c1,eps_1,eps_2,v_prom,diam_coll
integer ::id_col,jd_col
double precision :: rho_m, rho_mid, rho_mjd !rho immersed averaged

tol_ss=rad_esf*0.25d0 !tolerance coll sphere
eps_1= 0.125!0.000125d0   !8.0e-4 |   0.125    !fenj2005
eps_2= 0.02 !0.0002d0    !1.0e-5 |   0.02  fenj2005
volume_esf=pi*(rad_esf**2)
diam_coll=2*rad_esf! + 0.033
! write(*,*) "few_bod, ini_bodies, ntask_gl", few_bod,n_budies,ntask_gl
  if(few_bod.lt.ntask_gl) then
    do id_col=1,few_bod
      rho_mid=rho_fld*((1.0d0-immers(id_col))+rhor*immers(id_col))
      do jd_col=1,few_bod
        rho_mjd=rho_fld*((1.0d0-immers(jd_col))+rhor*immers(jd_col))
!------- Average density ----------------------------------------
        rho_m=(rho_mid+rho_mjd)*0.5d0
!-------------------------------------------------------------

        v_prom=dsqrt((mass_vel_lag_all(id_col,1,1)**2d0) &
        &+(mass_vel_lag_all(id_col,1,2)**2d0) &
        &+(mass_vel_lag_all(id_col,1,3)**2d0))
        c1=(1.0d0-rho_m/rho_part) !(0.0001*v_prom)!*(volume_esf))!**2/(rad_esf*2.d0)

        if(id_col.ne.jd_col) then
         dist_ss=dsqrt((xh_lagrang(id_col,1)-xh_lagrang(jd_col,1))**2 +&
         &(yh_lagrang(id_col,1)-yh_lagrang(jd_col,1))**2 +&
         &(zh_lagrang(id_col,1)-zh_lagrang(jd_col,1))**2)

         dist_ss=dabs(dist_ss)

         if((dist_ss.lt.(diam_coll+tol_ss)).and.(dist_ss.ge.(diam_coll))) then

         fcollss= (c1/eps_1)*(((dist_ss - diam_coll - tol_ss)/tol_ss)**2)!

         fcolssbud(id_col,1)=fcolssbud(id_col,1)+((xh_lagrang(id_col,1)-xh_lagrang(jd_col,1))/dist_ss)*fcollss
         fcolssbud(id_col,2)=fcolssbud(id_col,2)+((yh_lagrang(id_col,1)-yh_lagrang(jd_col,1))/dist_ss)*fcollss
         fcolssbud(id_col,3)=fcolssbud(id_col,3)+((zh_lagrang(id_col,1)-zh_lagrang(jd_col,1))/dist_ss)*fcollss
           write(*,*) 'solsol mild collision'
         elseif(dist_ss.lt.(diam_coll)) then

         fcollss=((c1/eps_1)*(((dist_ss - diam_coll - tol_ss)/tol_ss)**2)&
           + (c1/eps_2)*((diam_coll- dist_ss)/tol_ss))!*(diff/abs(diff))
         fcolssbud(id_col,1)=fcolssbud(id_col,1)+((xh_lagrang(id_col,1)-xh_lagrang(jd_col,1))/dist_ss)*fcollss
         fcolssbud(id_col,2)=fcolssbud(id_col,2)+((yh_lagrang(id_col,1)-yh_lagrang(jd_col,1))/dist_ss)*fcollss
         fcolssbud(id_col,3)=fcolssbud(id_col,3)+((zh_lagrang(id_col,1)-zh_lagrang(jd_col,1))/dist_ss)*fcollss
           write(*,*) 'estoy en lw hard collision'

         else
         fcolssbud(id_col,1)=fcolssbud(id_col,1)+0.0d0
         fcolssbud(id_col,2)=fcolssbud(id_col,2)+0.0d0
         fcolssbud(id_col,3)=fcolssbud(id_col,3)+0.0d0
         endif
       endif! different indexes
     enddo
    enddo
  ! endif!fin create bodies
  else! more solids than tasks

    do id_col=1,n_budies
      rho_mid=rho_fld*((1.0d0-immers(id_col))+rhor*immers(id_col))
      do jd_col=1,n_budies
      rho_mjd=rho_fld*((1.0d0-immers(jd_col))+rhor*immers(jd_col))
!------- Average density ----------------------------------------
      rho_m=(rho_mid+rho_mjd)*0.5d0
!-------------------------------------------------------------

        if(id_col.ne.jd_col) then
         dist_ss=dsqrt((xh_lagrang(id_col,1)-xh_lagrang(jd_col,1))**2 +&
         &(yh_lagrang(id_col,1)-yh_lagrang(jd_col,1))**2 +&
         &(zh_lagrang(id_col,1)-zh_lagrang(jd_col,1))**2)

         dist_ss=dabs(dist_ss)

         v_prom=dsqrt((mass_vel_lag_all(id_col,1,1)**2d0) &
         &+(mass_vel_lag_all(id_col,1,2)**2d0) &
         &+(mass_vel_lag_all(id_col,1,3)**2d0))
         c1=(1.0d0-rho_m/rho_part)!(0.0001*v_prom)!*(volume_esf))!**2/(rad_esf*2.d0)


         if((dist_ss.lt.(diam_coll+tol_ss)).and.(dist_ss.ge.(diam_coll))) then

         fcollss= (c1/eps_1)*(((dist_ss - diam_coll - tol_ss)/tol_ss)**2)!

         fcolssbud(id_col,1)=fcolssbud(id_col,1)+((xh_lagrang(id_col,1)-xh_lagrang(jd_col,1))/dist_ss)*fcollss
         fcolssbud(id_col,2)=fcolssbud(id_col,2)+((yh_lagrang(id_col,1)-yh_lagrang(jd_col,1))/dist_ss)*fcollss
         fcolssbud(id_col,3)=fcolssbud(id_col,3)+((zh_lagrang(id_col,1)-zh_lagrang(jd_col,1))/dist_ss)*fcollss
           write(*,*) 'solsol mild collision'
         elseif(dist_ss.lt.(diam_coll)) then

         fcollss=((c1/eps_1)*(((dist_ss - diam_coll - tol_ss)/tol_ss)**2)&
           + (c1/eps_2)*((diam_coll- dist_ss)/tol_ss))!*(diff/abs(diff))
         fcolssbud(id_col,1)=fcolssbud(id_col,1)+((xh_lagrang(id_col,1)-xh_lagrang(jd_col,1))/dist_ss)*fcollss
         fcolssbud(id_col,2)=fcolssbud(id_col,2)+((yh_lagrang(id_col,1)-yh_lagrang(jd_col,1))/dist_ss)*fcollss
         fcolssbud(id_col,3)=fcolssbud(id_col,3)+((zh_lagrang(id_col,1)-zh_lagrang(jd_col,1))/dist_ss)*fcollss
           write(*,*) 'estoy en lw hard collision'

         else
         fcolssbud(id_col,:)=fcolssbud(id_col,:)+0.0d0
         endif
       endif
     enddo
    enddo

  endif

call coll_solsol

return
end


subroutine coll_solsol
!############# collision #############################
use commondata
use par_size
use grid
use sim_par
use ibm_membrane
use three_phase
use mpi
integer          :: id_col



if(few_bod.lt.ntask_gl) then
  do id_col=1,few_bod
    mass_vel_lag_all(id_col,1,1)=mass_vel_lag_all(id_col,1,1)+ fcolssbud(id_col,1)*dt/(froude_ibm**2)
    mass_vel_lag_all(id_col,1,2)=mass_vel_lag_all(id_col,1,2)+ fcolssbud(id_col,2)*dt/(froude_ibm**2)
    mass_vel_lag_all(id_col,1,3)=mass_vel_lag_all(id_col,1,3)+ fcolssbud(id_col,3)*dt/(froude_ibm**2)
  enddo
else
  do id_col=1,n_budies
    mass_vel_lag_all(id_col,1,1)=mass_vel_lag_all(id_col,1,1)+ fcolssbud(id_col,1)*dt/(froude_ibm**2)
    mass_vel_lag_all(id_col,1,2)=mass_vel_lag_all(id_col,1,2)+ fcolssbud(id_col,2)*dt/(froude_ibm**2)
    mass_vel_lag_all(id_col,1,3)=mass_vel_lag_all(id_col,1,3)+ fcolssbud(id_col,3)*dt/(froude_ibm**2)
  enddo
endif

return
end subroutine coll_solsol


!################## read resume lag pos and vel #############################################


!###################### end collisions ####################################################
!################## read resume lag pos and vel #############################################


subroutine resume_lpsol(budy)

use commondata
use grid
use sim_par
use ibm_membrane
use three_phase
double precision :: vx_sol, vy_sol, vz_sol
double precision :: vel_sol(3)
integer:: i,time_step,dump, budy
character(len=40) :: fname
character(len=8) :: budie

write(budie,'(I8.8)') budy

fname='./initial_fields/sol'//trim(budie)//'.dat'

  ! if((mod(time_step,dump).eq.0)) then!.and.(time_step.gt.0))then

open(unit=73,file=fname ,access='direct',recl=132,form='formatted')

read(73,'(I8.8,f20.12,f20.8,f20.8,f20.12,f20.8,f20.8)',rec=(resumetimes+ndump)/ndump) time_step, xh_lagrang(budy,1),&
yh_lagrang(budy,1), zh_lagrang(budy,1),vx_sol, vy_sol, vz_sol

close(73)
  ! endif

end subroutine


subroutine resume_lvsol(budy)

use commondata
use grid
use sim_par
use ibm_membrane
use three_phase

double precision :: vel_sol(3)
integer:: i,time_step,dump, budy
character(len=40) :: fname
character(len=8) :: budie

write(budie,'(I8.8)') budy

fname='./initial_fields/sol'//trim(budie)//'.dat'

  ! if((mod(time_step,dump).eq.0)) then!.and.(time_step.gt.0))then

open(unit=73,file=fname ,access='direct',recl=132,form='formatted')

read(73,'(I8.8,f20.12,f20.8,f20.8,f20.12,f20.12,f20.12)',&
rec=(resumetimes+ndump)/ndump) time_step, xh_lagrang(budy,1),&
yh_lagrang(budy,1), zh_lagrang(budy,1), mass_vel_lag_all(budy,1,1)&
, mass_vel_lag_all(budy,1,2), mass_vel_lag_all(budy,1,3)

close(73)
  ! endif

end subroutine

!####################à####################################################################################

! saving all parameters related to the solid phase, which can be txt and serial since they are just one value no fields

subroutine write_solid(xh_sol,yh_sol,zh_sol,vel_sol,time_step, budy,dump)!(xh_l,yh_l, zh_l,vel_lag, time_step,f_hyd, mass_vel_lag, lag_mass_p)

use commondata
use grid
use sim_par
use ibm_membrane
use three_phase
double precision :: xh_sol, yh_sol, zh_sol
double precision :: vel_sol(3)
integer:: i,time_step,dump, budy
character(len=40) :: fname
character(len=8) :: budie

write(budie,'(I8.8)') budy

fname='./results/sol'//trim(budie)//'.dat'

 ! write(*,*) fname

if((mod(time_step,dump).eq.0)) then!.and.(time_step.gt.0))then
open(unit=33,file=fname ,access='direct',recl=258,form='formatted')


If(time_step.eq.0) then

write(33,'(I8.8,f20.16,f20.16,f20.16,f20.16,f20.16,f20.16&
,f20.12 , f20.12, f20.12, f20.12, f20.12, f20.12,a)',rec=1) time_step, &
xh_sol,yh_sol,zh_sol,vel_sol(1),vel_sol(2),vel_sol(3), &
cline_adv(budy), immers(budy), relfluidrho(budy),&
addedmass(budy), dragforce(budy), buoyforce(budy), char(10)

else

write(33,'(I8.8,f20.16,f20.16,f20.16,f20.16,f20.16,f20.16&
,f20.12 , f20.12, f20.12, f20.12, f20.12, f20.12,a)',rec=(time_step+dump)/dump) time_step, &
xh_sol,yh_sol,zh_sol,vel_sol(1),vel_sol(2),vel_sol(3), &
cline_adv(budy), immers(budy), relfluidrho(budy),&
addedmass(budy), dragforce(budy), buoyforce(budy), char(10)
endif

!(1 timestp, 2 x, 3 y,4 z,5 vx,6 vy,7 vz,8 contactline_advancement,9 displaced_volume
!,10 relative_density_fluid, 11 addmass_force, 12 drag_force, 13 buoy_force)


close(33)
endif

end subroutine write_solid

!####################à####################################################################################

!######## Viscosity in Solid volume ###############################################
! only for non-matched viscosities
subroutine viscosity_change(s1,s2,s3)
use commondata
use par_size
use phase_field
use wavenumber
use velocity
use sim_par
use velocity_old
use surfactant
use dual_grid
use three_phase
use ibm_membrane


double precision, dimension(spx,nz,spy,2) :: s1,s2,s3
double precision, allocatable, dimension(:,:,:,:) :: gradphix,gradphiy,gradphiz
double precision, allocatable, dimension(:,:,:,:) :: a4,a5,a6,a7,a8,a9
double precision, allocatable, dimension(:,:,:) :: fgradphix,fgradphiy,fgradphiz
double precision, allocatable, dimension(:,:,:) :: a4f,a5f,a6f,a7f,a8f,a9f,a10f,a11f,a12f,viscnon
double precision :: modg,threshold,gthreshold
double precision :: phif

integer :: i,j,k
#define match_visc matched_viscosity
#define match_dens matched_density

!#if psisol_flag == 1
if(flag_sdvis.eq.1) then

if (rank.eq.0) print*,'solid viscosity'

! first row
allocate(a4(spx,nz,spy,2))
allocate(a5(spx,nz,spy,2))
allocate(a6(spx,nz,spy,2))

call dz(uc,a6)

do j=1,spy
  do i=1,spx
    a4(i,:,j,1)=-kx(i+cstart(1))*uc(i,:,j,2)
    a4(i,:,j,2)=+kx(i+cstart(1))*uc(i,:,j,1)
    a5(i,:,j,1)=-ky(j+cstart(3))*uc(i,:,j,2)-kx(i+cstart(1))*vc(i,:,j,2)
    a5(i,:,j,2)=+ky(j+cstart(3))*uc(i,:,j,1)+kx(i+cstart(1))*vc(i,:,j,1)
    a6(i,:,j,1)=a6(i,:,j,1)-kx(i+cstart(1))*wc(i,:,j,2)
    a6(i,:,j,2)=a6(i,:,j,2)+kx(i+cstart(1))*wc(i,:,j,1)
  enddo
enddo

allocate(a4f(nx,fpz,fpy))
allocate(a5f(nx,fpz,fpy))
allocate(a6f(nx,fpz,fpy))

call spectral_to_phys(a4,a4f,0)
call spectral_to_phys(a5,a5f,0)
call spectral_to_phys(a6,a6f,0)


do j=1,fpy
  do k=1,fpz
    do i=1,nx
!if ((p_psisol(i,k,j).gt.0.1).and.(p_psisol(i,k,j).lt.0.8)) then
if(p_psisol(i,k,j).lt.0.50d0) then
cut_flux=p_psisol(i,k,j)
else
cut_flux=1.0d0
endif

!######### current viscosity ##############################
#if match_visc == 0
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=2.0d0*0.5d0*(visr-1.0d0)*(phif+1.0d0)*a4f(i,k,j)
viscurr(2)=0.5d0*(visr-1.0d0)*(phif+1.0d0)*a5f(i,k,j)
viscurr(3)=0.5d0*(visr-1.0d0)*(phif+1.0d0)*a6f(i,k,j)
#endif
#if match_visc == 1
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=0.0d0!2.0d0*0.5d0*(1.0d0)*(phif+1.0d0)*a4f(i,k,j)
viscurr(2)=0.0d0!0.5d0*(1.0d0)*(phif+1.0d0)*a5f(i,k,j)
viscurr(3)=0.0d0!0.5d0*(1.0d0)*(phif+1.0d0)*a6f(i,k,j)
#endif
#if match_visc == 2
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=2.0d0*0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a4f(i,k,j)
viscurr(2)=0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a5f(i,k,j)
viscurr(3)=0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a6f(i,k,j)
#endif
#if match_dens == 2
! rescale NS if rhor > 1 for improved stability
viscurr=viscurr/(rhor)*visr
#endif
if(p_psisol(i,k,j).ge.0.50d0) then
      a4f(i,k,j)=2.0d0*(soldynvis)*a4f(i,k,j)*cut_flux - viscurr(1)
      a5f(i,k,j)=(soldynvis)*a5f(i,k,j)*cut_flux- viscurr(2)
      a6f(i,k,j)=(soldynvis)*a6f(i,k,j)*cut_flux- viscurr(3)
!elseif((p_psisol(i,k,j).lt.0.50d0).and.(p_psisol(i,k,j).gt.0.01d0)) then
      ! a4f(i,k,j)=2.0d0*0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
      ! a5f(i,k,j)=0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
      ! a6f(i,k,j)=0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
  ! a4f(i,k,j)=2.0d0*(1.0d0/visr)*a4f(i,k,j)/soldynvis! -soldynvis*a4f(i,k,j)
  ! a5f(i,k,j)=(1.0d0/visr)*a5f(i,k,j)/soldynvis!-soldynvis*a5f(i,k,j)
  ! a6f(i,k,j)=(1.0d0/visr)*a6f(i,k,j)/soldynvis!-soldynvis*a6f(i,k,j)

endif
    enddo
  enddo
enddo

call phys_to_spectral(a4f,a4,0)
call phys_to_spectral(a5f,a5,0)
call phys_to_spectral(a6f,a6,0)


allocate(a7(spx,nz,spy,2))

do j=1,spy
  do i=1,spx
    a7(i,:,j,1)=-kx(i+cstart(1))*a4(i,:,j,2)-ky(j+cstart(3))*a5(i,:,j,2)
    a7(i,:,j,2)=+kx(i+cstart(1))*a4(i,:,j,1)+ky(j+cstart(3))*a5(i,:,j,1)
  enddo
enddo

call dz(a6,a4)


s1=s1+(a4+a7)/re

deallocate(a4)
deallocate(a5)
deallocate(a6)
deallocate(a7)

deallocate(a4f)
deallocate(a5f)
deallocate(a6f)


! second row
allocate(a4(spx,nz,spy,2))
allocate(a5(spx,nz,spy,2))
allocate(a6(spx,nz,spy,2))

call dz(vc,a6)

do j=1,spy
  do i=1,spx
    a4(i,:,j,1)=-ky(j+cstart(3))*uc(i,:,j,2)-kx(i+cstart(1))*vc(i,:,j,2)
    a4(i,:,j,2)=+ky(j+cstart(3))*uc(i,:,j,1)+kx(i+cstart(1))*vc(i,:,j,1)
    a5(i,:,j,1)=-ky(j+cstart(3))*vc(i,:,j,2)
    a5(i,:,j,2)=+ky(j+cstart(3))*vc(i,:,j,1)
    a6(i,:,j,1)=a6(i,:,j,1)-ky(j+cstart(3))*wc(i,:,j,2)
    a6(i,:,j,2)=a6(i,:,j,2)+ky(j+cstart(3))*wc(i,:,j,1)
  enddo
enddo

allocate(a4f(nx,fpz,fpy))
allocate(a5f(nx,fpz,fpy))
allocate(a6f(nx,fpz,fpy))

call spectral_to_phys(a4,a4f,0)
call spectral_to_phys(a5,a5f,0)
call spectral_to_phys(a6,a6f,0)

do j=1,fpy
  do k=1,fpz
    do i=1,nx

if(p_psisol(i,k,j).lt.0.50d0) then
cut_flux=p_psisol(i,k,j)
else
cut_flux=1.0d0
endif

!if ((p_psisol(i,k,j).gt.0.1).and.(p_psisol(i,k,j).lt.0.8)) then
!######### current viscosity ##############################
#if match_visc == 0
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=0.5d0*(visr-1.0d0)*(phif+1.0d0)*a4f(i,k,j)
viscurr(2)=2.0d0*0.5d0*(visr-1.0d0)*(phif+1.0d0)*a5f(i,k,j)
viscurr(3)=0.5d0*(visr-1.0d0)*(phif+1.0d0)*a6f(i,k,j)
#endif
#if match_visc == 1
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=0.0d0!0.5d0*(1.0d0)*(phif+1.0d0)*a4f(i,k,j)
viscurr(2)=0.0d0!2.0d0*(0.5d0*1.0d0)*(phif+1.0d0)*a5f(i,k,j)
viscurr(3)=0.0d0!0.5d0*(1.0d0)*(phif+1.0d0)*a6f(i,k,j)
#endif
#if match_visc == 2
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a4f(i,k,j)
viscurr(2)=2.0d0*0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a5f(i,k,j)
viscurr(3)=0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a6f(i,k,j)
#endif
#if match_dens == 2
! rescale NS if rhor > 1 for improved stability
viscurr=viscurr/(rhor)*visr
#endif
if(p_psisol(i,k,j).ge.0.50d0) then
      a4f(i,k,j)=(soldynvis)*a4f(i,k,j)*cut_flux - viscurr(1)
      a5f(i,k,j)=2.0d0*(soldynvis)*a5f(i,k,j)*cut_flux - viscurr(2)
      a6f(i,k,j)=(soldynvis)*a6f(i,k,j)*cut_flux - viscurr(3)
!elseif((p_psisol(i,k,j).lt.0.50d0).and.(p_psisol(i,k,j).gt.0.01d0)) then
  ! a4f(i,k,j)=0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
  ! a5f(i,k,j)=2.0d0*0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
  ! a6f(i,k,j)=0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
  ! a4f(i,k,j)=(1.0d0/visr)*a4f(i,k,j)/soldynvis!-soldynvis*a4f(i,k,j)
  ! a5f(i,k,j)=2.0d0*(1.0d0/visr-1.0d0)*a5f(i,k,j)/soldynvis!-soldynvis*a5f(i,k,j)
  ! a6f(i,k,j)=(1.0d0/visr)*a6f(i,k,j)/soldynvis!-soldynvis*a6f(i,k,j)
endif
    enddo
  enddo
enddo

call phys_to_spectral(a4f,a4,0)
call phys_to_spectral(a5f,a5,0)
call phys_to_spectral(a6f,a6,0)

allocate(a7(spx,nz,spy,2))

do j=1,spy
  do i=1,spx
    a7(i,:,j,1)=-kx(i+cstart(1))*a4(i,:,j,2)-ky(j+cstart(3))*a5(i,:,j,2)
    a7(i,:,j,2)=+kx(i+cstart(1))*a4(i,:,j,1)+ky(j+cstart(3))*a5(i,:,j,1)
  enddo
enddo

call dz(a6,a4)

! add to S term a4+a7
s2=s2+(a4+a7)/re

deallocate(a4)
deallocate(a5)
deallocate(a6)
deallocate(a7)

deallocate(a4f)
deallocate(a5f)
deallocate(a6f)

! third row
allocate(a4(spx,nz,spy,2))
allocate(a5(spx,nz,spy,2))
allocate(a6(spx,nz,spy,2))

call dz(uc,a4)
call dz(vc,a5)
call dz(wc,a6)

do j=1,spy
  do i=1,spx
    a4(i,:,j,1)=a4(i,:,j,1)-kx(i+cstart(1))*wc(i,:,j,2)
    a4(i,:,j,2)=a4(i,:,j,2)+kx(i+cstart(1))*wc(i,:,j,1)
    a5(i,:,j,1)=a5(i,:,j,1)-ky(j+cstart(3))*wc(i,:,j,2)
    a5(i,:,j,2)=a5(i,:,j,2)+ky(j+cstart(3))*wc(i,:,j,1)
  enddo
enddo

allocate(a4f(nx,fpz,fpy))
allocate(a5f(nx,fpz,fpy))
allocate(a6f(nx,fpz,fpy))

call spectral_to_phys(a4,a4f,0)
call spectral_to_phys(a5,a5f,0)
call spectral_to_phys(a6,a6f,0)

do j=1,fpy
  do k=1,fpz
    do i=1,nx
!if ((p_psisol(i,k,j).gt.0.1).and.(p_psisol(i,k,j).lt.0.8)) then
if(p_psisol(i,k,j).lt.0.50d0) then
cut_flux=p_psisol(i,k,j)
else
cut_flux=1.0d0
endif

!######### current viscosity ##############################
#if match_visc == 0
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=0.5d0*(visr-1.0d0)*(phif+1.0d0)*a4f(i,k,j)
viscurr(2)=0.5d0*(visr-1.0d0)*(phif+1.0d0)*a5f(i,k,j)
viscurr(3)=2.0d0*0.5d0*(visr-1.0d0)*(phif+1.0d0)*a6f(i,k,j)
#endif
#if match_visc == 1
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=0.0d0!0.5d0*(1.0d0)*(phif+1.0d0)*a4f(i,k,j)
viscurr(2)=0.0d0!0.5d0*(1.0d0)*(phif+1.0d0)*a5f(i,k,j)
viscurr(3)=0.0d0!2.0d0*0.5d0*(1.0d0)*(phif+1.0d0)*a6f(i,k,j)
#endif
#if match_visc == 2
phif=min(1.0d0,max(-1.0d0,phi(i,k,j)))
viscurr(1)=0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a4f(i,k,j)
viscurr(2)=0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a5f(i,k,j)
viscurr(3)=2.0d0*0.5d0*(1.0d0-1.0d0/visr)*(phif-1.0d0)*a6f(i,k,j)
#endif
#if match_dens == 2
! rescale NS if rhor > 1 for improved stability
viscurr=viscurr/(rhor)*visr
#endif
if(p_psisol(i,k,j).ge.0.50d0) then
    a4f(i,k,j)=(soldynvis)*a4f(i,k,j)*cut_flux - viscurr(1)
    a5f(i,k,j)=(soldynvis)*a5f(i,k,j)*cut_flux - viscurr(2)
    a6f(i,k,j)=2.0d0*(soldynvis)*a6f(i,k,j)*cut_flux - viscurr(3)
! elseif((p_psisol(i,k,j).lt.0.50d0).and.(p_psisol(i,k,j).gt.0.01d0)) then
!   ! a4f(i,k,j)=0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
!   ! a5f(i,k,j)=0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
!   ! a6f(i,k,j)=2.0d0*0.5d0*(1.0d0/visr-soldynvis)*(phif-1.0d0)*a4f(i,k,j)
!   a4f(i,k,j)=(1.0d0/visr)*a4f(i,k,j)/soldynvis!-soldynvis*a4f(i,k,j)
!   a5f(i,k,j)=(1.0d0/visr)*a5f(i,k,j)/soldynvis!-soldynvis*a5f(i,k,j)
!   a6f(i,k,j)=2.0d0*(1.0d0/visr)*a6f(i,k,j)/soldynvis!-soldynvis*a6f(i,k,j)
endif
    enddo
  enddo
enddo

call phys_to_spectral(a4f,a4,0)
call phys_to_spectral(a5f,a5,0)
call phys_to_spectral(a6f,a6,0)

allocate(a7(spx,nz,spy,2))

do j=1,spy
  do i=1,spx
    a7(i,:,j,1)=-kx(i+cstart(1))*a4(i,:,j,2)-ky(j+cstart(3))*a5(i,:,j,2)
    a7(i,:,j,2)=+kx(i+cstart(1))*a4(i,:,j,1)+ky(j+cstart(3))*a5(i,:,j,1)
  enddo
enddo

call dz(a6,a4)

! add to S term a4+a7
s3=s3+(a4+a7)/re

deallocate(a4,a5,a6,a7)
deallocate(a4f,a5f,a6f)

endif!End Block Visc-soldid body
!#endif

end subroutine viscosity_change

!!!!!!!!!!!!!!!!###############immersed fraction####################!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine immersed_frac(id_sol)
use commondata
use par_size
use grid
use phase_field
use velocity_old
use velocity
use sterms
use sim_par
use dual_grid
use wavenumber
use ibm_membrane
use three_phase
use mpi

double precision ::  count_drop, count_fl, countdrop_sum, countfl_sum,cap,volesph
integer :: id_sol
!###########################  ghost phase velocity interpolation ##########

!clockstart = MPI_Wtime() !timing
count_drop=0.0d0
count_fl=0.0d0

 do j=1,fpy
   do k=1,fpz
     do i=1,nx
!a1f(i,k,j)
if ((p_alfa_psi_sol(i,k,j,id_sol).lt.0.25d0).and.&
(p_alfa_psi_sol(i,k,j,id_sol).gt.0.1d0)) then
  if(phi(i,k,j).gt.0.0d0) then
  count_drop=count_drop+1.d0
  count_fl=count_fl+0.0d0
  elseif(phi(i,k,j).lt.0.0d0) then
  count_drop=count_drop+0.d0
  count_fl=count_fl+1.0d0
  endif
endif

    enddo
  enddo
enddo

!write(*,*) "id_sol, rank, counter,perx,y,z", id_sol,rank,count_intr , per

call MPI_Allreduce(count_drop,countdrop_sum, 1,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(count_fl,countfl_sum, 1,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

!--- Getting the percentage of immersed body in the drop-phase from all ranks -------------
immers(id_sol)=countdrop_sum/(countdrop_sum + countfl_sum)
!-------------contact line advancement ------------------------------------
cline_adv(id_sol)=immers(id_sol)
!if it is a Sphere then ----------------------------------
!----------- displaced volume in drop phase --------------------

immers(id_sol)=immers(id_sol)*2*rad_esf
if (immers(id_sol).le.(rad_esf)) then
cap=pi*(immers(id_sol)**2)*(3.0d0*rad_esf-immers(id_sol))/3.0d0
volesph=(4.0d0/3.0d0)*pi*(rad_esf**3)
immers(id_sol)=cap/volesph

elseif (immers(id_sol).gt.rad_esf) then
immers(id_sol)=2.0d0*rad_esf - immers(id_sol)
volesph=(4.0d0/3.0d0)*pi*(rad_esf**3)
cap=volesph - pi*(immers(id_sol)**2)*(3.0d0*rad_esf-immers(id_sol))/3.0d0
immers(id_sol)=cap/volesph
endif

if(rank.eq.0) write(*,*) 'Solid', id_sol, 'immersed',immers(id_sol),' in drop'
!clockend = MPI_Wtime() !timing
!write(*,*) 'That took ',clockend-clockstart,' seconds'

return
end
!----------end immersed fraction ------------------------------
