subroutine solver(ntime,rest_length, ang_bend, lenteja, rest_inv_beam)

use mpi
use commondata
use par_size
use sim_par
use velocity
use sterms
use grid
use phase_field
use surfactant
use temperature
use particle
use dual_grid
use wavenumber
use ibm_membrane
use three_phase
#define masspoint_flag masspointflag
#define psisol_flag psisolflag

double precision, allocatable, dimension(:,:,:,:) :: s1,s2,s3,sphi,hphi,spsi,hpsi,stheta,htheta
double precision, dimension(spx,nz,spy,2) :: h1,h2,h3,h,omega
double precision, dimension(spx,nz,spy,2) :: gradphix_f,gradphiy_f,gradphiz_f
double precision :: xh_l(n_budies,nz_h), yh_l(n_budies,nz_h), zh_l(n_budies,nz_h)
double precision :: frz_ibm_ibud(nx,nz,ny,3,n_budies,nz_h)!, frz_ibm(nx,nz,ny,3)
! double precision, allocatable, dimension(:,:,:,:) :: frz_ibm_rank, frz_ibm
double precision :: f_ibmu(nx,fpz,fpy), f_ibmv(nx,fpz,fpy), f_ibmw(nx,fpz,fpy)
double precision :: f_ibmuc(spx,nz,spy,2), f_ibmvc(spx,nz,spy,2), f_ibmwc(spx,nz,spy,2)
integer          :: indx_eul(n_budies,nz_h,3)
double precision :: diste_l(nz_h,3,2*n_supp+1)
integer :: ntime
integer   :: ic, jc, kc,i,j,k
double precision, allocatable, dimension(:,:,:) :: umm, um1
double precision, allocatable, dimension(:,:,:) :: vmm, vm1
double precision, allocatable, dimension(:,:,:) :: wmm, wm1
double precision :: perxzy(n_budies,nz_h,3)!,lag_mass_p(n_budies,nz_h,3)
double precision, allocatable, dimension(:,:,:) :: lag_mass_p
double precision :: mass_vel(nx,nz,ny,3),f_hyd(3)
double precision :: m_vel_lag(n_budies,nz_h,3)
!preferred shapes
double precision :: rest_length(n_budies,nz_h), lenteja(n_budies,nz_h)
double precision :: ang_bend(n_budies,nz_h,3)
double precision :: rest_inv_beam(n_budies,nz_h,3)
!efficient
double precision :: xl_c(n_budies,nz_h),yl_c(n_budies,nz_h),zl_c(n_budies,nz_h)
integer :: i_blq(nx),j_blq(fpy),k_blq(fpz)
! integer, allocatable, dimension(:) :: indx_box!(6)
integer :: box_cut_ini(3),box_cut_fin(3)
!integer :: iblock_found(2*nx_supp+1),jblock_found(2*ny_supp+1),kblock_found(2*nz_supp+1)
integer :: jj_corr,ii_corr,kk_corr
! double precision, allocatable, dimension(:,:,:,:) :: u_supp,u_pert
! double precision, allocatable, dimension(:,:,:,:) :: v_supp,v_pert
! double precision, allocatable, dimension(:,:,:,:) :: w_supp,w_pert
! Phi on the IBM surface
double precision, allocatable, dimension (:,:,:)::phi_co, psi_co
!half_step_varuables
double precision :: xh_l_half(n_budies,nz_h), yh_l_half(n_budies,nz_h), zh_l_half(n_budies,nz_h)
double precision :: lag_mass_p_half(n_budies,nz_h,3),mass_vel_lag_half(n_budies,nz_h,3)
double precision :: mass_vel_lag_prev(n_budies,nz_h,3)
double precision :: solid_force_bud(n_budies,3),solid_force_prevbud(n_budies,3)
#define phiflag phicompflag
#define psiflag psicompflag
#define tempflag tempcompflag
#define partflag particlecompflag
#define twowayc twowaycflag
#define boussinnesq boussinnesqcompflag
#define match_dens matched_density
#define expx expansionx
#define expy expansiony
#define expz expansionz
#define cpiflag cpicompflag
#define part_surface activateSurfaceForce
#define ibmflag ibmcompflag

! flow part
if(rank.lt.flow_comm_lim)then
!split step method IBM

! allocating three_phase for Ch
!
! #if psisol_flag == 1
! #if phiflag == 1
! allocate(fnsx_psisolc(spx,nz,spy,2))
! allocate(fnsy_psisolc(spx,nz,spy,2))
! allocate(fnsz_psisolc(spx,nz,spy,2))
!
! #endif
! #endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
cho_sub_t=0
do while (cho_sub_t.lt.2)
cho_sub_t=cho_sub_t+1
!if(rank.eq.0) write(*,*) "substep N°", 0.5*(cho_sub_t)

if(cho_sub_t.eq.1)then
uc_ene=uc
vc_ene=vc
wc_ene=wc
endif

allocate(s1(spx,nz,spy,2))
allocate(s2(spx,nz,spy,2))
allocate(s3(spx,nz,spy,2))

 s1=0.0d0
 s2=0.0d0
 s3=0.0d0

call convective_ns(s1,s2,s3)

#if cpiflag == 0
#if match_dens == 2
 ! rescale NS equation if rhor > 1 for improved stability
  s1=s1-sgradpx/rhor
  s2=s2-sgradpy/rhor
#else
  s1=s1-sgradpx
  s2=s2-sgradpy
#endif
#elif cpiflag == 1
#if match_dens == 2
 ! rescale NS equation if rhor > 1 for improved stability
  s1=s1-sgradpx*dabs(gradpx)/rhor
  s2=s2-sgradpy*dabs(gradpy)/rhor
#else
  s1=s1-sgradpx*dabs(gradpx)
  s2=s2-sgradpy*dabs(gradpy)
#endif
#endif


! add non-linear part of phase field to N-S non-linear terms

#if phiflag == 1
!if(cho_sub_t.eq.2) then
 call phi_non_linear(s1,s2,s3)
!endif
#endif


! add temperature contribution to N-S non-linear terms (Boussinesq)
#if tempflag == 1
#if boussinnesq == 1
 ! write(*,*) grav*Ra/(16.0d0*Pr*Re**2)
 s1=s1-grav(1)*Ra/(16.0d0*Pr*Re**2)*thetac
 s2=s2-grav(3)*Ra/(16.0d0*Pr*Re**2)*thetac
 s3=s3-grav(2)*Ra/(16.0d0*Pr*Re**2)*thetac
#endif
#endif
!-----------------------------------------------------------------------------------------

!!!Kevin Contribution!!!---!!! fuerza_membrana_IBM + RHS_N-S
#if ibmflag == 1

 !Bringing velocities to physical space
call viscosity_change(s1,s2,s3)

 call spectral_to_phys(uc,u,1)
 call spectral_to_phys(vc,v,1)
 call spectral_to_phys(wc,w,1)
!################### Effciency ########################################
allocate (vel_interp(n_budies,3))
! allocate(frz_ibm_rank(nx,nz,ny,3))
! allocate(frz_ibm(nx,nz,ny,3))
allocate(lag_mass_p(n_budies,nz_h,3))

frz_ibm_rank=0.0d0
frz_ibm_ibud=0.0d0

box_cut_ini=0
box_cut_fin=0
i_blq=0
j_blq=0
k_blq=0

do i=fstart(1)+1,fstart(1)+nx
  i_blq(i-fstart(1))=i
enddo
do j=fstart(3)+1,fstart(3)+fpy
  j_blq(j-fstart(3))=j
enddo
do k=fstart(2)+1,fstart(2)+fpz
  k_blq(k-fstart(2))=k
enddo
!write(*,*) k_blq
xl_c=xh_lagrang
yl_c=yh_lagrang
zl_c=zh_lagrang

!if(rank.ne.0) then
xh_l=0.0d0
yh_l=0.0d0
zh_l=0.0d0
#if masspoint_flag == 1
lag_mass_p=0.0d0
m_vel_lag=0.0d0
lag_mass_p_half=0.0d0
mass_vel_lag_half=0.0d0
solid_force_bud=0.0d0
solid_force_prevbud=0.0d0
#endif
! indx_box=0
do i_nbudies=n_budies_ini_rank,n_budies_fin_rank !distribution of part

xh_l(i_nbudies,:)=xh_lagrang(i_nbudies,:)
yh_l(i_nbudies,:)=yh_lagrang(i_nbudies,:)
zh_l(i_nbudies,:)=zh_lagrang(i_nbudies,:)
#if masspoint_flag == 1
lag_mass_p(i_nbudies,:,:)=massiv_xyz_all(i_nbudies,:,:)
!#####################collision detector#######################
if(part_part_coll.eq.1) then
fcolssbud=0.0d0
call coll_detector
endif
!######################################################
m_vel_lag(i_nbudies,:,:)=mass_vel_lag_all(i_nbudies,:,:)
lag_mass_p_half(i_nbudies,:,:)=massiv_xyz_half_all(i_nbudies,:,:)
mass_vel_lag_half(i_nbudies,:,:)=mass_vel_lag_half_all(i_nbudies,:,:)
mass_vel_lag_prev(i_nbudies,:,:)=mass_vel_lag_prev_all(i_nbudies,:,:)
solid_force_bud(i_nbudies,:)=solid_force(i_nbudies,:)
solid_force_prevbud(i_nbudies,:)=solid_force_prev(i_nbudies,:)
#endif
enddo
if(rank.eq.1) then
!write(*,*) "l_mx, l_my, l_mz",xh_lagrang(1,:),yh_lagrang(1,:),zh_lagrang(1,:)
write(*,*) "vel_mx, vel_my, vel_mz", mass_vel_lag_all(1,1,:)
endif
!############################ Three phase : solid phase ########################
!----------------- Updating the solid phase filed ------------------------------
#if psisol_flag == 1
p_psisol=0.0d0 !new every time step
p_alfa_psi_sol=0.0d0 !new every time step
do i_nbudies=1,n_budies
  if(few_bod.lt.ntask_gl) then
    if(i_nbudies.le.few_bod) then
    call ini_pbodies(xh_lagrang(i_nbudies,1),yh_lagrang(i_nbudies,1)&
    , zh_lagrang(i_nbudies,1),i_nbudies)
    endif
  else
    call ini_pbodies(xh_lagrang(i_nbudies,1),yh_lagrang(i_nbudies,1)&
    , zh_lagrang(i_nbudies,1),i_nbudies)
  endif
enddo

call phys_to_spectral(p_psisol,p_psisolc,0)

#if phiflag == 1
if(cho_sub_t.eq.2) then
! #################################
  call spectral_to_phys(phic,phi,0)
  call phi_clean
  call phys_to_spectral(phi,phic,0)
!###################################
!!call sphase_coupledfce
endif
#endif

!-------------------- Calculating feedback to the fluid ------------------------

#endif
!########################## end solid phase ####################################
!################ mapping the velocity each rank parallel for all particles
!initialization of all velocities as 0
vel_interp=0.0d0
! Interpolating velocities, for 2nd_time we use an intermediate velocity
do i_nbudies=1,n_budies
  if(few_bod.lt.ntask_gl) then
    if(i_nbudies.le.few_bod) then
      call interp_vel(vel_interp(i_nbudies,:),i_nbudies)
    endif
  else
      call interp_vel(vel_interp(i_nbudies,:),i_nbudies)
  endif
enddo

!-------Phase Immersed Solid Fraction ----------------
do i_nbudies=1,n_budies
  if(few_bod.lt.ntask_gl) then
    if(i_nbudies.le.few_bod) then
      call immersed_frac(i_nbudies)
    endif
  else
      call immersed_frac(i_nbudies)
  endif
enddo

!-------------------------------------------------

! if(cho_sub_t.eq.2)then
! uc=uc_ene
! vc=vc_ene
! wc=wc_ene
! call spectral_to_phys(uc,u,1)
! call spectral_to_phys(vc,v,1)
! call spectral_to_phys(wc,w,1)
! !reset the velocity field to sub_t=1
! endif



do i_nz=1,nz_h
  do i_nbudies=n_budies_ini_rank,n_budies_fin_rank !distribution of part

!### sum velocities in IBM_SOLVER
if(cho_sub_t.eq.2) then!first half time
  if(few_bod.lt.ntask_gl) then
    if(i_nbudies.le.few_bod) then
  call svf_solver_2nd(xh_l(i_nbudies,i_nz), yh_l(i_nbudies,i_nz), &
  zh_l(i_nbudies,i_nz), frz_ibm_ibud(:,:,:,:,i_nbudies,i_nz),&
  lag_mass_p(i_nbudies,i_nz,:), m_vel_lag(i_nbudies,i_nz,:),&
  vel_interp(i_nbudies,:), f_hyd,&
  solid_force_bud(i_nbudies,:),solid_force_prevbud(i_nbudies,:), &
  i_nbudies)

  frz_ibm_rank(:,:,:,:)=frz_ibm_rank(:,:,:,:)+frz_ibm_ibud(:,:,:,:,i_nbudies,i_nz)  !collecting data from all bodies
    else
  frz_ibm_ibud(:,:,:,:,i_nbudies,i_nz)=0.0d0
  frz_ibm_rank(:,:,:,:)=frz_ibm_rank(:,:,:,:)+frz_ibm_ibud(:,:,:,:,i_nbudies,i_nz)
    endif
  else
  call svf_solver_2nd(xh_l(i_nbudies,i_nz), yh_l(i_nbudies,i_nz), &
  zh_l(i_nbudies,i_nz), frz_ibm_ibud(:,:,:,:,i_nbudies,i_nz),&
  lag_mass_p(i_nbudies,i_nz,:), m_vel_lag(i_nbudies,i_nz,:),&
  vel_interp(i_nbudies,:), f_hyd,&
  solid_force_bud(i_nbudies,:),solid_force_prevbud(i_nbudies,:), &
  i_nbudies)

  frz_ibm_rank(:,:,:,:)=frz_ibm_rank(:,:,:,:)+frz_ibm_ibud(:,:,:,:,i_nbudies,i_nz) !collecting data from all bodies

  endif
endif

if(cho_sub_t.eq.1)then
  ! write(*,*) "inside solver 1 vx vy vz", vel_interp(1,:)
  if(few_bod.lt.ntask_gl) then
    if(i_nbudies.le.few_bod) then

  call svf_solver_1st(xh_l(i_nbudies,i_nz), yh_l(i_nbudies,i_nz), &
  zh_l(i_nbudies,i_nz), lag_mass_p(i_nbudies,i_nz,:),&
  m_vel_lag(i_nbudies,i_nz,:),mass_vel_lag_half(i_nbudies,i_nz,:),&
  mass_vel_lag_prev(i_nbudies,i_nz,:) ,vel_interp(i_nbudies,:), f_hyd,&
  solid_force_bud(i_nbudies,:),solid_force_prevbud(i_nbudies,:), &
  i_nbudies)
      else
  frz_ibm_ibud(:,:,:,:,i_nbudies,i_nz)=0.0d0
    endif
  else
call svf_solver_1st(xh_l(i_nbudies,i_nz), yh_l(i_nbudies,i_nz), &
zh_l(i_nbudies,i_nz), lag_mass_p(i_nbudies,i_nz,:),&
m_vel_lag(i_nbudies,i_nz,:),mass_vel_lag_half(i_nbudies,i_nz,:),&
mass_vel_lag_prev(i_nbudies,i_nz,:),vel_interp(i_nbudies,:), f_hyd,&
solid_force_bud(i_nbudies,:),solid_force_prevbud(i_nbudies,:), &
i_nbudies)
endif

endif!(cho_sub_t.eq.2)then

enddo

if(cho_sub_t.eq.2) then!second half
xh_l(:,1)=lag_mass_p(:,1,1)
yh_l(:,1)=lag_mass_p(:,1,2)
zh_l(:,1)=lag_mass_p(:,1,3)

! #if masspoint_flag == 1
! mass_vel_lag_half=m_vel_lag
! #endif
endif!end second half

enddo


!if(cho_sub_t.eq.2) then!first half time

  frz_ibm=0.0d0
call MPI_Allreduce(frz_ibm_rank(:,:,:,:),frz_ibm(:,:,:,:), nx*nz*ny*3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)


!! Return frz to processes and chop it
if(rank.lt.ntask_gl) then
! call MPI_Bcast(frz_ibm, nx*ny*nz*3, mpi_double_precision,&
! 0, cart_comm,ierr)

f_ibmu=0.0d0
f_ibmv=0.0d0
f_ibmw=0.0d0

 do i=fstart(1)+1,fstart(1)+nx
 ic=i-fstart(1)
  do j=fstart(3)+1,fstart(3)+fpy
  jc=j-fstart(3)
   do k=fstart(2)+1,fstart(2)+fpz
    kc=k-fstart(2)
       f_ibmu(ic,kc,jc)=frz_ibm(i,k,j,1)
       f_ibmv(ic,kc,jc)=frz_ibm(i,k,j,2)
       f_ibmw(ic,kc,jc)=frz_ibm(i,k,j,3)

   enddo
  enddo
enddo

endif!if(rank.lt.ntask_gl)

!endif!cho_sub_t.eq.2
!half time
!write(*,*) 'after 2nd Bcast'
!%%%%%%%%%%%%%%Reducing all the massive lagrangian position into one array, compiling from ranks

call MPI_ALLREDUCE (xh_l(:,:), xh_lagrang(:,:),&
n_budies*nz_h,MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm, ierr)
call MPI_ALLREDUCE (yh_l(:,:), yh_lagrang(:,:),&
n_budies*nz_h,MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm, ierr)
call MPI_ALLREDUCE (zh_l(:,:), zh_lagrang(:,:),&
n_budies*nz_h,MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm, ierr)

#if masspoint_flag == 1
call MPI_Allreduce(lag_mass_p(:,:,:),massiv_xyz_all(:,:,:), n_budies*nz_h*3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(lag_mass_p_half(:,:,:),massiv_xyz_half_all(:,:,:), n_budies*nz_h*3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(m_vel_lag(:,:,:),mass_vel_lag_all(:,:,:), n_budies*nz_h*3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(mass_vel_lag_half(:,:,:),mass_vel_lag_half_all(:,:,:), n_budies*nz_h*3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(mass_vel_lag_prev(:,:,:),mass_vel_lag_prev_all(:,:,:), n_budies*nz_h*3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(solid_force_bud(:,:),solid_force(:,:), n_budies*3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(solid_force_prevbud(:,:),solid_force_prev(:,:), n_budies*3,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)
!plot for falling SPhere
call MPI_Allreduce(relfluidrhobud(:),relfluidrho(:), n_budies,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(addedmassbud(:),addedmass(:), n_budies,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(dragforcebud(:),dragforce(:), n_budies,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

call MPI_Allreduce(buoyforcebud(:),buoyforce(:), n_budies,&
MPI_DOUBLE_PRECISION, MPI_SUM, cart_comm,ierr)

#endif

! if(rank.le.ntask_gl) write(*,*) 'mass_vel_lag_all,mass_vel_lag_half_all', rank,'[', &
! mass_vel_lag_all(:,1,3),mass_vel_lag_half_all(:,1,3),']'
! endif
!###
!################### Effciency ########################################
!------------------End preparation--------------------------

! deallocate(frz_ibm_rank) !now it is in main
! deallocate(frz_ibm)
deallocate(lag_mass_p)

!f_ibmu=f_ibmu
!f_ibmv=f_ibmv
!f_ibmw=f_ibmw
call phys_to_spectral(f_ibmu,f_ibmuc,0)
call phys_to_spectral(f_ibmv,f_ibmvc,0)
call phys_to_spectral(f_ibmw,f_ibmwc,0)

call phys_to_spectral(u,uc,0)
call phys_to_spectral(v,vc,0)
call phys_to_spectral(w,wc,0)

if(cho_sub_t.eq.2) then
s1=s1+f_ibmuc
s2=s2+f_ibmvc
s3=s3+f_ibmwc

! #if phiflag == 1
! #if psisol_flag == 1
! s1=s1+fnsx_psisolc
! s2=s2+fnsy_psisolc
! s3=s3+fnsz_psisolc
! #endif
! #endif
endif !end cho_sub=2

if(cho_sub_t.eq.2)then

!### writing p_psisol ###########
if(mod(ntime,ndump).eq.0)then!
call genpsi(ntime)
endif
!### writing p_psisol ###########

if((mod(ntime,ndump).eq.0).and.(rank.eq.0))then!
 !distribution of part

!   call ibm_lag_to_vtk(massiv_xyz_all(1,1,1),massiv_xyz_all(1,1,2),massiv_xyz_all(1,1,3), ntime)
!   write(*,*) 'Write Vtr for Lagrangian pts in ntime ', ntime
old_forza(:,:,:)=0.0d0
do i_nz=1,nz_h
  do i_nbudies=1,n_budies
    if(few_bod.lt.ntask_gl) then
      if(i_nbudies.le.few_bod) then
   call delta_indices(xh_lagrang(i_nbudies,i_nz),yh_lagrang(i_nbudies,i_nz),&
    zh_lagrang(i_nbudies,i_nz), indx_eul(i_nbudies,i_nz,:),diste_l)
   ! call ibm_object_gen(xh_lagrang(i_nbudies,i_nz),yh_lagrang(i_nbudies,i_nz),&
   !  zh_lagrang(i_nbudies,i_nz), indx_eul(i_nbudies,i_nz,:), ntime)
   call write_vel(zh_lagrang(1,1),m_vel_lag(1,1,:), ntime)
   call ibm_lag_to_vtk(massiv_xyz_all(1,1,1),massiv_xyz_all(1,1,2),massiv_xyz_all(1,1,3), ntime)
      endif
    else
      call delta_indices(xh_lagrang(i_nbudies,i_nz),yh_lagrang(i_nbudies,i_nz),&
       zh_lagrang(i_nbudies,i_nz), indx_eul(i_nbudies,i_nz,:),diste_l)
      ! call ibm_object_gen(xh_lagrang(i_nbudies,i_nz),yh_lagrang(i_nbudies,i_nz),&
      !  zh_lagrang(i_nbudies,i_nz), indx_eul(i_nbudies,i_nz,:), ntime)
      call write_vel(zh_lagrang(1,1),m_vel_lag(1,1,:), ntime)
    call ibm_lag_to_vtk(massiv_xyz_all(1,1,1),massiv_xyz_all(1,1,2),massiv_xyz_all(1,1,3), ntime)
    endif
enddo
enddo

!   call ibm_frc_write(ntime,frz_ibm)
!   write(*,*) 'Write Vtr for forces the sum of all the layers frz_ibm_rank = frz_ibmin ntime ', ntime
!call write_vel(xh_l,yh_l, zh_l,perxzy, ntime, f_hyd, mass_vel_lag, lag_mass_p)

endif
endif! end sub_second half
! deallocate(frz_ibm) ! now in main
! deallocate(indx_box)
deallocate (vel_interp)
#endif
!############### end IBM #####################
 ! time integration of the non-linear terms
 ! for first time step the code uses an explicit Euler algorithm,
 ! while from the second time step on an Adams-Bashforth algorithm
if(cho_sub_t.eq.1)then
 if (ntime.eq.nstart+1)then
   call euler_half(s1,s2,s3,h1,h2,h3)
 else
   call adams_bashforth_half(s1,s2,s3,h1,h2,h3)
 endif
elseif(cho_sub_t.eq.2)then
    call adams_bashforth_2nd(s1,s2,s3,h1,h2,h3)
endif

!if(cho_sub_t.eq.2)then
 s1_o=s1
 s2_o=s2
 s3_o=s3
!endif
 deallocate(s1)
 deallocate(s2)
 deallocate(s3)

 ! add linear contribution to history term
 call hist_term(h1,h2,h3,h)

 ! solve Helmholtz equation for w
 call calculate_w(h)
! endif
! solve Helmholtz equation for omega_z and store in h1
 call calculate_omega(h1,h2,omega)

 ! calculate u,v from continuity and vorticity definition
call calculate_uv(omega,h1,h2)

call chop_modes(uc)
call chop_modes(vc)
call chop_modes(wc)

! endif
 ! only if surfactant calculated on finer grid than phase field
#if expx != 1 || expy != 1 || expz != 1
 ! for phase field calculation
 call spectral_to_phys(uc,u,1)
 call spectral_to_phys(vc,v,1)
 call spectral_to_phys(wc,w,1)
 ! for surfactant calculation
 call coarse2fine(uc,uc_fg)
 call spectral_to_phys_fg(uc_fg,u_fg,1)
 call coarse2fine(vc,vc_fg)
 call spectral_to_phys_fg(vc_fg,v_fg,1)
 call coarse2fine(wc,wc_fg)
 call spectral_to_phys_fg(wc_fg,w_fg,1)
#else
call spectral_to_phys(uc,u,1)
call spectral_to_phys(vc,v,1)
call spectral_to_phys(wc,w,1)
uc_fg=uc
vc_fg=vc
wc_fg=wc
u_fg=u
v_fg=v
w_fg=w
#endif
! enddo! endo loop 1/2 time

 ! Cahn-Hilliard equation solution
#if phiflag == 1
if(cho_sub_t.eq.2) then
 allocate(sphi(spx,nz,spy,2))
 allocate(hphi(spx,nz,spy,2))
 ! calculate non-linear terms of Cahn-Hilliard equation
 call sterm_ch(sphi)

 if (ntime.eq.nstart+1)then
   call euler_phi(sphi,hphi)
 else
   call adams_bashforth_phi(sphi,hphi)
 endif
 sphi_o=sphi

 deallocate(sphi)

 ! history term
 hphi=hphi+phic

 call calculate_phi(hphi)

 deallocate(hphi)

 call chop_modes(phic)
endif

enddo! endo loop 1/2 time


 ! Cahn-Hilliard equation for surfactant
#if psiflag == 1
 allocate(spsi(spxpsi,npsiz,spypsi,2))
 allocate(hpsi(spxpsi,npsiz,spypsi,2))
 ! calculate non-linear terms of surfactant Cahn-Hilliard equation
 call sterm_surf(spsi)

 if (ntime.eq.nstart+1)then
   call euler_psi(spsi,hpsi)
 else
   call adams_bashforth_psi(spsi,hpsi)
 endif

 spsi_o=spsi

 deallocate(spsi)

 hpsi=hpsi+psic_fg

 call calculate_psi(hpsi)

 deallocate(hpsi)

 call chop_modes_fg(psic_fg)
#endif

! surfactant part executed only iff the phase field is activated
#endif


! Temperature transport equation
#if tempflag == 1
 allocate(stheta(spx,nz,spy,2))
 allocate(htheta(spx,nz,spy,2))

 ! calculate non-linear terms of temperature equation
 call sterm_temp(stheta)

 if (ntime.eq.nstart+1)then
   call euler_theta(stheta,htheta)
 else
   call adams_bashforth_theta(stheta,htheta)
 endif

 stheta_o=stheta

 deallocate(stheta)

 ! assemble history term
 call hist_term_temp(htheta)

 call calculate_theta(htheta)

 deallocate(htheta)

 call chop_modes(thetac)
#endif
endif


! particle part
#if partflag == 1


!!!!!!!!!!!
#if phiflag == 1 && part_surface == 1
!executed only by rank in floww_comm
if(rank.lt.flow_comm_lim)then
call spectral_to_phys(phic,phi_f,0)

do j=1,spy
  do k=1,nz
    do i=1,spx
      gradphix_f(i,k,j,1)=-kx(i+cstart(1))*phic(i,k,j,2)
      gradphix_f(i,k,j,2)=+kx(i+cstart(1))*phic(i,k,j,1)
      gradphiy_f(i,k,j,1)=-ky(j+cstart(3))*phic(i,k,j,2)
      gradphiy_f(i,k,j,2)=+ky(j+cstart(3))*phic(i,k,j,1)
    enddo
  enddo
enddo

call spectral_to_phys(gradphix_f,fgradphix_f,0)
call spectral_to_phys(gradphiy_f,fgradphiy_f,0)

! z component
call dz(phic,gradphiz_f)
call spectral_to_phys(gradphiz_f,fgradphiz_f,0)
endif


!update sharedmemeory variable phif to the current timestep executed by all ranks both flow_comm and part_comm
call get_phi
call get_gradphi

#endif
!!!!!!!!!!!!!!!!



!update sharedmemeory variable uf to the current timestep executed buy all ranks both flow_comm and part_comm
call get_velocity

!executed only by rank in part_comm
if(rank.ge.leader)then
 call lagrangian_tracker
endif


#if twowayc == 1
call get_2WCforces
#endif
#endif


return
end subroutine solver
